/*
 *  TTSP
 *      TOPPERS Test Suite Package
 * 
 *  Copyright (C) 2009-2012 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2009-2011 by Digital Craft Inc.
 *  Copyright (C) 2009-2011 by NEC Communication Systems, Ltd.
 *  Copyright (C) 2009-2012 by FUJISOFT INCORPORATED
 *  Copyright (C) 2009-2010 by Mitsuhiro Matsuura
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: out.c 2 2012-05-09 02:23:52Z nces-shigihara $
 */
#include <kernel.h>
#include <t_syslog.h>
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "ttsp_test_lib.h"
#include "out.h"

#ifndef TTSP_FMP
extern const SIZE   _kernel_istksz;
extern STK_T *const _kernel_istk;
#else
extern const SIZE   _kernel_istksz_table[TNUM_PRCID];
extern STK_T *const _kernel_istk_table[TNUM_PRCID];
#endif

STK_T nontask_stack[TTSP_NON_TASK_STACK_SIZE];

void task1(intptr_t exinf){
	ER ercd;

	ttsp_initialize_test_lib();
	syslog_0(LOG_NOTICE,"ASP_staticAPI_DEF_ICS_d_2: Start");

	ttsp_check_point(1);
	ercd = sta_alm(ALM1,0);
	check_ercd(ercd,E_OK);

	ercd = dly_tsk(1);
	check_ercd(ercd,E_OK);

	syslog_0(LOG_NOTICE,"ASP_staticAPI_DEF_ICS_d_2: OK");

	ttsp_check_finish(3);
}
void alm1(intptr_t exinf){
	ER ercd;

	ttsp_check_point(2);

	#ifndef TTSP_FMP 
	check_assert(TTSP_NON_TASK_STACK_SIZE == _kernel_istksz);
	check_assert(&ercd > (ER*)((char_t *)_kernel_istk));							/* ѿåΰˤ뤫ǧ */
	check_assert(&ercd < (ER*)((char_t *)_kernel_istk + TTSP_NON_TASK_STACK_SIZE));	/* ѿåΰˤ뤫ǧ */
	#else
	check_assert(TTSP_NON_TASK_STACK_SIZE == _kernel_istksz_table[0]);
	check_assert(&ercd > (ER*)((char_t *)_kernel_istk_table[0]));								/* ѿåΰˤ뤫ǧ */
	check_assert(&ercd < (ER*)((char_t *)_kernel_istk_table[0] + TTSP_NON_TASK_STACK_SIZE));	/* ѿåΰˤ뤫ǧ */
	#endif
}
