/*
 *  TTSP
 *      TOPPERS Test Suite Package
 * 
 *  Copyright (C) 2010-2011 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010-2011 by Digital Craft Inc.
 *  Copyright (C) 2010-2011 by NEC Communication Systems, Ltd.
 *  Copyright (C) 2010-2011 by FUJISOFT INCORPORATED
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: out.c 2 2012-05-09 02:23:52Z nces-shigihara $
 */

#include <kernel.h>
#include <t_syslog.h>
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "ttsp_test_lib.h"
#include "out.h"

void main_task(intptr_t exinf){
	ER ercd;

	ttsp_initialize_test_lib();

	ttsp_check_point(1);


	/* CPU㳰ȯ */

	/* CPU㳰򵯤 */
	ttsp_cpuexc_raise(TTSP_EXCNO_A);
	ttsp_wait_check_point(2);

	ttsp_check_point(3);


	/* CPU㳰ȯ㳰롼 */

  	/* 㳰ľ֤ˤ */
	ercd = ena_tex();
	check_ercd(ercd, E_OK);

	/* 㳰򵯤 */
	ercd = ras_tex(TSK_SELF, 0x00000001);
	check_ercd(ercd, E_OK);

	ttsp_check_point(7);


	/* CPU㳰ȯ顼ϥɥ */

	/* 顼ϥɥ򵯤 */
	ercd = sta_alm(ALM1, 0);
	check_ercd(ercd, E_OK);

	dly_tsk(10);

	ttsp_check_point(11);


	/* CPU㳰ȯϥɥ */

	/* ϥɥ򵯤 */
	ercd = sta_cyc(CYC1);
	check_ercd(ercd, E_OK);

	dly_tsk(10);

	/* ϥɥλ */
	ercd = stp_cyc(CYC1);
	check_ercd(ercd, E_OK);

	ttsp_check_finish(15);
}

void exception_ttsp_excno_a(void* p_excinf){
	static uint_t bootcnt = 0;

	bootcnt++;

	ttsp_cpuexc_hook(TTSP_EXCNO_A, p_excinf);

	if (bootcnt == 1){
		syslog_0(LOG_NOTICE, "[TSK]ttsp_cpuexc_raise(TTSP_EXCNO_A) : OK");

		ttsp_check_point(2);
	}
	if(bootcnt == 2){
		syslog_0(LOG_NOTICE, "[TEX]ttsp_cpuexc_raise(TTSP_EXCNO_A) : OK");

		ttsp_check_point(5);
	}
	if(bootcnt == 3){
		syslog_0(LOG_NOTICE, "[ALM]ttsp_cpuexc_raise(TTSP_EXCNO_A) : OK");

		ttsp_check_point(9);
	}
	if(bootcnt == 4){
		syslog_0(LOG_NOTICE, "[CYC]ttsp_cpuexc_raise(TTSP_EXCNO_A) : OK");

		ttsp_check_point(13);
	}
}

void texhdr_tex(TEXPTN texptn, intptr_t exinf){

	ttsp_check_point(4);

	ttsp_cpuexc_raise(TTSP_EXCNO_A);
	ttsp_wait_check_point(5);

	ttsp_check_point(6);
}

void almhdr_alm(intptr_t exinf){

	ttsp_check_point(8);

	ttsp_cpuexc_raise(TTSP_EXCNO_A);
	ttsp_wait_check_point(9);

	ttsp_check_point(10);
}

void cychdr_cyc(intptr_t exinf){

	ttsp_check_point(12);

	ttsp_cpuexc_raise(TTSP_EXCNO_A);
	ttsp_wait_check_point(13);

	ttsp_check_point(14);
}
