/*
 *  TTSP
 *      TOPPERS Test Suite Package
 * 
 *  Copyright (C) 2010-2011 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010-2011 by Digital Craft Inc.
 *  Copyright (C) 2010-2011 by NEC Communication Systems, Ltd.
 *  Copyright (C) 2010-2011 by FUJISOFT INCORPORATED
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: out.c 2 2012-05-09 02:23:52Z nces-shigihara $
 */

#include <kernel.h>
#include <t_syslog.h>
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "ttsp_test_lib.h"
#include "out.h"

/* sil_dly_nseˤٱ(10ߥ) */
#define SIL_DELAY_TIME 10000000

void main_task(intptr_t exinf){
	int i;
	SYSTIM system1, system2;

	ttsp_initialize_test_lib();

	/* ֤ʤǤ뤳Ȥǧ */
	get_tim(&system1);
	sil_dly_nse(SIL_DELAY_TIME);
	get_tim(&system2);
	check_assert(system1 < system2);
	syslog_1(LOG_NOTICE, "\nsystem1 : %d", system1);
	syslog_1(LOG_NOTICE, "system2 : %d", system2);
	syslog_0(LOG_NOTICE, "timer_interrupt : OK");

	/* ֤ߤޤ뤳Ȥǧ */
	ttsp_target_stop_tick();
	get_tim(&system1);
	sil_dly_nse(SIL_DELAY_TIME);
	get_tim(&system2);
	check_assert(system1 == system2);
	syslog_1(LOG_NOTICE, "system1 : %d", system1);
	syslog_1(LOG_NOTICE, "system2 : %d", system2);
	syslog_0(LOG_NOTICE, "ttsp_target_stop_tick() : OK");

	/* ֤1ƥåĿʤ뤳Ȥǧ */
	for(i = 0; i < 10; i++){
		get_tim(&system1);
		ttsp_target_gain_tick();
		sil_dly_nse(SIL_DELAY_TIME);
		get_tim(&system2);
		check_assert((system1 + 1) == system2);
	}
	syslog_1(LOG_NOTICE, "system1 : %d", system1);
	syslog_1(LOG_NOTICE, "system2 : %d", system2);
	syslog_0(LOG_NOTICE, "ttsp_target_gain_tick() : OK");

	/* ֤ưФȤǧ */
	ttsp_target_start_tick();
	get_tim(&system1);
	sil_dly_nse(SIL_DELAY_TIME);
	get_tim(&system2);
	check_assert(system1 < system2);
	syslog_1(LOG_NOTICE, "system1 : %d", system1);
	syslog_1(LOG_NOTICE, "system2 : %d", system2);
	syslog_0(LOG_NOTICE, "ttsp_target_start_tick() : OK");

	ttsp_check_finish(1);
}
