/*
 *  TTSP
 *      TOPPERS Test Suite Package
 *
 *  Copyright (C) 2010-2012 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010-2011 by Digital Craft Inc.
 *  Copyright (C) 2010-2011 by NEC Communication Systems, Ltd.
 *  Copyright (C) 2010-2012 by FUJISOFT INCORPORATED
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: ttsp_chip_timer.c 2 2012-05-09 02:23:52Z nces-shigihara $
 */

/*
 *  ޥɥ饤СARM PrimeCell Timer Moduleѡ
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "chip_timer.h"
#include "ttsp_chip_timer.h"
#include "ttsp_target_test.h"

/*
 *  ttsp_chip_timer.c󥯳ǧѥХѿ
 */
uint_t include_ttsp_chip_timer_to_KERNEL_COBJS = 0;

/*
 *  ƥѤδؿ
 */

/*
 *  ƥåѥޥǥ֥ѿ
 */
static volatile bool_t target_timer_disable[TNUM_PRCID];

/*
 *  ƥåѥޥ󥷥åȼ¹
 */
static volatile bool_t target_timer_oneshot[TNUM_PRCID];

/*
 *  ޥϥɥ鳫ϻ˸ƤӽФեå
 *  (falsesignal_time()ƤӽФʤ)
 */
static bool_t
ttsp_timer_handler_begin_hook(void)
{
        return !target_timer_disable[x_prc_index()];
}

/*
 *  ޥϥɥ齪λ˸ƤӽФեå
 */
static void
ttsp_timer_handler_end_hook(void)
{
        uint_t prc_index = x_prc_index();
        if (target_timer_oneshot[prc_index]) {
                target_timer_disable[prc_index] = true;
                target_timer_oneshot[prc_index] = false;
        }
}

/*
 *  ޳׵Υꥢ
 */
Inline void
target_timer_int_clear(void)
{
        /* ڥǥ󥰥ӥåȤ򥯥ꥢ */
        sil_wrw_mem((void *)MPCORE_TM_ISR, MPCORE_TM_ISR_SCBIT);
}

/*
 *  ޤεư
 */
void
target_timer_initialize(intptr_t exinf)
{
        CLOCK    cyc = TO_CLOCK(TIC_NUME, TIC_DENO);

        /*  */
        sil_wrw_mem((void *)MPCORE_TM_CNT, 0x00);

        /* ڥǥ󥰥ӥåȥꥢ */
        target_timer_int_clear();

        /* ͤ */
        sil_wrw_mem((void *)MPCORE_TM_LR, cyc - 1);

        /*
         * ޡ(ߵ)
         * 1MHzǥȤ褦˥ץꥹ顼
         */
        sil_wrw_mem((void *)MPCORE_TM_CNT,
                    (MPCORE_TM_PS_1MS << MPCORE_TM_CNT_PS_OFFSET)
                    | MPCORE_TM_CNT_IEN | MPCORE_TM_CNT_AR | MPCORE_TM_CNT_EN);
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(intptr_t exinf)
{
        /* ߥꥢ */
        target_timer_int_clear();

        /*  */
        sil_wrw_mem((void *)MPCORE_TM_CNT, 0x00);
}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(void)
{
        ID prcid;

        /* ߥꥢ */
        target_timer_int_clear();

        iget_pid(&prcid);
        i_begin_int((0x10000 << (prcid - 1))|DIC_IRQNO_TM);
        if (ttsp_timer_handler_begin_hook()) {
                signal_time();                    /* ƥåζ */
                ttsp_timer_handler_end_hook();
        }
        i_end_int((0x10000 << (prcid - 1))|DIC_IRQNO_TM);
}

/*
 *  ޥϥɥƤӽФλǧؿ
 */
void
ttsp_check_timer_handler(void)
{
        int_t           i;
        ID              pid;
        ulong_t         timeout;

        sil_get_pid(&pid);

        /* Υޥϥɥ餬λƤ뤫å */
        for(i = 0; i < TNUM_PRCID; i++) {
                timeout = 0;
                while (target_timer_disable[i] == false) {
                        timeout++;
                        if (timeout > TTSP_LOOP_COUNT) {
                                syslog_2(LOG_ERROR, "## PE %d : ttsp_check_timer_handler[PE:%d][check] caused a timeout.", pid, i + 1);
                                ext_ker();
                        }
                        sil_dly_nse(TTSP_SIL_DLY_NSE_TIME);
                };
        }
}

/*
 *  ƥå(ץå)
 */
void
ttsp_target_stop_tick(void)
{
        uint_t i;

        for(i = 1; i <= TNUM_PRCID; i++) {
                ttsp_target_stop_tick_pe(i);
        }
}

/*
 *  ƥå(ץå)
 */
void
ttsp_target_stop_tick_pe(ID prcid)
{
        uint_t prc_index = prcid - 1;
        target_timer_disable[prc_index] = true;
}

/*
 *  ƥåκƳץå
 */
void
ttsp_target_start_tick(void)
{
        uint_t i;

        for(i = 1; i <= TNUM_PRCID; i++) {
                ttsp_target_start_tick_pe(i);
        }
}

/*
 *  ƥåκƳץå
 */
void
ttsp_target_start_tick_pe(ID prcid)
{
        uint_t prc_index = prcid - 1;
        target_timer_disable[prc_index] = false;
}

/*
 *  ƥåιץå
 */
void
ttsp_target_gain_tick_pe(ID prcid, bool_t wait_flg)
{
        int             prc_index = prcid - 1;
        ID              pid;
        ulong_t         timeout;

        sil_get_pid(&pid);

        /*
         *  ιäƤ뤳Ȥǧ
         *  PEФƤϥåɬפϤʤåƤʤᡤ
         *  å롥
         */
        timeout = 0;
        while (target_timer_oneshot[prc_index] == true) {
                timeout++;
                if (timeout > TTSP_LOOP_COUNT) {
                        syslog_2(LOG_ERROR, "## PE %d : ttsp_target_gain_tick_pe(%d)[check] caused a timeout.", pid, prcid);
                        ext_ker();
                }
                sil_dly_nse(TTSP_SIL_DLY_NSE_TIME);
        };

        target_timer_oneshot[prc_index] = true;
        target_timer_disable[prc_index] = false;

        /* PE⤷ϥե饰trueξϡϥɥ餬λޤԤ碌 */
        if ((pid == prcid) || (wait_flg == true)) {
                timeout = 0;
                while (target_timer_oneshot[prc_index] == true) {
                        timeout++;
                        if (timeout > TTSP_LOOP_COUNT) {
                                syslog_2(LOG_ERROR, "## PE %d : ttsp_target_gain_tick_pe(%d)[wait] caused a timeout.", pid, prcid);
                                ext_ker();
                        }
                        sil_dly_nse(TTSP_SIL_DLY_NSE_TIME);
                };
        }
}

/*
 *  ƥåιץå
 */
void
ttsp_target_gain_tick(void)
{
        int_t           i;
        ID              pid;
        ulong_t         timeout;
        int             prc_index;

        /* PEΥƥåλȤǧ */
        ttsp_check_timer_handler();

        /* ᥤץåID */
        sil_get_pid(&pid);
        prc_index = pid - 1;

        /*
         *  ιäƤ뤳Ȥǧ
         *  PEФƤϥåɬפϤʤåƤʤᡤ
         *  å롥
         */
        for(i = 0; i < TNUM_PRCID; i++) {
                if (i != prc_index) {
                        timeout = 0;
                        while (target_timer_oneshot[i] == true) {
                                timeout++;
                                if (timeout > TTSP_LOOP_COUNT) {
                                        syslog_2(LOG_ERROR, "## PE %d : ttsp_target_gain_tick[PE:%d][check] caused a timeout.", pid, i + 1);
                                        ext_ker();
                                }
                                sil_dly_nse(TTSP_SIL_DLY_NSE_TIME);
                        };
                }
        }

        for(i = 0; i < TNUM_PRCID; i++) {
                if (i != prc_index) {
                        target_timer_oneshot[i] = true;
                }
        }

        for(i = 0; i < TNUM_PRCID; i++) {
                if (i != prc_index) {
                        target_timer_disable[i] = false;
                }
        }

        /* PEФơϥɥ餬λޤԤ碌 */
        for(i = 0; i < TNUM_PRCID; i++) {
                if (i != prc_index) {
                        timeout = 0;
                        while (target_timer_oneshot[i] == true) {
                                timeout++;
                                if (timeout > TTSP_LOOP_COUNT) {
                                        syslog_2(LOG_ERROR, "## PE %d : ttsp_target_gain_tick[PE:%d][wait] caused a timeout.", pid, i + 1);
                                        ext_ker();
                                }
                                sil_dly_nse(TTSP_SIL_DLY_NSE_TIME);
                        };
                }
        }

        /* Ǹ˥ᥤץåλʤ */
        timeout = 0;
        while (target_timer_oneshot[prc_index] == true) {
                timeout++;
                if (timeout > TTSP_LOOP_COUNT) {
                        syslog_2(LOG_ERROR, "## PE %d : ttsp_target_gain_tick[PE:%d][check] caused a timeout.", pid, pid);
                        ext_ker();
                }
                sil_dly_nse(TTSP_SIL_DLY_NSE_TIME);
        };
        target_timer_oneshot[prc_index] = true;
        target_timer_disable[prc_index] = false;
        timeout = 0;
        while (target_timer_oneshot[prc_index] == true) {
                timeout++;
                if (timeout > TTSP_LOOP_COUNT) {
                        syslog_2(LOG_ERROR, "## PE %d : ttsp_target_gain_tick[PE:%d][wait] caused a timeout.", pid, pid);
                        ext_ker();
                }
                sil_dly_nse(TTSP_SIL_DLY_NSE_TIME);
        };
}

