/*
 *  TTSP
 *      TOPPERS Test Suite Package
 * 
 *  Copyright (C) 2010-2011 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010-2011 by Digital Craft Inc.
 *  Copyright (C) 2010-2011 by NEC Communication Systems, Ltd.
 *  Copyright (C) 2010-2011 by FUJISOFT INCORPORATED
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: out.c 2 2012-05-09 02:23:52Z nces-shigihara $
 */

#include <kernel.h>
#include <t_syslog.h>
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "ttsp_test_lib.h"
#include "out.h"

typedef struct{
	EXCNO excno;
	ID almid;
	ID cycid;
}PRC_INFO;

PRC_INFO prc_info[] = {
#ifdef TOPPERS_SYSTIM_LOCAL
	{TTSP_EXCNO_A,     ALM1, CYC1},
#if TNUM_PRCID >= 2
	{TTSP_EXCNO_PE2_A, ALM2, CYC2},
#endif /* TNUM_PRCID >= 2 */
#if TNUM_PRCID >= 3
	{TTSP_EXCNO_PE3_A, ALM3, CYC3},
#endif /* TNUM_PRCID >= 3 */
#if TNUM_PRCID >= 4
	{TTSP_EXCNO_PE4_A, ALM4, CYC4}
#endif /* TNUM_PRCID >= 4 */
#else /* TOPPERS_SYSTIM_GLOBAL */
	{TTSP_EXCNO_A,     ALM1, CYC1},
#if TNUM_PRCID >= 2
	{TTSP_EXCNO_PE2_A, ALM1, CYC1},
#endif /* TNUM_PRCID >= 2 */
#if TNUM_PRCID >= 3
	{TTSP_EXCNO_PE3_A, ALM1, CYC1},
#endif /* TNUM_PRCID >= 3 */
#if TNUM_PRCID >= 4
	{TTSP_EXCNO_PE4_A, ALM1, CYC1}
#endif /* TNUM_PRCID >= 4 */
#endif /* TOPPERS_SYSTIM_LOCAL */
};

void main_task(intptr_t exinf){
	uint_t i;
	ER ercd;
	EXCNO excno = prc_info[(int)exinf].excno;
	ID almid = prc_info[(int)exinf].almid;
	ID cycid = prc_info[(int)exinf].cycid;
	ID prcid;
	get_pid(&prcid);
	i = 0;

	ttsp_mp_check_point(prcid, 1);

	/* CPU㳰ȯ */

	/* CPU㳰򵯤 */
	ttsp_cpuexc_raise(excno);
	ttsp_mp_wait_check_point(prcid, 2);

	ttsp_mp_check_point(prcid, 3);

	/* CPU㳰ȯ㳰롼 */

  	/* 㳰ľ֤ˤ */
	ercd = ena_tex();
	check_ercd(ercd, E_OK);
  
	/* 㳰򵯤 */
	ercd = ras_tex(TSK_SELF, 0x00000001);
	check_ercd(ercd, E_OK);
  
	ttsp_mp_check_point(prcid, 7);


#ifdef TOPPERS_SYSTIM_GLOBAL
	if (TOPPERS_SYSTIM_PRCID == prcid) {
#endif /* TOPPERS_SYSTIM_GLOBAL */

	/* CPU㳰ȯ顼ϥɥ */

	/* 顼ϥɥ򵯤 */
	ercd = sta_alm(almid, 0);
	check_ercd(ercd, E_OK);

	ttsp_mp_wait_check_point(prcid, 8);

	ttsp_mp_check_point(prcid, 11);


	/* CPU㳰ȯϥɥ */

	/* ϥɥ򵯤 */
	ercd = sta_cyc(cycid);
	check_ercd(ercd, E_OK);

	ttsp_mp_wait_check_point(prcid, 12);

	/* ϥɥλ */
	ercd = stp_cyc(cycid);
	check_ercd(ercd, E_OK);

#ifdef TOPPERS_SYSTIM_GLOBAL
	}
	if ((TOPPERS_MASTER_PRCID != TOPPERS_SYSTIM_PRCID) && (TOPPERS_MASTER_PRCID == prcid)) {
		for (i = 8; i <= 14; i++) {
			ttsp_mp_check_point(prcid, i);
		}
	}
#endif /* TOPPERS_SYSTIM_GLOBAL */

	ttsp_barrier_sync(1, TNUM_PRCID);

	if (TOPPERS_MASTER_PRCID == prcid) {
		ttsp_mp_check_finish(prcid, 15);
	}
}

void exc(void* p_excinf){
	static uint_t bootcnt[4] = {0};
	EXCNO excno;
	ID prcid;
	iget_pid(&prcid);

	bootcnt[prcid - 1]++;
	excno = prc_info[prcid - 1].excno;

	ttsp_cpuexc_hook(excno, p_excinf);

	if (bootcnt[prcid - 1] == 1) {
		syslog_2(LOG_NOTICE, "[TSK%d]ttsp_cpuexc_raise(0x%x) : OK", prcid, excno);
		ttsp_mp_check_point(prcid, 2);
	}
	if (bootcnt[prcid - 1] == 2) {
		syslog_2(LOG_NOTICE, "[TEX%d]ttsp_cpuexc_raise(0x%x) : OK", prcid, excno);
		ttsp_mp_check_point(prcid, 5);
	}
	if (bootcnt[prcid - 1] == 3) {
		syslog_2(LOG_NOTICE, "[ALM%d]ttsp_cpuexc_raise(0x%x) : OK", prcid, excno);
		ttsp_mp_check_point(prcid, 9);
	}
	if (bootcnt[prcid - 1] == 4) {
		syslog_2(LOG_NOTICE, "[CYC%d]ttsp_cpuexc_raise(0x%x) : OK", prcid, excno);
		ttsp_mp_check_point(prcid, 13);
	}
}

void tex(TEXPTN texptn, intptr_t exinf){
	EXCNO excno = prc_info[(int)exinf].excno;
	ID prcid;
	get_pid(&prcid);

	ttsp_mp_check_point(prcid, 4);

	ttsp_cpuexc_raise(excno);
	ttsp_mp_wait_check_point(prcid, 5);

	ttsp_mp_check_point(prcid, 6);
}

void alm(intptr_t exinf){
	EXCNO excno = prc_info[(int)exinf].excno;
	ID prcid;
	iget_pid(&prcid);

	ttsp_mp_check_point(prcid, 8);

	ttsp_cpuexc_raise(excno);
	ttsp_mp_wait_check_point(prcid, 9);

	ttsp_mp_check_point(prcid, 10);
}

void cyc(intptr_t exinf){
	EXCNO excno = prc_info[(int)exinf].excno;
	ID prcid;
	iget_pid(&prcid);

	ttsp_mp_check_point(prcid, 12);

	ttsp_cpuexc_raise(excno);
	ttsp_mp_wait_check_point(prcid, 13);

	ttsp_mp_check_point(prcid, 14);
}

void ttsp_test_lib_init(intptr_t exinf){
	ttsp_initialize_test_lib();
}
