/*
 *  TTSP
 *      TOPPERS Test Suite Package
 * 
 *  Copyright (C) 2010-2011 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010-2011 by Digital Craft Inc.
 *  Copyright (C) 2010-2011 by NEC Communication Systems, Ltd.
 *  Copyright (C) 2010-2011 by FUJISOFT INCORPORATED
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: ttsp_test_lib.h 2 2012-05-09 02:23:52Z nces-shigihara $
 */

/* 
 *		ƥȥץѥ饤֥
 */

#ifndef TTSP_TEST_LIB_H
#define TTSP_TEST_LIB_H

#include <t_stddef.h>
#include <queue.h>

#include <kernel/kernel_impl.h>
#include <kernel/check.h>
#include <kernel/task.h>
#include <kernel/wait.h>
#include <kernel/semaphore.h>
#include <kernel/eventflag.h>
#include <kernel/dataqueue.h>
#include <kernel/pridataq.h>
#include <kernel/spin_lock.h>
#include <kernel/mailbox.h>
#include <kernel/mempfix.h>
#include <kernel/time_event.h>
#include <kernel/alarm.h>
#include <kernel/cyclic.h>
#include <kernel/mp.h>
#include <target_ipi.h>

#define TTSP_FMP   /* FMPΤߥݡȤ뤿 */

#define TTS_RUS		UINT_C(0x20)	/* Ԥ֡μ¹Է³ */

/*
 *	ʿǴؿη
 */
typedef ER (*BIT_FUNC)(void);

/*
 *	ʿǴؿ
 */
extern void	set_bit_func(BIT_FUNC bit_func);

/*
 *  ƥȥ饤֥ѿ
 */
extern void	ttsp_initialize_test_lib(void);

/*
*	åݥ(ASPAPIƥήѤΤ߻)
 */
extern void	ttsp_check_point(uint_t count);

/*
 *	λåݥ(ASPAPIƥήѤΤ߻)
 */
extern void	ttsp_check_finish(uint_t count);

/*
 *	åݥ̲ξּ
 */
extern bool_t	ttsp_get_cp_state(void);

/*
 *	åݥ̲ξ
 */
extern void	ttsp_set_cp_state(bool_t state);

/*
 *	å
 */
extern void	_check_assert(const char *expr, const char *file, int_t line);
#define check_assert(exp) \
	((void)(!(exp) ? (_check_assert(#exp, __FILE__, __LINE__), 0) : 0))

/*
 *	顼ɥå
 */
extern void	_check_ercd(ER ercd, const char *file, int_t line);
#define check_ercd(ercd, expected_ercd) \
	((void)((ercd) != (expected_ercd) ? \
					(_check_ercd(ercd, __FILE__, __LINE__), 0) : 0))


/*
 *  ƥȤ˱CPUå
 */
Inline bool_t
ttsp_loc_cpu(void)
{
	bool_t	locked = false;

	if (!sense_context()) {
		if (!t_sense_lock()) {
			t_lock_cpu();
			locked = true;
		}
	}
	else {
		if (!i_sense_lock()) {
			i_lock_cpu();
			locked = true;
		}
	}

	return locked;
}

/*
 *  ƥȤ˱CPUå
 */
Inline void
ttsp_unl_cpu(bool_t locked)
{
	if (locked) {
		if (!sense_context()) {
			t_unlock_cpu();
		}
		else {
			i_unlock_cpu();
		}
	}
}


/*
 *  ХꥢƱ
 */
extern void ttsp_barrier_sync(uint_t phase, uint_t tnum_prcid);

/*
 *  IDΥåݥ
 *  IDκͤϥץåIDƱ
 */

/*  
 *  idֹΥåݥȤʤ롥 
 */
extern void ttsp_mp_check_point(ID id, uint_t count);

/*
 *  idֹΥåݥȤcountˤʤΤԤġ 
 */
extern void ttsp_mp_wait_check_point(ID id, uint_t count);

/*
 *  idֹΥåݥȤʤơͥλ롥
 */ 
extern void ttsp_mp_check_finish(ID id, uint_t count);

/*
 *  оݥξ֤ꤷ֤ѲΤԤġ
 */ 
extern void ttsp_state_sync(char* proc_id, char* target_id, ID target_tskid, char* target_state_id, STAT target_state);

/*
 *  ¹Ծ֤Τޤ¾ter_tskˤ꽪λΤԤġ
 */ 
extern void ttsp_wait_finish_sync(char* proc_id);



/*
 *  åλܹԻ˳ߤĤʤåؿ
 *  (شؿCPUå֤ǤȯԲǽȤ뤿)
 */
#if TTYPE_KLOCK == G_KLOCK

Inline PCB*
ttsp_acquire_tsk_lock_without_preemption(TCB *p_tcb)
{
	x_acquire_lock_without_preemption(&giant_lock);
	return(p_tcb->p_pcb);
}

Inline PCB*
ttsp_acquire_tsk_lock_without_preemption_cyc(CYCCB *p_cyccb)
{
	x_acquire_lock_without_preemption(&giant_lock);
	return(p_cyccb->p_pcb);
}

Inline PCB*
ttsp_acquire_tsk_lock_without_preemption_alm(ALMCB *p_almcb)
{
	x_acquire_lock_without_preemption(&giant_lock);
	return(p_almcb->p_pcb);
}

Inline void
ttsp_acquire_obj_lock_without_preemption(LOCK *p_objlock)
{
	x_acquire_lock_without_preemption(&giant_lock);
}

#else /* P_KLOCK or F_KLOCK */

Inline PCB*
ttsp_acquire_tsk_lock_without_preemption(TCB *p_tcb)
{
	PCB *p_pcb;

	while(true) {
		p_pcb = p_tcb->p_pcb;
		x_acquire_lock_without_preemption(&(p_pcb->tsk_lock));
		if (p_pcb != p_tcb->p_pcb) {
			/* оݥޥ졼Ȥ */
			x_release_lock(&(p_pcb->tsk_lock));
		} else {
			break;
		}
	}

	return(p_tcb->p_pcb);
}

Inline PCB*
ttsp_acquire_tsk_lock_without_preemption_cyc(CYCCB *p_cyccb)
{
	PCB *p_pcb;

	while(true) {
		p_pcb = p_cyccb->p_pcb;
		x_acquire_lock_without_preemption(&(p_pcb->tsk_lock));
		if (p_pcb != p_cyccb->p_pcb) {
			/* оݥޥ졼Ȥ */
			x_release_lock(&(p_pcb->tsk_lock));
		} else {
			break;
		}
	}

	return(p_cyccb->p_pcb);
}

Inline PCB*
ttsp_acquire_tsk_lock_without_preemption_alm(ALMCB *p_almcb)
{
	PCB *p_pcb;

	while(true) {
		p_pcb = p_almcb->p_pcb;
		x_acquire_lock_without_preemption(&(p_pcb->tsk_lock));
		if (p_pcb != p_almcb->p_pcb) {
			/* оݥޥ졼Ȥ */
			x_release_lock(&(p_pcb->tsk_lock));
		} else {
			break;
		}
	}

	return(p_almcb->p_pcb);
}

Inline void
ttsp_acquire_obj_lock_without_preemption(LOCK *p_objlock)
{
	x_acquire_lock_without_preemption(p_objlock);
}

#endif /* TTYPE_KLOCK == G_KLOCK */


/*
 *  ref_tskشؿ
 */
typedef struct t_ttsp_rtsk {
	STAT		tskstat;		/*  */
	PRI			tskpri;			/* θͥ */
	PRI			tskbpri;		/* Υ١ͥ */
	STAT		tskwait;		/* Ԥװ */
	ID			wobjid;			/* ԤоݤΥ֥ȤID */
	TMO			lefttmo;		/* ॢȤޤǤλ */
	uint_t		actcnt;			/* ư׵ᥭ塼󥰿 */
	uint_t		wupcnt;			/* ׵ᥭ塼󥰿 */
	ATR			tskatr;			/* ° */
	intptr_t	exinf;			/* γĥ */
	PRI			itskpri;		/* εưͥ */
	SIZE		stksz;			/* åΰΥ */
	void		*stk;			/* åΰƬ */
	uint_t		porder;			/* դץåƱͥ٥Ǥͥ */
	ID			prcid;			/* դץåID */
	ID			actprc;			/* εưγդץåID */
	ID			iaffinity;		/* νդץå */
	uint_t		affinity_mask;	/* γդǽץå */
} T_TTSP_RTSK;

extern ER ttsp_ref_tsk(ID tskid, T_TTSP_RTSK *pk_rtsk);



/*
 *  ref_texشؿ
 */
typedef struct t_ttsp_rtex {
	STAT	texstat;	/* 㳰ξ */
	TEXPTN	pndptn;		/* α㳰װ */
	ATR		texatr;		/* 㳰롼° */
} T_TTSP_RTEX;

extern ER ttsp_ref_tex(ID tskid, T_TTSP_RTEX *pk_rtex);



/*
 *  ref_semشؿ
 */
typedef struct t_ttsp_rsem {
	uint_t	semcnt;		/* ޥեλ񸻿 */
	ATR		sematr;		/* ޥե° */
	uint_t	isemcnt;	/* ޥեν񸻿 */
	uint_t	maxsem;		/* ޥեκ񸻿 */
	uint_t	waitcnt;	/* Ԥο */
} T_TTSP_RSEM;

extern ER ttsp_ref_sem(ID semid, T_TTSP_RSEM *pk_rsem);


/*
 *  ޥեԤȴؿ
 */
extern ER ttsp_ref_wait_sem(ID semid, uint_t order, ID *p_tskid);



/*
 *  ref_flgشؿ
 */
typedef struct t_ttsp_rflg {
	FLGPTN	flgptn;		/* ٥ȥե饰θߤΥӥåȥѥ */
	ATR		flgatr;		/* ٥ȥե饰° */
	FLGPTN	iflgptn;	/* ٥ȥե饰Υӥåȥѥν */
	uint_t	waitcnt;	/* Ԥο */
} T_TTSP_RFLG;

extern ER ttsp_ref_flg(ID flgid, T_TTSP_RFLG *pk_rflg);


/*
 *  ٥ȥե饰Ԥȴؿ
 */
extern ER ttsp_ref_wait_flg(ID flgid, uint_t order, ID *p_tskid, FLGPTN *p_waiptn, MODE *p_wfmode);


/*
 *  ref_dtqشؿ
 */
typedef struct t_ttsp_rdtq {
	uint_t	sdtqcnt;	/* ǡ塼ΰ˳ǼƤǡο */
	ATR		dtqatr;		/* ǡ塼° */
	uint_t	dtqcnt;		/* ǡ塼 */
	uint_t	swaitcnt;	/* Ԥο */
	uint_t	rwaitcnt;	/* Ԥο */
} T_TTSP_RDTQ;

extern ER ttsp_ref_dtq(ID dtqid, T_TTSP_RDTQ *pk_rdtq);


/*
 *  ǡ塼ΰ˳ǼƤǡȴؿ
 */
extern ER ttsp_ref_data(ID dtqid, uint_t index, intptr_t *p_data);


/*
 *  ǡ塼Ԥȴؿ
 */
extern ER ttsp_ref_swait_dtq(ID dtqid, uint_t order, ID *p_tskid, intptr_t *p_data);


/*
 *  ǡ塼μԤȴؿ
 */
extern ER ttsp_ref_rwait_dtq(ID dtqid, uint_t order, ID *p_tskid);



/*
 *  ref_pdqشؿ
 */
typedef struct t_ttsp_rpdq {
	uint_t	spdqcnt;		/* ͥ٥ǡ塼ΰ˳ǼƤǡο */
	ATR		pdqatr;			/* ͥ٥ǡ塼° */
	uint_t	pdqcnt;			/* ͥ٥ǡ塼 */
	PRI		maxdpri;		/* ǡͥ٤κ */
	uint_t	swaitcnt;		/* Ԥο */
	uint_t	rwaitcnt;		/* Ԥο */
} T_TTSP_RPDQ;

extern ER ttsp_ref_pdq(ID pdqid, T_TTSP_RPDQ *pk_rpdq);


/*
 *  ͥ٥ǡ塼ΰ˳ǼƤǡȴؿ
 */
extern ER ttsp_ref_pridata(ID pdqid, uint_t index, intptr_t *p_data, PRI *p_datapri);


/*
 *  ͥ٥ǡ塼Ԥȴؿ
 */
extern ER ttsp_ref_swait_pdq(ID pdqid, uint_t order, ID *p_tskid, intptr_t *p_data, PRI *p_datapri);


/*
 *  ͥ٥ǡ塼μԤȴؿ
 */
extern ER ttsp_ref_rwait_pdq(ID pdqid, uint_t order, ID *p_tskid);



/*
 *  ref_spnشؿ
 */
typedef struct t_ttsp_rspn {
	STAT	spnstat;	/* ԥåΥå */
	ATR		spnatr;		/* ԥå° */
} T_TTSP_RSPN;

extern ER ttsp_ref_spn(ID spnid, T_TTSP_RSPN *pk_rspn);



/*
 *  ref_mbxشؿ
 */
typedef struct t_ttsp_rmbx {
	uint_t	msgcnt;		/* ᡼ܥåˤĤʤƤåο */
	ATR		mbxatr;		/* ᡼ܥå° */
	PRI		maxmpri;	/* åͥ٤κ */
	uint_t	rwaitcnt;	/* Ԥο */
} T_TTSP_RMBX;

extern ER ttsp_ref_mbx(ID mbxid, T_TTSP_RMBX *pk_rmbx);


/*
 *  ᡼ܥåˤĤʤƤǡȴؿ
 */
extern ER ttsp_ref_msg(ID mbxid, uint_t index, T_MSG **pp_msg);


/*
 *  ᡼ܥåμԤȴؿ
 */
extern ER ttsp_ref_rwait_mbx(ID mbxid, uint_t order, ID *p_tskid);



/*
 *  ref_mpfشؿ
 */
typedef struct t_ttsp_rmpf {
	uint_t	fblkcnt;	/* Ĺסΰζΰ˳դ뤳ȤǤĹ֥åο */
	ATR		mpfatr;		/* Ĺס° */
	uint_t	blkcnt;		/* ֥å */
	uint_t	blksz;		/* ֥åΥ */
	uint_t	waitcnt;	/* Ԥο */
	void	*mpf;		/* ĹסΰƬ */
} T_TTSP_RMPF;

extern ER ttsp_ref_mpf(ID mpfid, T_TTSP_RMPF *pk_rmpf);


/*
 *  ĹסԤȴؿ
 */
extern ER ttsp_ref_wait_mpf(ID mpfid, uint_t order, ID *p_tskid);



/*
 *  ref_cycشؿ
 */
typedef struct t_ttsp_rcyc {
	STAT		cycstat;		/* ϥɥư */
	RELTIM		lefttim;		/* ˼ϥɥưޤǤл */
	ATR			cycatr;			/* ϥɥ° */
	intptr_t	exinf;			/* ϥɥγĥ */
	RELTIM		cyctim;			/* ϥɥεư */
	RELTIM		cycphs;			/* ϥɥεư */
	ID			prcid;			/* դץåID */
#ifdef TOPPERS_SYSTIM_LOCAL
	ID			iaffinity;		/* ϥɥνդץå */
	uint_t		affinity_mask;	/* ϥɥγդǽץå */
#endif /* TOPPERS_SYSTIM_LOCAL */
} T_TTSP_RCYC;

extern ER ttsp_ref_cyc(ID cycid, T_TTSP_RCYC *pk_rcyc);



/*
 *  ref_almشؿ
 */
typedef struct t_ttsp_ralm {
	STAT		almstat;		/* 顼ϥɥư */
	RELTIM		lefttim;		/* 顼ϥɥưޤǤл */
	ATR			almatr;			/* 顼ϥɥ° */
	intptr_t	exinf;			/* 顼ϥɥγĥ */
	ID			prcid;			/* դץåID */
#ifdef TOPPERS_SYSTIM_LOCAL
	ID			iaffinity;		/* 顼ϥɥνդץå */
	uint_t		affinity_mask;	/* 顼ϥɥγդǽץå */
#endif /* TOPPERS_SYSTIM_LOCAL */
} T_TTSP_RALM;

extern ER ttsp_ref_alm(ID almid, T_TTSP_RALM *pk_ralm);

/*
 *  get_ipmشؿ
 */
extern ER ttsp_get_ipm(PRI *p_intpri);

/*
 *  sus_tskشؿ
 */
extern ER ttsp_sus_tsk(ID tskid);

#endif /* TTSP_TEST_LIB_H */
