#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2012 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: CBuilder.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "bin/builder/CodeBuilder.rb"
require "bin/product/CCode.rb"

module TTG
  #===================================================================
  # 饹̾: CBuilder
  #     : ֥ɤCɤ֤
  #===================================================================
  class CBuilder < CodeBuilder
    include CommonModule

    #=================================================================
    #   : ֥ɤc/h/cfgե
    #=================================================================
    def build(cImCode)
      check_class(IntermediateCode, cImCode) # ֥ɤΥ󥹥

      @aGlobalVar    = cImCode.aGlobalVar.dup()
      @aCode         = cImCode.aCode.dup()
      @hProcUnitInfo = cImCode.hProcUnitInfo.dup()
      @nStack        = cImCode.nStack
      @aHeader       = cImCode.aHeader.dup()
      @hConfig       = cImCode.hConfig.dup()
      @cConf         = Config.new() # ե
      @sFileName     = @cConf.get_out_file()

      @hEnumData     = Hash.new()  # enumѥϥå

      sCCode      = make_c()
      sHeaderCode = make_header()
      sCfgCode    = make_cfg()

      @@cCode = CCode.new(sCCode, sHeaderCode, sCfgCode)
    end

    #=================================================================
    #   : cfgեʸ֤
    #=================================================================
    def make_cfg()
      # ϥɤ׻ʸ
      sCfgCode = <<-EOS
#{VERSION}
INCLUDE("target_timer.cfg");
INCLUDE("syssvc/syslog.cfg");
INCLUDE("syssvc/serial.cfg");
#include "#{@sFileName}.h"

      EOS

      if (@cConf.is_asp?())
        @hConfig.each{|sClassID, aClassData|
          # ŪAPIε
          aClassData.each{|sCode|
            sCfgCode.concat("#{sCode}#{TTG_NL}")
          }
        }
      else
        sCfgCode.concat("INCLUDE(\"target_ipi.cfg\");#{TTG_NL}#{TTG_NL}")
        @hConfig.sort.each{|sClassID, aClassData|
          # ɤΥ饹ˤ°ʤñ̤ϡ
          if (sClassID == IMC_NO_CLASS)
            next
          end

          # 饹
          sCfgCode.concat("CLASS(#{sClassID}){#{TTG_NL}")

          # ŪAPIε
          aClassData.each{|sCode|
            sCfgCode.concat("#{TTG_TB}#{sCode}#{TTG_NL}")
          }

          # 饹
          sCfgCode.concat("}#{TTG_NL}")
        }
      end

      # FMPξǡɤΥ饹ˤ°ʤñ
      if (@cConf.is_fmp?())
        @hConfig.each{|sClassID, aClassData|
          if (sClassID == IMC_NO_CLASS)
            aClassData.each{|sCode|
              sCfgCode.concat("#{sCode}#{TTG_NL}")
            }
          end
        }
      end

      return sCfgCode  # [String]cfgեʸ
    end

    #=================================================================
    #   : hեʸ֤
    #=================================================================
    def make_header()
      # ϥɤ׻ʸ
      sHeaderCode = <<-EOS
#{VERSION}
#include "ttsp_target_test.h"

      EOS

      # ͭå
      if (@cConf.is_stack_share_mode?())
        sHeaderCode.concat("#{TTG_NL}#define TTSP_STACK_SHARE#{TTG_NL}")
        nNum = 1
        while nNum <= @nStack
          sHeaderCode.concat("extern STK_T ttg_stack_#{nNum}[COUNT_STK_T(TTSP_TASK_STACK_SIZE)];#{TTG_NL}")
          nNum += 1
        end
      end

      # enum
      if (!@hEnumData.empty?())
        @hEnumData.each{|sEnumID, aTestID|
          sHeaderCode.concat("enum #{sEnumID}{")
          # Ƭ̵ͤ
          sHeaderCode.concat("#{TTG_NL}#{TTG_TB}#{sEnumID.sub("ENUM_", "")}_#{TTG_ENUM_INVALID},")
          aTestID.each{|sTestID|
            sHeaderCode.concat("#{TTG_NL}#{TTG_TB}#{sTestID},")
          }
          sHeaderCode.chop!()
          sHeaderCode.concat("#{TTG_NL}};#{TTG_NL}")
        }
        sHeaderCode.concat("#{TTG_NL}")
      end

      @aHeader.sort.each{|sObjID, aArgs|
        if (aArgs.empty?())
          sHeaderCode.concat("extern void #{sObjID}(#{TYP_VOID});#{TTG_NL}")
        else
          sHeaderCode.concat("extern void #{sObjID}(#{aArgs.join(', ')});#{TTG_NL}")
        end
      }

      return sHeaderCode  # [String]hեʸ
    end

    #=================================================================
    #   : cեʸ֤
    #=================================================================
    def make_c()
      # ϥɤ׻ʸ
      sCCode = <<-EOS
#{VERSION}
#include <kernel.h>
#include <t_syslog.h>
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "ttsp_test_lib.h"
#include "#{@sFileName}.h"

      EOS

      # ͭå
      if (@cConf.is_stack_share_mode?())
        nNum = 1
        while nNum <= @nStack
          sCCode.concat("STK_T ttg_stack_#{nNum}[COUNT_STK_T(TTSP_TASK_STACK_SIZE)];#{TTG_NL}")
          nNum += 1
        end
      end

      # GCOV
      if (@cConf.enable_gcov?())
        sGcov = <<-EOS

extern void #{FNC_GCOV_INIT}(void);
extern void #{FNC_GCOV_PAUSE}(void);
extern void #{FNC_GCOV_RESUME}(void);
extern void #{FNC_GCOV_DUMP}(void);
        EOS

        sCCode.concat(sGcov)
      end


      sCCode.concat(make_global_var())
      sCCode.concat(make_function())

      return sCCode  # [String]cեʸ
    end

    #=================================================================
    #   : ؿΥʸ֤
    #=================================================================
    def make_function()
      # ѿε
      @hFuncCode = make_local_var() # ®ٸΤᥤ󥹥ѿȤưϤʤ

      # ץ쥳ɤɲ
      @hProcUnitInfo.each{|sObjID, hObjData|
        bPreChk = false
        hObjData[:precode].each{|sCode|
          @hFuncCode[sObjID].push("#{TTG_TB}#{sCode}#{TTG_NL}")
          bPreChk = true
        }
        # ץ쥳ɤ硤Ǹ˲Ԥ
        if (bPreChk == true)
          @hFuncCode[sObjID].push("#{TTG_NL}")
        end
      }

      # bootcnt0Ǥʤñ̤ʣưŪѿΥ󥯥Ƚ
      # (ߥӥ롼ξmake_block_codetǥ󥯥Ȥ)
      @hProcUnitInfo.each{|sObjID, hObjData|
        if ((hObjData[:fbootcnt] > TTG_MAIN_BOOTCNT) && !(sObjID =~ /^#{TTG_LBL_ISR}_.+/))
          @hFuncCode[sObjID].push("#{TTG_TB}#{VAR_BOOTCNT}++;#{TTG_NL}#{TTG_NL}")
        end
      }

      # ƥȥʥꥪоݳη򸺻
      nCnt = 0
      nTotal = @aCode.size()
      @aCode.each{|hScenarioes|
        hScenarioes.each{|sScenarioID, aScenario|
          GRP_IGNORE_LABEL.each{|sIgnoreLabel|
            if (sScenarioID.include?(sIgnoreLabel))
              nTotal -= 1
              break
            end
          }
        }
      }

      @aCode.each{|hScenarioes|
        hScenarioes.each{|sScenarioID, aScenario|
          bChk = false
          GRP_IGNORE_LABEL.each{|sIgnoreLabel|
            if (sScenarioID.include?(sIgnoreLabel))
              bChk = true
              break
            end
          }
          if (bChk == false)
            nCnt += 1
            if (@cConf.is_no_progress_bar_mode?() == true)
              $stderr.puts "[IMC][#{"%5.1f" % (100 * nCnt.to_f / nTotal.to_f)}\% (#{"%4d" % nCnt}/#{"%4d" % nTotal})] #{sScenarioID}"
            else
              print_progress("IMC", sScenarioID, nCnt, nTotal)
            end
          end

          # ƥȥν
          aScenario.each{|hScenarioData|
            hScenarioData.each{|sConditionID, aConditionData|
              if (sConditionID == IMC_TTG_MAIN)
                make_block_code(aConditionData)
              else
                aConditionData.each{|hBlock|
                  hBlock.each{|sBlockID, aBlockData|
                    make_block_code(aBlockData, sScenarioID)
                  }
                }
              end
            }
          }
        }
      }
      # ץ쥹СɽΥꥻå
      if (@cConf.is_no_progress_bar_mode?() != true)
        finish_progress("IMC", nTotal)
      end

      # ݥȥɤɲ
      @hProcUnitInfo.each{|sObjID, hObjData|
        hObjData[:postcode].each{|sCode|
          @hFuncCode[sObjID].push("#{TTG_TB}#{sCode}#{TTG_NL}")
        }
      }

      # ϥɤݻʸ
      sFuncCode = ""

      # إåϥå岽
      hHeader = {}
      @aHeader.each{|aFuncInfo|
        hHeader[aFuncInfo[0]] = aFuncInfo[1]
      }

      # ñ̤Ȥʬϥå򡤽ϤΥɤ˺
      @hFuncCodeLow = @hFuncCode.sort_by{|key, val| key.downcase }
      @hFuncCodeLow.each{|sObjectID, aCode|
        # ؿ
        if (hHeader[sObjectID.downcase].empty?())
          sFuncCode.concat("void #{sObjectID.downcase}(#{TYP_VOID}){#{TTG_NL}")
        else
          sFuncCode.concat("void #{sObjectID.downcase}(#{hHeader[sObjectID.downcase].join(', ')}){#{TTG_NL}")
        end

        # ɤε
        aCode.each{ |sCode|
          sFuncCode.concat("#{sCode}")
        }

        # ؿ
        sFuncCode.concat("}#{TTG_NL}#{TTG_NL}")
      }

      return sFuncCode  # [String]ؿΥ
    end

    #=================================================================
    #   : ХѿΥɤ֤
    #=================================================================
    def make_global_var()

      # ϥɤ׻ʸ
      sGlobalCode = ""

      @aGlobalVar.each{|sVarName, sVarType, snVarValue|
        # :valueͤ¸ߤ뤫ɤȽ
        if (snVarValue.nil?())
          sGlobalCode.concat("#{sVarType} #{sVarName};#{TTG_NL}")
        else
          sGlobalCode.concat("#{sVarType} #{sVarName} = #{snVarValue};#{TTG_NL}")
        end
      }

      # 
      sGlobalCode.concat("#{TTG_NL}")

      return sGlobalCode  # [String]ХѿΥ
    end

    #=================================================================
    #   : ѿΥɤ֤
    #=================================================================
    def make_local_var()

      # Υɤݻϥå
      hLocalCode = {}

      @hProcUnitInfo.each{|sObjID, hObjData|
        # Фͤʤ硤
        # (ñ̤Ф@hFuncCodeΥ)
        if (hLocalCode[sObjID].nil?())
          hLocalCode[sObjID] = []
        end

        hObjData[:localvar].each{|sVarName, hVarData|
          # :valueͤ¸ߤ뤫ɤȽ
          if (hVarData[:value].nil?())
            hLocalCode[sObjID].push("#{TTG_TB}#{hVarData[:type]} #{sVarName};#{TTG_NL}")
          else
            hLocalCode[sObjID].push("#{TTG_TB}#{hVarData[:type]} #{sVarName} = #{hVarData[:value]};#{TTG_NL}")
          end
        }

        # ʣưŪѿ
        if (hObjData[:fbootcnt] > TTG_MAIN_BOOTCNT)
          hLocalCode[sObjID].push("#{TTG_TB}static int #{VAR_BOOTCNT} = -1;#{TTG_NL}")
        end

        # 
        hLocalCode[sObjID].push("#{TTG_NL}")
      }

      return hLocalCode  # [String]ѿΥ
    end

    #=================================================================
    #   : ֥åμ¹ԥɤ
    #=================================================================
    def make_block_code(aBlockData, sTestID = nil)
      check_class(Array,  aBlockData)    # ֥åΥɤΥǡ
      check_class(String, sTestID, true) # ƥID

      # ֥åȤ˲ԤФΥ֥ȥꥹ
      aObjList = []

      #nPrcID, sAttrCϻѤʤ
      aBlockData.each{|sObjID, sCode, nBootCnt, nPrcID, sAttr|
        # Ԥ륪֥ꥹ
        aObjList.push(sObjID)

        # ߥϥɥ顤ߥӥ롼CPU㳰ϥɥѽ
        if ((sObjID =~ /^#{TTG_LBL_INTHDR}_.+/) || (sObjID =~ /^#{TTG_LBL_ISR}_.+/) || (sObjID =~ /^#{TTG_LBL_EXCEPTION}_.+/))
          # ɬפʸ
          # (ߥӥ롼ξ硤֥IDIDʬ)
          if (sObjID =~ /^#{TTG_LBL_ISR}_.+/)
            sEnumID       = "ENUM_#{TTG_LBL_ISR}"
            sEnumElement  = "#{TTG_LBL_ISR}_#{sTestID}"
            sIfTestID     = "#{TTG_TB}if (#{TTG_LBL_ISR}_#{VAR_BOOTCNT} == #{sEnumElement}) {#{TTG_NL}"
            sEndIfTestID  = "#{TTG_TB}} \/* #{TTG_LBL_ISR}_#{VAR_BOOTCNT} == #{sEnumElement} *\/#{TTG_NL}"
          else
            sEnumObjID    = sObjID
            sEnumID       = "ENUM_#{sEnumObjID}"
            sEnumElement  = "#{sEnumObjID}_#{sTestID}"
            sIfTestID     = "#{TTG_TB}if (#{sEnumObjID}_#{VAR_BOOTCNT} == #{sEnumObjID}_#{sTestID}) {#{TTG_NL}"
            sEndIfTestID  = "#{TTG_TB}} \/* #{sEnumObjID}_#{VAR_BOOTCNT} == #{sEnumObjID}_#{sTestID} *\/#{TTG_NL}"
          end

          sIfBootcnt    = "#{TTG_TB}#{TTG_TB}\/* #{sTestID} *\/#{TTG_NL}#{TTG_TB}#{TTG_TB}if (#{VAR_BOOTCNT} == #{nBootCnt}) {#{TTG_NL}"
          sInitBootcnt  = "#{TTG_TB}#{TTG_TB}#{TTG_TB}#{VAR_BOOTCNT} = -1; \/* #{sTestID} *\/#{TTG_NL}#{TTG_NL}"
          sEndIfBootcnt = "#{TTG_NL}#{TTG_TB}#{TTG_TB}} \/* #{VAR_BOOTCNT} == #{nBootCnt} (#{sTestID}) *\/#{TTG_NL}"

          # enumǡν
          if (!@hEnumData.has_key?(sEnumID))
            @hEnumData[sEnumID] = [sEnumElement]
          # ǡʤɲ
          elsif (!@hEnumData[sEnumID].include?(sEnumElement))
            @hEnumData[sEnumID].push(sEnumElement)
          end

          # ƥIDεư
          if (!@hFuncCode[sObjID].include?(sIfTestID))
            @hFuncCode[sObjID].push(sIfTestID)

            # ߥӥ롼ξifʸ¦ǹԤ
            if (sObjID =~ /^#{TTG_LBL_ISR}_.+/)
              # bootcnt0Ǥʤ硤bootcnt򥤥󥯥
              # (¾ΥƥǤISRư˥󥯥ȤΤ򤱤)
              if (@hProcUnitInfo[sObjID][:fbootcnt] > TTG_MAIN_BOOTCNT)
                @hFuncCode[sObjID].push("#{TTG_TB}#{TTG_TB}#{VAR_BOOTCNT}++;#{TTG_NL}#{TTG_NL}")
              end

              # Ūʳ׵᥯ꥢ
              # (¾ΥƥǤISRư˥ꥢؿ¹ԤΤ򤱤)
              if (sTestID.include?(TTG_LBL_CHK_ENAINT))
                # ƥIDTTG_LBL_CHK_ENAINTޤޤ
                snIntNo = sObjID.gsub(/^#{TTG_LBL_ISR}_(.+)_#{TTG_LBL_CHK_ENAINT}$/, "\\1")
              else
                # ƥIDTTG_LBL_CHK_ENAINTޤޤʤ
                snIntNo = sObjID.gsub(/^#{TTG_LBL_ISR}_(.+)_#{sTestID}_.+$/, "\\1")
              end
              # Фֹǥꥢؿ¹
              @hFuncCode[sObjID].push("#{TTG_TB}#{TTG_TB}#{FNC_CLEAR_INT_REQ}(#{snIntNo});#{TTG_NL}#{TTG_NL}")
            end
          end

            # ʣư
            if (@hProcUnitInfo["#{sObjID}"][:fbootcnt] == TTG_MAIN_BOOTCNT)
              @hFuncCode[sObjID].push("#{TTG_TB}#{TTG_TB}#{sCode}#{TTG_NL}")
            else
              if (!@hFuncCode[sObjID].include?(sIfBootcnt))
                @hFuncCode[sObjID].push(sIfBootcnt)
                @hFuncCode[sObjID].delete(sInitBootcnt)
                @hFuncCode[sObjID].push(sInitBootcnt)
              end

              @hFuncCode[sObjID].push("#{TTG_TB}#{TTG_TB}#{TTG_TB}#{sCode}#{TTG_NL}")

              if (@hFuncCode[sObjID].include?(sEndIfBootcnt))
                @hFuncCode[sObjID].delete(sEndIfBootcnt)
              end

              @hFuncCode[sObjID].push(sEndIfBootcnt)
            end

          if (@hFuncCode[sObjID].include?(sEndIfTestID))
            @hFuncCode[sObjID].delete(sEndIfTestID)
          end

          @hFuncCode[sObjID].push(sEndIfTestID)
        # ̾Υ
        else
          # ɬפʸ
          sIfBootcnt    = "#{TTG_TB}if (#{VAR_BOOTCNT} == #{nBootCnt}) {#{TTG_NL}"
          sEndIfBootcnt = "#{TTG_TB}} \/* #{VAR_BOOTCNT} == #{nBootCnt} *\/#{TTG_NL}"

          # ʣưγǧ
          if (@hProcUnitInfo[sObjID][:fbootcnt] == TTG_MAIN_BOOTCNT)
            @hFuncCode[sObjID].push("#{TTG_TB}#{sCode}#{TTG_NL}")
          else
            if (!@hFuncCode[sObjID].include?(sIfBootcnt))
              @hFuncCode[sObjID].push(sIfBootcnt)
            end

            @hFuncCode[sObjID].push("#{TTG_TB}#{TTG_TB}#{sCode}#{TTG_NL}")

            if (@hFuncCode[sObjID].include?(sEndIfBootcnt))
              @hFuncCode[sObjID].delete(sEndIfBootcnt)
            end

            @hFuncCode[sObjID].push(sEndIfBootcnt)
          end
        end
      }

      # ֥åΥ֥˲Ԥ
      aObjList.uniq.each{|sObjID|
        @hFuncCode[sObjID].push("#{TTG_NL}")
      }
    end

    #=================================================================
    #   : ɤե벽
    #=================================================================
    def output_code_file(cCCode, sFileName)
      check_class(CCode, cCCode)    # CCodeΥ󥹥
      check_class(String, sFileName) # ϻΥե̾

      cCCode.output_code_file(sFileName)
    end

    #=================================================================
    #   : ɥ饹֤
    #=================================================================
    def get_result()
      return @@cCode  # [CCode]ɥ饹
    end
  end
end
