#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: ProfileDirector.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"

module TTG

  #==================================================================
  # 饹̾: ProfileDirector
  #   : ProfileBuilderѤ֥ɤ륯饹
  #==================================================================
  class ProfileDirector
    include CommonModule

    #================================================================
    # : 󥹥ȥ饯
    #================================================================
    def initialize(cProfileBuilder)
      check_class(ProfileBuilder, cProfileBuilder) # ProfileBuilder饹Υ󥹥

      @cProfileBuilder = cProfileBuilder.dup()

      @cConf = Config.new() # Config
    end


    #================================================================
    # : ꤵ줿ProfileBuilderѤbuildԤ
    #================================================================
    def build(aTestScenarios)
      check_class(Array, aTestScenarios) # ƥȥʥꥪ

      # 롼/λ롼󥯥饹
      bIsIniRtn = false
      bIsTerRtn = false
      aIniRtn = []
      aTerRtn = []
      aTestScenarios.each{|cTestScenario|
        if (@cProfileBuilder.exist_ini_rtn(cTestScenario) == true)
          aIniRtn.concat(cTestScenario.get_ini_ter_object_info_sort_by_id(TSR_OBJ_INIRTN))
          bIsIniRtn = true
        end
        if (@cProfileBuilder.exist_ter_rtn(cTestScenario) == true)
          aTerRtn.concat(cTestScenario.get_ini_ter_object_info_sort_by_id(TSR_OBJ_TERRTN))
          bIsTerRtn = true
        end
      }

      # 롼Υɤ
      if (bIsIniRtn == true)
        # FMPǤϥХ롼ǥƥȥ饤֥ѿνԤ
        if (@cConf.is_fmp?())
          @cProfileBuilder.build_initialize_test_lib_ini_rtn()
        end

        @cProfileBuilder.build_ini_rtn(aIniRtn)

        # 롼󤬤Ȥϥᥤ󥿥Ƭcp_stateå
        @cProfileBuilder.build_check_cp_state()
      else
        # 롼̵硤ᥤ󥿥ƬǳƽԤ
        @cProfileBuilder.build_initialize()
      end


      # TA_STA°μϥɥξ
      hCyclicStaInfo = get_all_object_info(aTestScenarios, TSR_OBJ_CYCLE)
      # TA_STA°μϥɥ餬Ȥϥᥤ󥿥ƬǾ֥åstp_cyc
      if (hCyclicStaInfo.empty?() == false)
        @cProfileBuilder.build_stp_cyc(hCyclicStaInfo)
      end

      # TA_ENAINT°γߥӥ롼ξ
      hISRInfo = get_all_object_info(aTestScenarios, TSR_OBJ_ISR)
      # TA_ENAINT°γߥӥ롼󤬤Ȥϳ߳ǧdis_intȯԤ
      if (hISRInfo.empty?() == false)
        @cProfileBuilder.build_ena_int_isr(hISRInfo)
      end

      # ߥϥɥξ
      hIntHdrInfo = get_all_object_info(aTestScenarios, TSR_OBJ_INTHDR)
      # ߥϥɥ餬Ȥ϶ͭñ/ؿ߳ǧdis_intȯԤ
      if (hIntHdrInfo.empty?() == false)
        @cProfileBuilder.build_shared_proc_unit(hIntHdrInfo, TSR_OBJ_INTHDR)
      end

      # CPU㳰ϥɥξ
      hExceptionInfo = get_all_object_info(aTestScenarios, TSR_OBJ_EXCEPTION)
      # CPU㳰ϥɥ餬Ȥ϶ͭñ/ؿ
      if (hExceptionInfo.empty?() == false)
        @cProfileBuilder.build_shared_proc_unit(hExceptionInfo, TSR_OBJ_EXCEPTION)
      end


      # GCOV  롼̵ν(ץե˰ۤʤ)
      if (@cConf.enable_gcov?() && (bIsIniRtn == false))
        @cProfileBuilder.build_main_task_gcov_start()
      end

      # ֥ɤ˥ƥȥʥꥪȤɬפʾɲä
      nCnt = 0
      nTotal = aTestScenarios.size()
      # Υƥȥʥꥪˤưե饰configure.yamlΥե饰ǽ
      bPrevGainTime = @cConf.is_all_gain_time_mode?()
      aTestScenarios.each{|cTestScenario|
        nCnt += 1
        if (@cConf.is_no_progress_bar_mode?() == true)
          $stderr.puts "[TTG][#{"%5.1f" % (100 * nCnt.to_f / nTotal.to_f)}\% (#{"%4d" % nCnt}/#{"%4d" % nTotal})] #{cTestScenario.sTestID}"
        else
          print_progress("TTG", cTestScenario.sTestID, nCnt, nTotal)
        end

        @cProfileBuilder.build(cTestScenario, bPrevGainTime)
        bPrevGainTime = cTestScenario.bGainTime
      }
      # ץ쥹СɽΥꥻå
      if (@cConf.is_no_progress_bar_mode?() != true)
        finish_progress("TTG", nTotal)
      end


      # ǸΥåݥȤ
      # λ롼󤬤check_pointext_ker̵check_finish
      @cProfileBuilder.build_finish_cp(bIsTerRtn)

      # λ롼Υɤ
      if (bIsTerRtn == true)
        @cProfileBuilder.build_ter_rtn(aTerRtn)
      end
    end

    #================================================================
    #   : ꤷ֥Ȥƥȥʥꥪξ֤
    #         (ߡCPU㳰ϥɥ(TA_STA)Τߤ˻Ѥ)
    #================================================================
    def get_all_object_info(aTestScenarios, sObjectType)
      check_class(Array, aTestScenarios) # ƥȥʥꥪǡ
      check_class(String, sObjectType)   # оݤȤ륪֥ȥ

      hAllObjectInfo = Hash.new()

      aTestScenarios.each{|cTestScenario|
        if (((sObjectType == TSR_OBJ_INTHDR) && (cTestScenario.exist_int_hdr() == true)) ||
            ((sObjectType == TSR_OBJ_ISR) && (cTestScenario.exist_isr_enaint() == true)) ||
            ((sObjectType == TSR_OBJ_EXCEPTION) && (cTestScenario.exist_exception() == true)) ||
            ((sObjectType == TSR_OBJ_CYCLE) && (cTestScenario.exist_cyclic_sta() == true)))
          hAllObjectInfo.update(cTestScenario.get_all_object_info(sObjectType)){|key, self_val, other_val|
            # bootcntϺͤ
            if (self_val.hState[TSR_PRM_BOOTCNT] > other_val.hState[TSR_PRM_BOOTCNT])
              self_val
            else
              other_val
            end
          }
        end
      }

      return hAllObjectInfo  # [Hash]֥Ⱦϥå
    end

  end
end
