#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2012 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: ttg.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
if ($0 == __FILE__)
  TOOL_ROOT = File.expand_path(File.dirname(__FILE__) + "/../")
  $LOAD_PATH.unshift(TOOL_ROOT)
end
require "common/bin/Config.rb"
require "bin/builder/ASPBuilder.rb"
require "bin/builder/FMPBuilder.rb"
require "bin/builder/CBuilder.rb"
require "bin/builder/HTMLBuilder.rb"
require "bin/director/ProfileDirector.rb"
require "bin/director/CodeDirector.rb"
require "ttc/bin/ttc.rb"
require "ttj/bin/ttj.rb"
require 'pp'

module TTG
  # TTGΥС
  $Version   = "3.0.6"
  VERSION = "/* Generated by TTG ver #{$Version} ($Rev: 6880 $) */"

  class TTGMain
    include TTCModule
    include TTJModule
    include CommonModule

    #=================================================================
    # : TTGᥤ롼
    #=================================================================
    def main(aArgs)
      check_class(Array, aArgs)      # ¹Ի

      # 󥽡βå
      if (check_console_width() == false)
        $stderr.puts(ERR_CONSOLE_WIDTH)
        exit(1)
      end

      #
      # TESRYǡ顤֥ɤ
      #

      # TTCyamlꥹȤϤ饹֤
      cTTC = TTC.new()
      aTestScenarios = cTTC.pre_process(aArgs)

      # եμ
      cConf = Config.new()

      # ProfileBuilderProfileDirectorΰȤϤ
      if (cConf.is_asp?())
        cProfileBuilder = ASPBuilder.new()
      elsif (cConf.is_fmp?())
        cProfileBuilder = FMPBuilder.new()
      else
        abort(ERR_MSG % [__FILE__, __LINE__])
      end
      cProfileDirector = ProfileDirector.new(cProfileBuilder)

      # aTestScenariosȤơProfileDirectorbuild¹
      cProfileDirector.build(aTestScenarios)
      cIntermediateCode = cProfileBuilder.get_result()
      # ֥ɤϤϰʲ򥢥󥳥
      #cIntermediateCode.p_code(:all)

      #
      # 줿֥ɤ顤¹ԥɤ
      #

      # CodeBuilderCodeDirectorΰȤϤ
      aBuilder = []
      aBuilder.push(CBuilder.new())
      if (cConf.is_testflow_mode?())
        aBuilder.push(HTMLBuilder.new())
      end

      aBuilder.each{ |cBuilder|
        cCodeDirector = CodeDirector.new(cBuilder)

        # cIntermediateCodeȤơcCodeDirectorbuild¹
        cCodeDirector.build(cIntermediateCode)
        cCode = cBuilder.get_result()
        # 줿ɤե벽
        cBuilder.output_code_file(cCode, cConf.get_out_file())
      }

      #
      # TTJ
      #

      # TTJTestScenarioϤܸ첽
      if (cConf.is_enable_ttj_mode?())
        cTTJ = TTJ.new()
        cTTJ.japanize_test_scenario(aTestScenarios)
        cTTJ.print_file()     # ե
      end


      # Хꥨǽ줿եɽ
      cTTC.print_exclude()
    end
  end
end


#====================================================================
# ƥȥ
#====================================================================
if (__FILE__ == $0)
  require 'pp'
  include TTG

  cTTG = TTGMain.new()
  cTTG.main(ARGV)
end
