#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Config.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"
require "ttc/bin/class/TTCCommon.rb"

module CommonModule
  #===================================================================
  # 饹̾: Config
  #   : 
  #===================================================================
  class Config
    include CommonModule
    include TTCModule

    @@hConf = {}  # configure

    #=================================================================
    # : configureեɤ߹
    #=================================================================
    def load_config(sFileName)
      check_class(String, sFileName)  # configureե

      hConf = load_yaml_file(sFileName)
      # HashʤȤsetƤ
      if (hConf.is_a?(Hash))
        hConf.each{|sKey, val|
          # ꤵƤܤФ
          if (@@hConf[sKey].nil?())
            set(sKey, val)
          end
        }
      ### T0_008: configureHashǤʤ
      else
        sErr = sprintf("T0_008: " + ERR_INVALID_TYPE, "configure", Hash, hConf.class())
        raise(TTCError.new(sErr))
      end

      # ޥͤ׻
      calc_macro()
    end

    #=================================================================
    # : ͤꤹ
    #=================================================================
    def set(sKey, val)
      check_class(String, sKey)       # 
      check_class(Object, val, true)  # 

      # 16ʿ
      if (val =~ TTC_REX_HEX)
        val = val.hex()
      end

      case sKey
      # ʸ
      when CFG_FILE, CFG_DEFAULT_CLASS, CFG_OUT_FILE, CFG_TIME_MANAGE_CLASS, CFG_EXCEPT_ARG_NAME
        ### T0_002: configureͤꤵ줿Ȱۤʤ
        unless (val.is_a?(String))
          sErr = sprintf("T0_002: " + ERR_CFG_INVALID_VALUE, sKey, val)
          raise(TTCError.new(sErr))
        end

      # 
      when CFG_TEST_FLOW, CFG_DEBUG_MODE, CFG_STACK_SHARE, CFG_ALL_GAIN_TIME,
           CFG_OWN_IPI_RAISE, CFG_ENA_EXC_LOCK, CFG_ENA_CHGIPM,
           CFG_FUNC_TIME, CFG_FUNC_INTERRUPT, CFG_FUNC_EXCEPTION,
           CFG_NO_PROGRESS_BAR, CFG_ENABLE_GCOV, CFG_ENABLE_LOG, CFG_ENABLE_TTJ,
           CFG_SUPPORT_GET_UTM, CFG_SUPPORT_ENA_INT, CFG_SUPPORT_DIS_INT
        val = to_bool(val)
        ### T0_002: configureͤꤵ줿Ȱۤʤ
        unless (Bool.include?(val.class()))
          sErr = sprintf("T0_002: " + ERR_CFG_INVALID_VALUE, sKey, val)
          raise(TTCError.new(sErr))
        end

      # 0礭
      when CFG_MAIN_PRCID, CFG_PRC_NUM, CFG_TIME_MANAGE_PRCID
        # ץʸˤʤ뤿Ѵ
        if (val =~ TTC_REX_NUM)
          val = val.to_i()
        end
        ### T0_002: configureͤꤵ줿Ȱۤʤ
        if (!val.is_a?(Integer))
          sErr = sprintf("T0_002: " + ERR_CFG_INVALID_VALUE, sKey, val)
          raise(TTCError.new(sErr))
        ### T0_003: configureͤͭͤǤʤ
        elsif (val <= 0)
          sErr = sprintf("T0_003: " + ERR_CFG_BE_INTEGER_GT, sKey, 0, val)
          raise(TTCError.new(sErr))
        end

      # 0ʾ
      when CFG_SPINLOCK_NUM, CFG_WAIT_SPIN_LOOP
        # ץʸˤʤ뤿Ѵ
        if (val =~ TTC_REX_NUM)
          val = val.to_i()
        end
        ### T0_002: configureͤꤵ줿Ȱۤʤ
        if (!val.is_a?(Integer))
          sErr = sprintf("T0_002: " + ERR_CFG_INVALID_VALUE, sKey, val)
          raise(TTCError.new(sErr))
        ### T0_003: configureͤͭͤǤʤ
        elsif (val < 0)
          sErr = sprintf("T0_003: " + ERR_CFG_BE_INTEGER_GE, sKey, 0, val)
          raise(TTCError.new(sErr))
        end

      # ʸ0꾮
      when CFG_TIMER_INT_PRI
        ### T0_002: configureͤꤵ줿Ȱۤʤ
        if (!val.is_a?(String) && !val.is_a?(Integer))
          sErr = sprintf("T0_002: " + ERR_CFG_INVALID_VALUE, sKey, val)
          raise(TTCError.new(sErr))
        ### T0_003: configureͤͭͤǤʤ
        elsif (val.is_a?(Integer) && (val >= 0))
          sErr = sprintf("T0_003: " + ERR_CFG_BE_INTEGER_LT, sKey, 0, val)
          raise(TTCError.new(sErr))
        end

      # ץե
      when CFG_PROFILE
        # ץϤͭͤå

      # ޥƥ
      when CFG_TIMER_ARCH
        ### T0_002: configureͤꤵ줿Ȱۤʤ
        if (!val.is_a?(String))
          sErr = sprintf("T0_002: " + ERR_CFG_INVALID_VALUE, sKey, val)
          raise(TTCError.new(sErr))
        ### T0_003: configureͤͭͤǤʤ
        elsif (val != TSR_PRM_TIMER_GLOBAL && val != TSR_PRM_TIMER_LOCAL)
          sErr = sprintf("T0_003: " + ERR_CFG_INVALID_VALUE, sKey, val)
          raise(TTCError.new(sErr))
        end

      # IRCƥ
      when CFG_IRC_ARCH
        ### T0_002: configureͤꤵ줿Ȱۤʤ
        if (!val.is_a?(String))
          sErr = sprintf("T0_002: " + ERR_CFG_INVALID_VALUE, sKey, val)
          raise(TTCError.new(sErr))
        ### T0_003: configureͤͭͤǤʤ
        elsif (val != TSR_PRM_IRC_GLOBAL && val != TSR_PRM_IRC_LOCAL && val != TSR_PRM_IRC_COMBINATION)
          sErr = sprintf("T0_003: " + ERR_CFG_INVALID_VALUE, sKey, val)
          raise(TTCError.new(sErr))
        end

      # YAML饤֥
      when CFG_YAML_LIBRARY
        ### T0_002: configureͤꤵ줿Ȱۤʤ
        if (!val.is_a?(String))
          sErr = sprintf("T0_002: " + ERR_CFG_INVALID_VALUE, sKey, val)
          raise(TTCError.new(sErr))
        ### T0_003: configureͤͭͤǤʤ
        elsif (val != CFG_LIB_YAML && val != CFG_LIB_KWALIFY)
          sErr = sprintf("T0_003: " + ERR_CFG_INVALID_VALUE, sKey, val)
          raise(TTCError.new(sErr))
        end

      # ޥ
      when CFG_MACRO
        ### T0_009: ޥHashǤʤ
        unless (val.nil?() || val.is_a?(Hash))
          sErr = sprintf("T0_009: " + ERR_CFG_INVALID_VALUE, sKey, val)
          raise(TTCError.new(sErr))
        end

      # Ƥʤ
      else
        ### T0_010: configure˵ꤵƤʤܤҤƤ
        sErr = sprintf("T0_010: " + ERR_CFG_UNDEFINED_KEY, sKey, "configure")
        raise(TTCError.new(sErr))
      end

      # å̤
      @@hConf[sKey] = val
    end

    #=================================================================
    # : ޥͤ
    #=================================================================
    def calc_macro()
      if (@@hConf[CFG_MACRO].is_a?(Hash))
        hMacro = @@hConf.dup()
        hMacro.delete(CFG_MACRO)
        @@hConf[CFG_MACRO].each{|sMacro, val|
          @@hConf[CFG_MACRO][sMacro] = parse_value(val, hMacro)
        }
      end
    end

    #=================================================================
    # : ͤɽʸѴ
    #=================================================================
    def to_bool(sStr)
      check_class(Object, sStr, true)  # Ѵʸ

      case sStr
      when "true"
        return true # [Bool]Ѵ
      when "false"
        return false # [Bool]Ѵ
      else
        return safe_dup(sStr) # [Bool]Ѵ
      end
    end

    #=================================================================
    # : configureΥåԤ
    #=================================================================
    def environment_check()
      @aErrors = []

      # Υå
      GRP_CFG_NECESSARY_KEYS.each{|sKey|
        ### T0_001: configureǵҤƤʤܤ
        unless (@@hConf.has_key?(sKey))
          sErr = sprintf("T0_001: " + ERR_CFG_REQUIRED_KEY, sKey)
          @aErrors.push(TTCError.new(sErr))
        end
      }

      # ޥΥå
      hMacro = get_macro()
      hBitPattern = Hash.new{|hash, key|
        hash[key] = {}
      }

      ### T0_007: ɬפʥޥƤʤ
      GRP_CFG_NECESSARY_MACRO.each{|sMacro|
        if (hMacro.nil?() || !hMacro.has_key?(sMacro))
          sErr = sprintf("T0_007: " + ERR_CFG_REQUIRED_MACRO, sMacro)
          @aErrors.push(TTCError.new(sErr))
        end
      }

      if (hMacro.is_a?(Hash))
        ### T0_004: ޥͤꤵ줿Ȱۤʤ
        ### T0_005: ޥͤͭͤǤʤ
        hMacro.each{|sMacro, val|
          case sMacro
          # [0礭]
          when /^PRC_/, "MAIN_PRCID", "ANY_INI_BLKCNT", "ANY_NOW_BLKCNT", "ANY_BLKSZ", "ANY_MAX_SEMCNT", "ANY_NOW_SEMCNT"
            if (!val.is_a?(Integer))
              sErr = sprintf("T0_004: " + ERR_MCR_INVALID_TYPE, sMacro, Integer, val.class())
              @aErrors.push(TTCError.new(sErr))
            elsif (val <= 0)
              sErr = sprintf("T0_005: " + ERR_MCR_BE_INTEGER_GT, sMacro, 0, val)
              @aErrors.push(TTCError.new(sErr))
            end

          # [ʸ]
          when /^CLS_/
            unless (val.is_a?(String))
              sErr = sprintf("T0_004: " + ERR_MCR_INVALID_TYPE, sMacro, String, val.class())
              @aErrors.push(TTCError.new(sErr))
            end

          # [14ϰϤ]
          when "TSK_PRI_LE_4", "TSK_PRI_LE_LE_4"
            if (!val.is_a?(Integer))
              sErr = sprintf("T0_004: " + ERR_MCR_INVALID_TYPE, sMacro, Integer, val.class())
              @aErrors.push(TTCError.new(sErr))
            elsif (val < 1 || val > 4)
              sErr = sprintf("T0_005: " + ERR_MCR_BE_INTEGER_RANGE, sMacro, 1, 4, val)
              @aErrors.push(TTCError.new(sErr))
            end

          # [1316ϰϤ]
          when "TSK_PRI_GE_13"
            if (!val.is_a?(Integer))
              sErr = sprintf("T0_004: " + ERR_MCR_INVALID_TYPE, sMacro, Integer, val.class())
              @aErrors.push(TTCError.new(sErr))
            elsif (val < 13 || val > 16)
              sErr = sprintf("T0_005: " + ERR_MCR_BE_INTEGER_RANGE, sMacro, 13, 16, val)
              @aErrors.push(TTCError.new(sErr))
            end

          # [0ʾ]
          when /^BIT_PATTERN_/, /^TEXPTN_/
            nVal = parse_value(val)
            unless (nVal.is_a?(Integer))
              sErr = sprintf("T0_004: " + ERR_MCR_INVALID_TYPE, sMacro, Integer, val.class())
              @aErrors.push(TTCError.new(sErr))
            end
            # 0Ǥ
            if (nVal == 0 && sMacro =~ /^(BIT_PATTERN|TEXPTN)_[^0]/)
              sErr = sprintf("T0_005: " + ERR_MCR_BE_INTEGER_NE, sMacro, 0, val)
              @aErrors.push(TTCError.new(sErr))
            end
            # ӥåȥˡȽ
            if (sMacro =~ /^BIT_PATTERN_/)
              hBitPattern[:hBitPtn][sMacro] = nVal
            elsif (sMacro =~ /^TEXPTN_/)
              hBitPattern[:hTexPtn][sMacro] = nVal
            end

          # [TWF_ANDWTWF_ORW]
          when /^WAIT_FLG_MODE_/
            unless (val == KER_TWF_ANDW || val == KER_TWF_ORW)
              sErr = sprintf("T0_005: " + ERR_MCR_INVALID_VALUE, sMacro, val)
              @aErrors.push(TTCError.new(sErr))
            end

          # [0ʾ]
          when "ANY_INI_SEMCNT", /^RELATIVE_/
            if (!val.is_a?(Integer))
              sErr = sprintf("T0_004: " + ERR_MCR_INVALID_TYPE, sMacro, Integer, val.class())
              @aErrors.push(TTCError.new(sErr))
            elsif (val < 0)
              sErr = sprintf("T0_005: " + ERR_MCR_BE_INTEGER_GE, sMacro, 0, val)
              @aErrors.push(TTCError.new(sErr))
            end

          # [116]
          when /^TSK_PRI_/, /^DATA_PRI_/, /^MSG_PRI_/, /^ISR_PRI_/
            if (!val.is_a?(Integer))
              sErr = sprintf("T0_004: " + ERR_MCR_INVALID_TYPE, sMacro, Integer, val.class())
              @aErrors.push(TTCError.new(sErr))
            elsif (val < 1 || val > 16)
              sErr = sprintf("T0_005: " + ERR_MCR_BE_INTEGER_RANGE, sMacro, 1, 16, val)
              @aErrors.push(TTCError.new(sErr))
            end

          # [0礭]
          when /_TIME$/
            if (!val.is_a?(Integer))
              sErr = sprintf("T0_004: " + ERR_MCR_INVALID_TYPE, sMacro, Integer, val.class())
              @aErrors.push(TTCError.new(sErr))
            elsif (val <= 0)
              sErr = sprintf("T0_005: " + ERR_MCR_BE_INTEGER_GE, sMacro, 0, val)
              @aErrors.push(TTCError.new(sErr))
            end

          # [ʸ0꾮]
          when /^ANY_IPM/, /^INT_PRI_/
            unless (val.is_a?(String))
              if (!val.is_a?(Integer))
                sErr = sprintf("T0_004: " + ERR_MCR_INVALID_TYPE, sMacro, "Integer or String", val.class())
                @aErrors.push(TTCError.new(sErr))
              elsif (val >= 0)
                sErr = sprintf("T0_005: " + ERR_MCR_BE_INTEGER_LT, sMacro, 0, val)
                @aErrors.push(TTCError.new(sErr))
              end
            end

          # [ʸ0ʾ]
          when /^INTNO_/, /^INHNO_/, /^EXCNO_/, /^ANY_/
            unless (val.is_a?(String))
              if (!val.is_a?(Integer))
                sErr = sprintf("T0_004: " + ERR_MCR_INVALID_TYPE, sMacro, "Integer or String", val.class())
                @aErrors.push(TTCError.new(sErr))
              elsif (val < 0)
                sErr = sprintf("T0_005: " + ERR_MCR_BE_INTEGER_GE, sMacro, 0, val)
                @aErrors.push(TTCError.new(sErr))
              end
            end

          # [ʸ]
          when /^DATA_/, /^EXINF_/
            if (!val.is_a?(Integer) && !val.is_a?(String))
              sErr = sprintf("T0_004: " + ERR_MCR_INVALID_TYPE, sMacro, "Integer or String", val.class())
              @aErrors.push(TTCError.new(sErr))
            end
          end
        }
        check_error(@aErrors)

        # ¸طΥå
        check_priority("TSK_PRI_LOW", "TSK_PRI_MID", "TSK_PRI_HIGH")
        check_le("TSK_PRI_LE_LE_4", "TSK_PRI_LE_4")
        check_le("TSK_PRI_LE_GE_13", "TSK_PRI_GE_13")
        check_priority("DATA_PRI_LOW", "DATA_PRI_MID", "DATA_PRI_HIGH", "DATA_PRI_MAX")
        check_priority("MSG_PRI_LOW", "MSG_PRI_MID", "MSG_PRI_HIGH", "MSG_PRI_MAX")
        check_priority("ISR_PRI_LOW", "ISR_PRI_MID", "ISR_PRI_HIGH")
        check_le("ANY_NOW_BLKCNT", "ANY_INI_BLKCNT")
        check_le("ANY_INI_SEMCNT", "ANY_MAX_SEMCNT")
        check_lt("ANY_NOW_SEMCNT", "ANY_MAX_SEMCNT")
        check_bit_unique(hBitPattern[:hBitPtn])
        check_bit_unique(hBitPattern[:hTexPtn])
      end

      ### T0_006: ؿʤΤƥȥ߻Ǥ
      if (!is_all_gain_time_mode?() && get_func_time() == false)
        @aErrors.push(TTCError.new("T0_006: " + ERR_VARIATION_TIME_GAIN))
      end

      check_error(@aErrors)
    end

    #=================================================================
    # : ͥ٤ΰ¸طåԤ
    #=================================================================
    def check_priority(sLow, sMid, sHigh, sMax = nil)
      check_class(String, sLow)        # LOW
      check_class(String, sMid)        # MID
      check_class(String, sHigh)       # HIGH
      check_class(String, sMax, true)  # MAX

      hMacro = get_macro()
      # 
      unless (hMacro[sMax].nil?())
        check_le(sLow, sMax)
        check_le(sMid, sMax)
        check_le(sHigh, sMax)
      end

      # 羮ط
      check_lt(sMid, sLow)
      check_lt(sHigh, sMid)
      check_lt(sHigh, sLow)
    end

    #=================================================================
    # : 羮طåԤ
    #=================================================================
    def check_le(sKey1, sKey2)
      check_class(String, sKey1, true)  # ȤʤͤΥ
      check_class(String, sKey2, true)  # оݤΥ

      hMacro = get_macro()
      if (hMacro[sKey1] > hMacro[sKey2])
        sErr = sprintf("T0_005: " + ERR_MCR_BE_INTEGER_LE, sKey1, sKey2, hMacro[sKey2])
        @aErrors.push(TTCError.new(sErr))
      end
    end

    #=================================================================
    # : 羮طåԤ
    #=================================================================
    def check_lt(sKey1, sKey2)
      check_class(String, sKey1, true)  # ȤʤͤΥ
      check_class(String, sKey2, true)  # оݤΥ

      hMacro = get_macro()
      if (hMacro[sKey1] >= hMacro[sKey2])
        sErr = sprintf("T0_005: " + ERR_MCR_BE_INTEGER_LT, sKey1, sKey2, hMacro[sKey2])
        @aErrors.push(TTCError.new(sErr))
      end
    end

    #=================================================================
    # : ӥåȥˡåԤ
    #=================================================================
    def check_bit_unique(hBitPattern)
      check_class(Hash, hBitPattern)  # ӥåȥѥäƤ

      nTmp = 0
      hBitPattern.each{|sMacro, nVal|
        if (nTmp & nVal != 0)
          sErr = sprintf("T0_005: " + ERR_MCR_NOT_BIT_UNIQUE, sMacro)
          @aErrors.push(TTCError.new(sErr))
        end
        nTmp = nTmp | nVal
      }
    end

    #=================================================================
    # : ɤ߹configureե̾
    #=================================================================
    def get_configure_file()
      return @@hConf[CFG_FILE] # [String]configureե̾
    end

    #=================================================================
    # : ϥե̾
    #=================================================================
    def get_out_file()
      return @@hConf[CFG_OUT_FILE] # [String]ϥե̾
    end

    #=================================================================
    # : ǥեȥ饹̾
    #=================================================================
    def get_default_class()
      return @@hConf[CFG_DEFAULT_CLASS] # [String]ǥեȥ饹̾
    end

    #=================================================================
    # : ᥤץåID
    #=================================================================
    def get_main_prcid()
      return @@hConf[CFG_MAIN_PRCID] # [Integer]ᥤץåID
    end

    #=================================================================
    # : ץå
    #=================================================================
    def get_prc_num()
      return @@hConf[CFG_PRC_NUM] # [Integer]ץå
    end

    #=================================================================
    # : ԥå
    #=================================================================
    def get_spinlock_num()
      return @@hConf[CFG_SPINLOCK_NUM] # [Integer]ԥå
    end

    #=================================================================
    # : ԥåԤǧ뤿Υ롼ײ
    #=================================================================
    def get_wait_spin_loop()
      return @@hConf[CFG_WAIT_SPIN_LOOP] # [Integer]ԥåԤǧ뤿Υ롼ײ
    end

    #=================================================================
    # : ޥƥ
    #=================================================================
    def get_timer_arch()
      return @@hConf[CFG_TIMER_ARCH] # [String]ޥƥ
    end

    #=================================================================
    # : IRCƥ
    #=================================================================
    def get_irc_arch()
      return @@hConf[CFG_IRC_ARCH] # [String]IRCƥ
    end

    #=================================================================
    # : Х륿ѥ饹
    #=================================================================
    def get_time_manage_class()
      return @@hConf[CFG_TIME_MANAGE_CLASS] # [String]Х륿ѥ饹
    end

    #=================================================================
    # : ƥץåID
    #=================================================================
    def get_time_manage_prcid()
      return @@hConf[CFG_TIME_MANAGE_PRCID] # [Integer]ƥץåID
    end

    #=================================================================
    # : 桼ޥ
    #=================================================================
    def get_macro()
      return @@hConf[CFG_MACRO] # [Hash]ޥΥϥå
    end

    #=================================================================
    # : ؿѲǽ֤
    #=================================================================
    def get_func_time()
      return @@hConf[CFG_FUNC_TIME] # [Bool]ؿѲǽ
    end

    #=================================================================
    # : ȯؿѲǽ֤
    #=================================================================
    def get_func_interrupt()
      return @@hConf[CFG_FUNC_INTERRUPT] # [Bool]ȯؿѲǽ
    end

    #=================================================================
    # : CPU㳰ȯؿѲǽ֤
    #=================================================================
    def get_func_exception()
      return @@hConf[CFG_FUNC_EXCEPTION] # [Bool]CPU㳰ȯؿѲǽ
    end

    #=================================================================
    # : ץåؤΥץåֳߤǽ֤
    #=================================================================
    def get_own_ipi_raise()
      return @@hConf[CFG_OWN_IPI_RAISE] # [Bool]ץåؤΥץåֳߤǽ
    end

    #=================================================================
    # : CPUåCPU㳰ȯ򥵥ݡȤƤ뤫֤
    #=================================================================
    def get_enable_exc_in_cpulock()
      return @@hConf[CFG_ENA_EXC_LOCK] # [Bool]CPUåCPU㳰ȯ򥵥ݡȤƤ뤫
    end

    #=================================================================
    # : 󥿥ƥȤγͥ٥ޥѹ򥵥ݡ
    #       : ȤƤ뤫֤
    #=================================================================
    def get_enable_chg_ipm_in_non_task()
      return @@hConf[CFG_ENA_CHGIPM] # [Bool]ݡȤƤ뤫
    end

    #=================================================================
    # : CPU㳰ϥɥΰȤѿ̾
    #=================================================================
    def get_exception_arg_name()
      return @@hConf[CFG_EXCEPT_ARG_NAME] # [String]Ȥѿ̾
    end

    #=================================================================
    # : APIget_utm򥵥ݡȤƤ뤫֤
    #=================================================================
    def get_api_support_get_utm()
      return @@hConf[CFG_SUPPORT_GET_UTM] # [Bool]ݡȤƤ뤫
    end

    #=================================================================
    # : APIena_int򥵥ݡȤƤ뤫֤
    #=================================================================
    def get_api_support_ena_int()
      return @@hConf[CFG_SUPPORT_ENA_INT] # [Bool]ݡȤƤ뤫
    end

    #=================================================================
    # : APIdis_int򥵥ݡȤƤ뤫֤
    #=================================================================
    def get_api_support_dis_int()
      return @@hConf[CFG_SUPPORT_DIS_INT] # [Bool]ݡȤƤ뤫
    end

    #=================================================================
    # : ޳ߤγͥ٤֤(Ի)
    #=================================================================
    def get_timer_int_pri()
      return @@hConf[CFG_TIMER_INT_PRI] # [Bool]޳ߤγͥ
    end

    #=================================================================
    # : ƥȥե⡼ɤ֤ͭ
    #=================================================================
    def is_testflow_mode?()
      return @@hConf[CFG_TEST_FLOW] # [Bool]ƥȥե⡼ɤͭ
    end

    #=================================================================
    # : ǥХå⡼ɤ֤ͭ
    #=================================================================
    def is_debug_mode?()
      return @@hConf[CFG_DEBUG_MODE] # [Bool]ǥХå⡼ɤͭ
    end

    #=================================================================
    # : åͭ⡼ɤ֤ͭ
    #=================================================================
    def is_stack_share_mode?()
      return @@hConf[CFG_STACK_SHARE] # [Bool]åͭ⡼ɤͭ
    end

    #=================================================================
    # : ƥȥʥꥪǻ֤ʤ⡼ɤ֤ͭ
    #=================================================================
    def is_all_gain_time_mode?()
      return @@hConf[CFG_ALL_GAIN_TIME] # [Bool]ƥȥʥꥪǻ֤ʤ⡼ɤͭ
    end

    #=================================================================
    # : ץ쥹Сɽ⡼ɤ֤ͭ
    #=================================================================
    def is_no_progress_bar_mode?()
      return @@hConf[CFG_NO_PROGRESS_BAR] # [Bool]ץ쥹Сɽ⡼ɤͭ
    end

    #=================================================================
    # : TTJϥ⡼ɤ֤ͭ
    #=================================================================
    def is_enable_ttj_mode?()
      return @@hConf[CFG_ENABLE_TTJ] # [Bool]TTJϥ⡼ɤͭ
    end

    #=================================================================
    # : ץե뤬ASPå
    #=================================================================
    def is_asp?()
      return (@@hConf[CFG_PROFILE] == CFG_PROFILE_ASP) # [Bool]ץե뤬ASP
    end

    #=================================================================
    # : ץե뤬FMPå
    #=================================================================
    def is_fmp?()
      return (@@hConf[CFG_PROFILE] == CFG_PROFILE_FMP) # [Bool]ץե뤬FMP
    end

    #=================================================================
    # : ޥƥ㤬뤫å
    #=================================================================
    def is_timer_local?()
      return (@@hConf[CFG_TIMER_ARCH] == TSR_PRM_TIMER_LOCAL) # [Bool]ޥƥ㤬뤫
    end

    #=================================================================
    # : ץե뤬åȤƤ뤫å
    #=================================================================
    def is_profile_set?()
      return (!@@hConf[CFG_PROFILE].nil?()) # [Bool]ץե뤬åȤƤ뤫
    end

    #=================================================================
    # : IRCƥ㤬Х뤫å(Ի)
    #=================================================================
    def is_irc_global?()
      return (@@hConf[CFG_IRC_ARCH] == TSR_PRM_IRC_GLOBAL) #[Bool]IRCƥ㤬Х뤫
    end

    #=================================================================
    # : IRCƥ㤬뤫å(Ի)
    #=================================================================
    def is_irc_local?()
      return (@@hConf[CFG_IRC_ARCH] == TSR_PRM_IRC_LOCAL) #[Bool]IRCƥ㤬뤫
    end

    #=================================================================
    # : IRCƥξݡȤ뤫å(Ի)
    #=================================================================
    def is_irc_combination?()
      return (@@hConf[CFG_IRC_ARCH] == TSR_PRM_IRC_COMBINATION) #[Bool]IRCƥξݡȤ뤫
    end

    #=================================================================
    # : YAML饤֥Ȥ֤
    #=================================================================
    def use_yaml_library?()
      return (@@hConf[CFG_YAML_LIBRARY] == CFG_LIB_YAML) #[Bool]YAML饤֥Ȥ
    end

    #=================================================================
    # : GCOV뤫֤
    #=================================================================
    def enable_gcov?()
      return (@@hConf[CFG_ENABLE_GCOV] == true) #[Bool]GCOV뤫
    end

    #=================================================================
    # : 뤫֤(Ի)
    #=================================================================
    def enable_log?()
      return (@@hConf[CFG_ENABLE_LOG] == true) #[Bool]뤫
    end

    #=================================================================
    # : ͤʾŪѻߡ
    #=================================================================
    def get(sKey)
      check_class(String, sKey)  # 

      return @@hConf[sKey] # [String, Bool]
    end

    #=================================================================
    # : ݻƤꥻåȤ
    #       : ʥХåƥȥץѡ
    #=================================================================
    def reset()
      @@hConf = {}
    end
  end
end
