#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Cyclic.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/process_unit/ProcessUnit.rb"
require "ttc/bin/process_unit/Cyclic.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Cyclic
  #     : ϥɥξ륯饹
  #===================================================================
  class Cyclic < ProcessUnit
    #=================================================================
    #   : ϥɥν
    #=================================================================
    def initialize(sObjectID, hObjectInfo, aPath, bIsPre)
      check_class(String, sObjectID)  # ֥ID
      check_class(Hash, hObjectInfo)  # ֥Ⱦ
      check_class(Array, aPath)       # 롼ȤΥѥ
      check_class(Bool, bIsPre)       # pre_condition⤫

      super(sObjectID, hObjectInfo, TSR_OBJ_CYCLE, aPath, bIsPre)

      @sRefAPI     = FNC_REF_CYC
      @sRefStrType = TYP_T_TTSP_RCYC
      @sRefStrVar  = GRP_VAR_TYPE[TYP_T_TTSP_RCYC]
      @sRefState   = STR_CYCSTAT
      @sRefExInf   = STR_EXINF
      @sRefPrcID   = STR_PRCID
      @sRefAtr     = STR_CYCATR
    end


    #=================================================================
    #   : եե˽Ϥ륳ɺ
    #=================================================================
    def gc_config(cElement)
      check_class(IMCodeElement, cElement) # 

      if (@cConf.is_timer_local?())
        cElement.set_config("#{API_CRE_CYC}(#{@sObjectID}, {#{@hState[TSR_PRM_ATR]}, #{@hState[TSR_PRM_EXINF]}, #{@sObjectID.downcase}, #{@hState[TSR_PRM_CYCTIM]}, #{@hState[TSR_PRM_CYCPHS]}});", @hState[TSR_PRM_CLASS]) # [IMCodeElement] ϥɥŪAPI
      else
        cElement.set_config("#{API_CRE_CYC}(#{@sObjectID}, {#{@hState[TSR_PRM_ATR]}, #{@hState[TSR_PRM_EXINF]}, #{@sObjectID.downcase}, #{@hState[TSR_PRM_CYCTIM]}, #{@hState[TSR_PRM_CYCPHS]}});", @cConf.get_time_manage_class()) # [IMCodeElement] ϥɥŪAPI
      end
    end

    #=================================================================
    #   : cycatrcycstatrefΤߤcElementɲä
    #=================================================================
    def gc_obj_ref_only_cyc(cElement, hProcUnitInfo)
      check_class(IMCodeElement, cElement) # 
      check_class(Hash, hProcUnitInfo)     # ñ̾

      cElement.set_local_var(hProcUnitInfo[:id], @sRefStrVar, @sRefStrType)
      cElement.set_code(hProcUnitInfo, "", false)
      cElement.set_syscall(hProcUnitInfo, "#{@sRefAPI}(#{@sObjectID}, &#{@sRefStrVar})")

      # °
      if (!@hState[TSR_PRM_ATR].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefAtr}", @hState[TSR_PRM_ATR])
      end

      # 
      if (!@hState[TSR_PRM_STATE].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefState}", @hState[TSR_PRM_STATE])
      end
    end

  end
end
