#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Task.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/process_unit/ProcessUnit.rb"
require "ttc/bin/process_unit/Task.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Task
  #     : ξ륯饹
  #===================================================================
  class Task < ProcessUnit
    attr_reader :cTex
    attr_accessor :nStackNum

    #=================================================================
    #   : ν
    #=================================================================
    def initialize(sObjectID, hObjectInfo, aPath, bIsPre)
      check_class(String, sObjectID)  # ֥ID
      check_class(Hash, hObjectInfo)  # ֥Ⱦ
      check_class(Array, aPath)       # 롼ȤΥѥ
      check_class(Bool, bIsPre)       # pre_condition⤫

      super(sObjectID, hObjectInfo, TSR_OBJ_TASK, aPath, bIsPre)

      # ref_tsk
      @sRefAPI     = FNC_REF_TSK
      @sRefStrType = TYP_T_TTSP_RTSK
      @sRefStrVar  = GRP_VAR_TYPE[TYP_T_TTSP_RTSK]
      @sRefState   = STR_TSKSTAT
      @sRefExInf   = STR_EXINF
      @sRefPrcID   = STR_PRCID
      @sRefActPrc  = STR_ACTPRC

      @cTex      = nil
      @nStackNum = nil
    end

    #=================================================================
    #   : Ԥװ
    #=================================================================
    def set_task_wait(cObjectInfo)
      check_class(Object, cObjectInfo)  # Ԥװ֥

      case cObjectInfo.sObjectType
      when TSR_OBJ_SEMAPHORE
        @hState[TSR_PRM_TSKWAIT] = KER_TTW_SEM
      when TSR_OBJ_EVENTFLAG
        @hState[TSR_PRM_TSKWAIT] = KER_TTW_FLG
      when TSR_OBJ_MAILBOX
        @hState[TSR_PRM_TSKWAIT] = KER_TTW_MBX
      when TSR_OBJ_MEMORYPOOL
        @hState[TSR_PRM_TSKWAIT] = KER_TTW_MPF
      when TSR_OBJ_DATAQUEUE
        if (!cObjectInfo.hState[TSR_PRM_STSKLIST].nil?() && !cObjectInfo.hState[TSR_PRM_STSKLIST].empty?())
          @hState[TSR_PRM_TSKWAIT] = KER_TTW_SDTQ
        elsif (!cObjectInfo.hState[TSR_PRM_RTSKLIST].nil?() && !cObjectInfo.hState[TSR_PRM_RTSKLIST].empty?())
          @hState[TSR_PRM_TSKWAIT] = KER_TTW_RDTQ
        end
      when TSR_OBJ_P_DATAQUEUE
        if (!cObjectInfo.hState[TSR_PRM_STSKLIST].nil?() && !cObjectInfo.hState[TSR_PRM_STSKLIST].empty?())
          @hState[TSR_PRM_TSKWAIT] = KER_TTW_SPDQ
        elsif (!cObjectInfo.hState[TSR_PRM_RTSKLIST].nil?() && !cObjectInfo.hState[TSR_PRM_RTSKLIST].empty?())
          @hState[TSR_PRM_TSKWAIT] = KER_TTW_RPDQ
        end
      else
        abort(ERR_MSG % [__FILE__, __LINE__])
      end
    end


    #=================================================================
    #   : եե˽Ϥ륳ɺ
    #=================================================================
    def gc_config(cElement)
      check_class(IMCodeElement, cElement) # 

      cElement.set_config("#{API_CRE_TSK}(#{@sObjectID}, {#{KER_TA_NULL}, #{@hState[TSR_PRM_EXINF]}, #{@sObjectID.downcase}, #{@hState[TSR_PRM_ITSKPRI]}, TTSP_TASK_STACK_SIZE, #{@nStackNum ? "ttg_stack_#{@nStackNum}" : "NULL"}});", @hState[TSR_PRM_CLASS])

      # ˰¸뤿᥿㳰ϥɥʬ⤳Ǻ
      if (@cTex)
        cElement.set_config("#{API_DEF_TEX}(#{@sObjectID}, {#{KER_TA_NULL}, #{@cTex.sObjectID.downcase}});", @hState[TSR_PRM_CLASS])
      end
    end

    #=================================================================
    #   : 㳰δϢդ
    #=================================================================
    def set_tex(cTex)
      check_class(TaskExcept, cTex)  # ꤹ륿㳰饹

      @cTex = cTex
    end

  end
end
