#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2012 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#  Copyright (C) 2012 by FUJISOFT INCORPORATED
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Variable.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"
require "ttc/bin/class/TTCCommon.rb"
require "common/bin/IMCodeElement.rb"
require "ttc/bin/process_unit/Variable.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Variable
  #     : variableξ륯饹
  #===================================================================
  class Variable
    include CommonModule
    include TTCModule
    include TTCModule::ObjectCommon

    attr_accessor :sVarName, :sType, :snValue, :hMember, :aPath

    #=================================================================
    #   : variableν
    #=================================================================
    def initialize(sVarName, hVarInfo, aPath)
      check_class(Object, sVarName)        # ѿ̾(T2_001ǥåԤ)
      check_class(Object, hVarInfo, true)  # ѿ
      check_class(Array, aPath)            # 롼ȤΥѥ

      @sVarName = sVarName    # ѿ̾
      @sType    = nil         # 
      @snValue  = nil         # 
      @hMember  = nil         # ¤ΤΥ
      @aPath    = aPath + [@sVarName]

      @cConf = Config.new()

      store_var_info(hVarInfo)
    end

    #=================================================================
    #   : ƥȥʥꥪ̤variable˥ǡ
    #=================================================================
    def store_var_info(hVarInfo)
      check_class(Object, hVarInfo, true)  # ѿ

      set_specified_attribute(hVarInfo)
      if (hVarInfo.is_a?(Hash))
        # ¤ΤΥФжϥåǽ
        hVarInfo.each_key{|sKey|
          unless ((sKey == TSR_PRM_VAR_TYPE) || (sKey == TSR_PRM_VAR_VALUE))
            @hMember = {}
          end
        }

        hVarInfo.each{|atr, val|
          case atr
          when TSR_PRM_VAR_TYPE
            @sType = val
          when TSR_PRM_VAR_VALUE
            @snValue = val
          else
            @hMember[atr] = val
          end
        }
      end
    end

    #=================================================================
    # : Х/ѿѥ
    #=================================================================
    def gc_global_local_var(cElement, sObjectID)
      check_class(IMCodeElement, cElement) # 
      check_class(String, sObjectID)       # ֥ID

      # Хѿ
      # (åϰۤʤ륿ǽ뤿ᥰХѿȤ)
      if (GRP_GLOBAL_TYPE.include?(@sType))
        # ¤ΤǤʤ
        if (@hMember.nil?())
          cElement.set_global_var(@sVarName, @sType, @snValue)
        # ¤Τξ(ѿ)
        else
          sInitStr = make_initial_str()
          cElement.set_global_var(@sVarName, @sType, sInitStr)
        end

      # ѿ
      else
        # ¤ΤǤʤ
        if (@hMember.nil?())
          cElement.set_local_var(sObjectID, @sVarName, @sType, @snValue)
        # ¤Τξ(ѿ)
        else
          sInitStr = make_initial_str()
          cElement.set_local_var(sObjectID, @sVarName, @sType, sInitStr)
        end
      end
    end

    #=================================================================
    # : ¤νʸ֤
    #=================================================================
    def make_initial_str()
      # Ƥʤ¤Τηξ票顼
      if (!STR_INITIAL_INFO.has_key?(@sType))
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

      sInitStr = "{"
      STR_INITIAL_INFO[@sType].each{|aStructInfo|
        # ASPξ硤Υѿ
        if (@cConf.is_asp?())
          if ((aStructInfo[0] == STR_PRCID) || (aStructInfo[0] == STR_ACTPRC))
            next
          end
        end

        # ͤꤵƤ
        if (@hMember.has_key?(aStructInfo[0]))
          sInitStr.concat(" #{@hMember[aStructInfo[0]]},")
        # ͤꤵƤʤ
        else
          sInitStr.concat(" #{aStructInfo[2]},")
        end
      }
      sInitStr.chop!()
      sInitStr.concat(" }")

      return sInitStr # [String]¤νʸ
    end

    #=================================================================
    # : ѿѥ
    #=================================================================
    def gc_assert_value(cElement, hProcUnitInfo)
      check_class(IMCodeElement, cElement) # 
      check_class(Hash, hProcUnitInfo)     # ñ̾

      # ѿͤꤵƤ
      if (@hMember.nil?() && !@snValue.nil?())
        cElement.set_assert(hProcUnitInfo, @sVarName, @snValue)
      # ¤ΤꤵƤ
      elsif (!@hMember.nil?())
        @hMember.each{|name, val|
          cElement.set_assert(hProcUnitInfo, "#{@sVarName}.#{name}", val)
        }
      end
    end

  end
end
