#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: CPUState.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"
require "common/bin/Config.rb"
require "common/bin/IMCodeElement.rb"
require "ttc/bin/sys_state/CPUState.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: CPUState
  #     : CPU֤ξ륯饹
  #===================================================================
  class CPUState
    include CommonModule

    attr_accessor :hState, :sObjectID, :sObjectType

    #=================================================================
    #   : CPU֤ν
    #=================================================================
    def initialize(sObjectID, hObjectInfo, aPath, bIsPre)
      check_class(String, sObjectID)  # ֥ID
      check_class(Hash, hObjectInfo)  # ֥Ⱦ
      check_class(Array, aPath)       # 롼ȤΥѥ
      check_class(Bool, bIsPre)       # pre_condition⤫

      @cConf  = Config.new()
      @hState = {}

      @sObjectID   = sObjectID
      @sObjectType = TSR_OBJ_CPU_STATE
      @aPath       = aPath + [@sObjectID]

      @hState[TSR_PRM_LOCCPU] = nil  # CPUå
      @hState[TSR_PRM_DISDSP] = nil  # ǥѥåػ߾
      @hState[TSR_PRM_CHGIPM] = nil  # ͥ٥ޥ
      @hState[TSR_PRM_PRCID]  = nil  # ץåID

      pre_attribute_check(hObjectInfo, aPath + [@sObjectID], bIsPre)
      store_object_info(hObjectInfo)
    end

    #=================================================================
    #   : ƥȥʥꥪCPU֥ǡ@hState
    #=================================================================
    def store_object_info(hObjectInfo)
      check_class(Hash, hObjectInfo)  # ֥Ⱦ

      # Ǽ
      set_specified_attribute(hObjectInfo)
      hObjectInfo.each{|atr, val|
        if (atr != TSR_PRM_TYPE)
          @hState[atr] = val
        end
      }
    end

    #=================================================================
    #   : CPU֤򻲾Ȥ륳ɤcElement˳Ǽ
    #=================================================================
    def gc_obj_ref(cElement, hProcUnitInfo)
      check_class(IMCodeElement, cElement) # 
      check_class(Hash, hProcUnitInfo)     # ñ̾

      # CPUå
      cElement.set_syscall(hProcUnitInfo, "#{API_SNS_LOC}()", @hState[TSR_PRM_LOCCPU], TYP_BOOL_T)

      # ǥѥåػ߾
      cElement.set_syscall(hProcUnitInfo, "#{API_SNS_DSP}()", @hState[TSR_PRM_DISDSP], TYP_BOOL_T)

      # ͥ٥ޥ
      cElement.set_local_var(hProcUnitInfo[:id], VAR_INTPRI, TYP_PRI)
      cElement.set_syscall(hProcUnitInfo, "#{FNC_GET_IPM}(&#{VAR_INTPRI})")
      cElement.set_assert(hProcUnitInfo, VAR_INTPRI, @hState[TSR_PRM_CHGIPM])
    end

    #=================================================================
    #   : ץåID֤
    #=================================================================
    def get_process_id()
      return @hState[TSR_PRM_PRCID] == nil ? 1 : @hState[TSR_PRM_PRCID] # [Integer]ץåID
    end
  end
end
