#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Condition.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"
require "common/bin/Config.rb"
require "common/bin/process_unit/Task.rb"
require "common/bin/process_unit/Alarm.rb"
require "common/bin/process_unit/Cyclic.rb"
require "common/bin/process_unit/TaskExcept.rb"
require "common/bin/process_unit/IntHdr.rb"
require "common/bin/process_unit/ISR.rb"
require "common/bin/process_unit/Execption.rb"
require "common/bin/process_unit/IniRtn.rb"
require "common/bin/process_unit/TerRtn.rb"
require "common/bin/sc_object/Semaphore.rb"
require "common/bin/sc_object/Eventflag.rb"
require "common/bin/sc_object/Dataqueue.rb"
require "common/bin/sc_object/PriDataQ.rb"
require "common/bin/sc_object/Mailbox.rb"
require "common/bin/sc_object/MemPFix.rb"
require "common/bin/sc_object/Spinlock.rb"
require "common/bin/sys_state/CPUState.rb"
require "common/bin/IMCodeElement.rb"
require "ttc/bin/test_scenario/Condition.rb"
require "ttj/bin/test_scenario/Condition.rb"
require "bin/builder/fmp_builder/test_scenario/Condition.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Condition
  #     : pre_condition, post_conditionξ륯饹
  #===================================================================
  class Condition
    include CommonModule

    attr_reader :hAllObject, :sTestMain, :hTask, :cActivate, :aActivate, :cRunning, :aRunning
    attr_reader :bIsIniRtn, :bIsTerRtn, :bIsIntHdr, :bIsISR, :bIsException, :lMainTaskState

    #=================================================================
    #   : 󥹥ȥ饯
    #=================================================================
    def initialize(sTestID)
      check_class(String, sTestID)        # ƥID

      @hAllObject = {}                 # 줿֥Ȥξݻ뤿Υϥå
      @cConf      = Config.new()       # եμ
      @sTestID    = sTestID
      @sTestMain  = sTestID + "_main"  # ᥤؿ̾

      @hMainTaskInfo = {               # ᥤ󥿥
        :id      => @sTestMain,
        :prcid   => @cConf.get_main_prcid(),
        :bootcnt => TTG_MAIN_BOOTCNT
      }

      @bIsIniRtn    = false    # 롼̵ͭ
      @bIsTerRtn    = false    # λ롼̵ͭ
      @bIsIntHdr    = false    # ߥϥɥ̵ͭ
      @bIsISR       = false    # ߥӥ롼̵ͭ
      @bIsException = false    # CPU㳰ϥɥ̵ͭ

      @bGcovAll = false  # GCOVե饰

      # FMP
      @sMainPrcid  = @cConf.get_main_prcid() # ᥤץåID
      nPrcNum      = @cConf.get_prc_num()    # ץå
      @aPrcid      = (1..nPrcNum).to_a()     # ץå롼פΤ
      @bPassed     = false
      @aSpinProcID = []                      # ԥåƤñID

    end

    #=================================================================
    #   : ƥ֥Ȥ
    #=================================================================
    def store_condition_info(hCondition, hObjectType)
      check_class(Hash, hCondition)  # ǥ
      check_class(Hash, hObjectType) # ֥ȥ

      # ֥
      aErrors = []
      aPath = get_condition_path()
      bIsPre  = (self.class() == PreCondition)
      hCondition.each{|sObjectID, hObjectInfo|
        ### T5_001: post_conditionpre_conditionƤʤ֥ID¸ߤ
        unless (hObjectType.has_key?(sObjectID))
          sErr = sprintf("T5_001: " + ERR_OBJECT_NOT_DEFINED_IN_PRE, sObjectID)
          aErrors.push(YamlError.new(sErr, aPath))
        else
          begin
            sObjectType = hObjectType[sObjectID]
            case sObjectType
            when TSR_OBJ_TASK
              cNewObject = Task.new(sObjectID, hObjectInfo, aPath, bIsPre)
            when TSR_OBJ_ALARM
              cNewObject = Alarm.new(sObjectID, hObjectInfo, aPath, bIsPre)
            when TSR_OBJ_CYCLE
              cNewObject = Cyclic.new(sObjectID, hObjectInfo, aPath, bIsPre)
            when TSR_OBJ_TASK_EXC
              cNewObject = TaskExcept.new(sObjectID, hObjectInfo, aPath, bIsPre)
            when TSR_OBJ_SEMAPHORE
              cNewObject = Semaphore.new(sObjectID, hObjectInfo, aPath, bIsPre)
            when TSR_OBJ_EVENTFLAG
              cNewObject = Eventflag.new(sObjectID, hObjectInfo, aPath, bIsPre)
            when TSR_OBJ_DATAQUEUE
              cNewObject = Dataqueue.new(sObjectID, hObjectInfo, aPath, bIsPre)
            when TSR_OBJ_P_DATAQUEUE
              cNewObject = PriDataQ.new(sObjectID, hObjectInfo, aPath, bIsPre)
            when TSR_OBJ_MAILBOX
              cNewObject = Mailbox.new(sObjectID, hObjectInfo, aPath, bIsPre)
            when TSR_OBJ_MEMORYPOOL
              cNewObject = MemPFix.new(sObjectID, hObjectInfo, aPath, bIsPre)
            when TSR_OBJ_CPU_STATE
              cNewObject = CPUState.new(sObjectID, hObjectInfo, aPath, bIsPre)
            when TSR_OBJ_SPINLOCK
              cNewObject = Spinlock.new(sObjectID, hObjectInfo, aPath, bIsPre)
            when TSR_OBJ_INTHDR
              cNewObject = IntHdr.new(sObjectID, hObjectInfo, aPath, bIsPre)
              @bIsIntHdr = true
            when TSR_OBJ_ISR
              cNewObject = ISR.new(sObjectID, hObjectInfo, aPath, bIsPre)
              @bIsISR = true
            when TSR_OBJ_EXCEPTION
              cNewObject = CPUException.new(sObjectID, hObjectInfo, aPath, bIsPre)
              @bIsException = true
            when TSR_OBJ_INIRTN
              cNewObject = IniRtn.new(sObjectID, hObjectInfo, aPath, bIsPre)
              @bIsIniRtn = true
            when TSR_OBJ_TERRTN
              cNewObject = TerRtn.new(sObjectID, hObjectInfo, aPath, bIsPre)
              @bIsTerRtn = true
            else
              abort(ERR_MSG % [__FILE__, __LINE__])
            end

            # 줿֥Ȥ@hAllObjectݻ
            @hAllObject[sObjectID] = cNewObject
          # ֥ȯ顼ޤȤ
          rescue TTCMultiError
            aErrors.concat($!.message())
          end
        end
      }

      check_error(aErrors)
    end

    #=================================================================
    # : 󥹥ѿ
    #=================================================================
    def init_instance_variables()
      @hTask       = get_objects_by_type(TSR_OBJ_TASK)   # ΥꥹȺ
      @hWaitObject = get_objects_by_type(GRP_SC_OBJECT)  # Ԥ֥ȤΥꥹȺ

      # ȥ㳰δϢդ
      @hAllObject.each{|key, val|
        if (val.sObjectType == TSR_OBJ_TASK_EXC)
          sObjectID = val.hState[TSR_PRM_TASK]
          unless (@hAllObject[sObjectID].nil?())
            @hAllObject[sObjectID].set_tex(val)
            # Ϣγĥ򥿥㳰饹ˤϿ(assert)
            val.hState[TSR_PRM_EXINF] = @hAllObject[sObjectID].hState[TSR_PRM_EXINF]
            # Ϣprcid򥿥㳰饹ˤϿ(FMP)
            val.hState[TSR_PRM_PRCID] = @hAllObject[sObjectID].hState[TSR_PRM_PRCID]
          end
        end
      }

      # Ԥװ°
      @hTask.each{|sObjectID, cObjectInfo|
        # Ԥоݤ֥ȤξΤ
        if (cObjectInfo.has_wait_object?())
          cObjectInfo.set_task_wait(@hAllObject[cObjectInfo.hState[TSR_PRM_WOBJID]])
        end
      }

      # asp
      if (@cConf.is_asp?())
        @cCpuState = get_cpu_state()
        @cActivate = get_activate()
        @cRunning  = get_running()
      # fmp
      elsif (@cConf.is_fmp?())
        @aTask = []
        @hTask.each{ |key, val|
          @aTask.push([val.hState[TSR_PRM_PRCID], key, val])
        }

        @aCpuState = get_cpu_state_fmp()
        @aActivate = get_activate_fmp()
        @aRunning  = get_running_fmp()
        # cϤϥᥤץåIDΤΤؤ褦
        @cCpuState = @aCpuState[@sMainPrcid]
        @cRunning  = @aRunning[@sMainPrcid]
        @cActivate = @aActivate[@sMainPrcid]
      end
    end

    #=================================================================
    # : ꤷפ˰פ륪֥Ȥ
    #=================================================================
    def get_objects_by_type(saType)
      check_class([String, Array], saType)  # ֥ȥ

      # ʸξˤ
      if (saType.is_a?(String))
        saType = saType.to_a()
      end
      # ֥Ⱦ󤫤鳺륿פΥ֥ȤȴФ
      hResult = @hAllObject.reject{|sObjectID, cObjectInfo|
        !(saType.include?(cObjectInfo.sObjectType))
      }

      return hResult # [Hash]֥ȤΥϥå
    end

    #=================================================================
    #   : ֥IDǳΥ֥Ȥξõ֤
    #=================================================================
    def get_object_info(sObjectID)
      check_class(String, sObjectID)

      return @hAllObject[sObjectID] # [Object]֥ȥ饹
    end

    #=================================================================
    #   : ¹󥿥Τfalse
    #         ¹󥿥Τʤtrue֤
    #=================================================================
    def check_activate_context()
      if (@cActivate.nil?())
        return true # [Bool]󥿥
      else
        return false # [Bool]󥿥ʤ
      end
    end

    #=================================================================
    #   : ¹Υ֤
    #         (ACTIVATEʥ㳰ϢդƤϥ㳰֤)
    #=================================================================
    def get_running()
      @hTask.each{|sObjectID, cObjectInfo|
        if ((cObjectInfo.sObjectType == TSR_OBJ_TASK) && GRP_ACTIVATE.include?(cObjectInfo.hState[TSR_PRM_STATE]))
          if (!cObjectInfo.cTex.nil?() && GRP_ACTIVATE.include?(cObjectInfo.cTex.hState[TSR_PRM_HDLSTAT]))
            return cObjectInfo.cTex # [TaskExcept]¹Υ㳰
          else
            return cObjectInfo # [Task]¹Υ
          end
        end
      }

      return nil
    end

    #=================================================================
    #   : ¹νñ̤֤
    #         顼ϥɥ > ϥɥ > 
    #=================================================================
    def get_activate()
      @hAllObject.each{|sObjectID, cObjectInfo|
        if (GRP_NON_CONTEXT.include?(cObjectInfo.sObjectType) && GRP_ACTIVATE.include?(cObjectInfo.hState[TSR_PRM_HDLSTAT]))
          return cObjectInfo # [Object] ¹νñ
        end
      }

      return nil
    end

    #=================================================================
    #   : CPU_STATE֤
    #=================================================================
    def get_cpu_state()
      @hAllObject.each{|sObjectID, cObjectInfo|
        if (cObjectInfo.sObjectType == TSR_OBJ_CPU_STATE)
          return cObjectInfo
        end
      }

      return nil
    end

    #=================================================================
    #   : ¹νñ̤֤
    #=================================================================
    def get_prev_actvate_running()
      if (!@cActivate.nil?())
        return @cActivate # [Object] ưνñ
      else
        return @cRunning # [Object] ¹νñ
      end
    end

    #=================================================================
    #   : ɬפʥ֥ȾޤȤ֤
    #=================================================================
    def get_proc_unit_info(cFristObject = nil, cSecondObject = nil)
      check_class(ProcessUnit, cFristObject, true)
      check_class(ProcessUnit, cSecondObject, true)

      hProcUnitInfo = {}

      if (!cFristObject.nil?())
        cObjectTemp = cFristObject
      elsif (!cSecondObject.nil?())
        cObjectTemp = cSecondObject
      else
        return @hMainTaskInfo # [Hash] ɬפʽñ̾
      end

      hProcUnitInfo.store(:id, cObjectTemp.sObjectID)
      hProcUnitInfo.store(:prcid, cObjectTemp.hState[TSR_PRM_PRCID])
      hProcUnitInfo.store(:bootcnt, cObjectTemp.hState[TSR_PRM_BOOTCNT])

      return hProcUnitInfo # [Hash] ɬפʽñ̾
    end

    #=================================================================
    #   : ǥѥåػ߾֤ξtrue
    #         Ǥʤfalse֤
    #=================================================================
    def check_dis_dsp()
      if (!@cCpuState.nil?() && !@cCpuState.hState[TSR_PRM_DISDSP].nil?() && (@cCpuState.hState[TSR_PRM_DISDSP] == true))
        return true # [Bool]ǥѥåػߤξ
      end

      return false # [Bool]ǥѥåػߤǤʤ
    end

    #=================================================================
    #   : ͥ٥ޥǤϤʤtrue
    #         Ǥʤfalse֤
    #=================================================================
    def check_chg_ipm()
      if (!@cCpuState.nil?() && !@cCpuState.hState[TSR_PRM_CHGIPM].nil?() && 
          (@cCpuState.hState[TSR_PRM_CHGIPM] != 0) && (@cCpuState.hState[TSR_PRM_CHGIPM] != KER_TIPM_ENAALL))
        return true # [Bool]ͥ٥ޥǤϤʤ
      end

      return false # [Bool]ͥ٥ޥξ
    end

    #=================================================================
    #   : CPUå֤ξtrue򡤤Ǥʤfalse֤
    #=================================================================
    def check_cpu_loc()
      unless (@cCpuState.nil?() || @cCpuState.hState[TSR_PRM_LOCCPU].nil?() || (@cCpuState.hState[TSR_PRM_LOCCPU] != true))
        return true # [Bool] CPUå֤ξ
      end

      return false # [Bool] CPUå֤ǤϤʤ
    end

    #=================================================================
    #   : ߼¹Ծ֤ΥϾ֤ξtrue
    #         Ǥʤfalse֤
    #=================================================================
    def check_run_sus()
      if (!@cRunning.nil?())
        if (((@cRunning.sObjectType == TSR_OBJ_TASK) && (@cRunning.hState[TSR_PRM_STATE] == KER_TTS_RUS)) ||
            ((@cRunning.sObjectType == TSR_OBJ_TASK_EXC) && (get_object_info(@cRunning.hState[TSR_PRM_TASK]).hState[TSR_PRM_STATE] == KER_TTS_RUS)))
          return true # [Bool] ߼¹Ծ֤ΥϾ֤ξ
        end
      end

      return false # [Bool] ߼¹Ծ֤ΥϾ֤ǤϤʤ
    end

    #=================================================================
    #   : ߼¹Ծ֤Υꤷͥ٤ξtrue
    #         Ǥʤfalse֤
    #=================================================================
    def check_running_pri(nTaskPri)
      check_class(Integer, nTaskPri)  # åͥ

      if (!@cRunning.nil?())
        # ξ
        if ((@cRunning.sObjectType == TSR_OBJ_TASK) && (@cRunning.hState[TSR_PRM_TSKPRI] == nTaskPri))
          return true # [Bool] ߼¹Ծ֤Υꤷͥ٤ξ

        # 㳰ξ
        elsif (@cRunning.sObjectType == TSR_OBJ_TASK_EXC)
          cObjectInfo = get_object_info(@cRunning.hState[TSR_PRM_TASK])
          if (cObjectInfo.hState[TSR_PRM_TSKPRI] == nTaskPri)
            return true # [Bool] ߼¹Ծ֤Υꤷͥ٤ξ
          end
        end
      end

      return false # [Bool] ߼¹Ծ֤Υꤷͥ٤ǤϤʤ
    end

    #=================================================================
    #   : ư֡Txxx_STAˤΥ।٥ȥϥɥ餬
    #         true򡤤Ǥʤfalse֤
    #=================================================================
    def exist_time_event_sta()
      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((GRP_TIME_EVENT_HDL.include?(cObjectInfo.sObjectType) == true) &&
            (GRP_TIME_EVENT_STA.include?(cObjectInfo.hState[TSR_PRM_STATE]) == true))
          return true # [Bool] ư֡Txxx_STAˤΥ।٥ȥϥɥ餬
        end
      }

      return false # [Bool] ư֡Txxx_STAˤΥ।٥ȥϥɥ餬ʤ
    end

    #=================================================================
    #   : ľ֤γߥϥɥ顤ߥӥ롼󤬤
    #         true򡤤Ǥʤfalse֤
    #=================================================================
    def exist_interrupt_ena()
      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((GRP_INTERRUPT.include?(cObjectInfo.sObjectType) == true) && (cObjectInfo.hState[TSR_PRM_STATE] == KER_TA_ENAINT))
          return true # [Bool] ľ֤γߥϥɥ顤ߥӥ롼󤬤
        end
      }

      return false # [Bool] ľ֤γߥϥɥ顤ߥӥ롼󤬤ʤ
    end

    #=================================================================
    #   : ¹Ծ֤Υ򸡺Ƥtrue
    #         ʤfalse֤
    #=================================================================
    def exist_task_running()
      @hTask.each{|sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RUN)
          return true # [Bool] ¹Ծ֤Υ򸡺Ƥ
        end
      }

      return false # [Bool] ¹Ծ֤Υ򸡺Ƥʤ
    end

    #=================================================================
    #   : ư󥿥Τtrue
    #         ʤfalse֤
    #=================================================================
    def exist_nontask_activate()
      if (!@cActivate.nil?())
        return true # [Bool]ư󥿥Τ
      else
        return false # [Bool]ư󥿥Τʤ
      end
    end

    #=================================================================
    #   : ư׵ᥭ塼󥰤򤷤Ƥtrue
    #         Ǥʤfalse֤
    #=================================================================
    def exist_task_queueing()
      @hTask.each{|sObjectID, cObjectInfo|
        if (!cObjectInfo.hState[TSR_PRM_ACTCNT].nil?() && cObjectInfo.hState[TSR_PRM_ACTCNT] >= 1 || !cObjectInfo.hState[TSR_PRM_WUPCNT].nil?() && cObjectInfo.hState[TSR_PRM_WUPCNT] >= 1)
          return true # [Bool] ư׵ᥭ塼󥰤򤷤Ƥ
        end
      }

      return false # [Bool] ư׵ᥭ塼󥰤򤷤Ƥʤ

    end

    #=================================================================
    #   : ֤ʤcElement˳Ǽ
    #=================================================================
    def gc_tick_gain(cElement)
      check_class(IMCodeElement, cElement) # 

      hProcUnitInfo = get_proc_unit_info(@cRunning)

      # ֤ʤ˥åݥ
      cElement.set_checkpoint(hProcUnitInfo)
      # ASPǤϥƥﹹǧؿѤ
      cElement.set_code(hProcUnitInfo, "#{FNC_TARGET_GAIN_TICK}()")
    end

    #=================================================================
    #   : ֥ȤrefIMCodeElement饹ˤޤȤ
    #         
    #=================================================================
    def gc_obj_ref()
      cElement      = IMCodeElement.new()
      hProcUnitInfo = get_proc_unit_info(@cActivate, @cRunning)

      # Ƚ
      if (@nSeqNum.nil?() && @nTimeTick.nil?())
        cElement.set_comment(hProcUnitInfo, "#{TSR_LBL_PRE}")
      else
        cElement.set_comment(hProcUnitInfo, "#{TSR_UNS_POST}#{@nSeqNum}_#{@nTimeTick}")
      end

      # 㳰ACTIAVTEä硤texptn/exinfȰפƤ뤳Ȥǧ륳ɤ
      if (@cActivate.nil?() && !@cRunning.nil?() && @cRunning.sObjectType == TSR_OBJ_TASK_EXC)
        @cRunning.gc_assert_texptn_exinf(cElement, hProcUnitInfo)
      end

      # ߥӥ롼ACTIAVTEä硤exinfȰפƤ뤳Ȥǧ륳ɤ
      if (!@cActivate.nil?() && @cActivate.sObjectType == TSR_OBJ_ISR)
        @cActivate.gc_assert_exinf(cElement, hProcUnitInfo)
      end

      # ¹νñ̤ͤꤵ줿ѿСפƤ뤳Ȥǧ륳ɤ
      if (!@cActivate.nil?() && !@cActivate.hState[TSR_PRM_VAR].nil?())
        @cActivate.gc_assert_value(cElement, hProcUnitInfo)
      elsif (!@cRunning.nil?() && !@cRunning.hState[TSR_PRM_VAR].nil?())
        @cRunning.gc_assert_value(cElement, hProcUnitInfo)
      end

      # CPU_STATEcpu_lockäƤ뤫򻲾
      bCpuLock = false

      if (!@cCpuState.nil?() && (@cCpuState.hState[TSR_PRM_LOCCPU] == true))
        bCpuLock = true
      end

      # ֥Ȥref_codeޤȤ
      @hAllObject.each{|sObjectID, cObjectInfo|
        case cObjectInfo.sObjectType
        when TSR_OBJ_CPU_STATE
          cObjectInfo.gc_obj_ref(cElement, hProcUnitInfo)

        when TSR_OBJ_TASK_EXC
          # 㳰ϴϢդ줿ٻ߾֤ξ硤ȤǤʤ
          cTask = get_object_info(cObjectInfo.hState[TSR_PRM_TASK])
          if (cTask.hState[TSR_PRM_STATE] != KER_TTS_DMT)
            cObjectInfo.gc_obj_ref(cElement, hProcUnitInfo, check_activate_context(), bCpuLock)
          end

        # ֤򻲾ȤǤʤñ̤ξ硤⤷ʤ
        when TSR_OBJ_INTHDR, TSR_OBJ_ISR, TSR_OBJ_EXCEPTION, TSR_OBJ_INIRTN, TSR_OBJ_TERRTN

        else
          cObjectInfo.gc_obj_ref(cElement, hProcUnitInfo, check_activate_context(), bCpuLock)

        end
      }

      cElement.set_checkpoint(hProcUnitInfo)

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : ꤷפ֥Ȥξ֤
    #=================================================================
    def get_all_object_info(sObjectType)
      check_class(String, sObjectType) # оݤȤ륪֥ȥ

      hObjectInfo = Hash.new()
      # 륪֥ȤξǼ
      @hAllObject.each{|sObjectID, cObjectInfo|
        if (cObjectInfo.sObjectType == sObjectType)
          hObjectInfo[sObjectID] = cObjectInfo
        end
      }

      return hObjectInfo # [Hash]֥Ⱦϥå
    end

    #=================================================================
    #   : ACTIVATEǤꤷñ̤ID֤
    #=================================================================
    def get_activate_proc_unit_id(sObjectType)
      check_class(String, sObjectType) # оݤȤ륪֥ȥ

      aProcUnitID = Array.new()

      # ACTIVATEǤñ̤ξǼ
      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((cObjectInfo.sObjectType == sObjectType) &&
            (cObjectInfo.hState[TSR_PRM_HDLSTAT] == TSR_STT_ACTIVATE))
          aProcUnitID.push(sObjectID)
        end
      }

      return aProcUnitID # [Array]ACTIVATEǤñID
    end

    #=================================================================
    #   : GCOVե饰ꤹ
    #=================================================================
    def set_gcov_all_flg(bFlg)
      check_class(Bool, bFlg) # ꤹGCOVե饰

      @bGcovAll = bFlg
    end

  end
end
