#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Do_PostCondition.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/test_scenario/Condition.rb"
require "ttc/bin/test_scenario/Do_PostCondition.rb"
require "ttj/bin/test_scenario/Do_PostCondition.rb"
require "bin/builder/fmp_builder/test_scenario/Do_PostCondition.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Do_PostCondition
  #     : dopost_conditionξ륯饹
  #===================================================================
  class Do_PostCondition < Condition
    include CommonModule

    attr_accessor :hDo
    attr_reader :nSeqNum, :nTimeTick

    #=================================================================
    #   : dopost_conditionν
    #=================================================================
    def initialize(sTestID, hScenarioDo, hScenarioPost, nSeqNum, nTimeTick, cPreCondition)
      check_class(String, sTestID)              # ƥID
      check_class(Hash, hScenarioDo, true)      # do
      check_class(Hash, hScenarioPost, true)    # post_condition
      check_class(Integer, nSeqNum)             # ֹ
      check_class(Integer, nTimeTick)           # ƥå
      check_class(PreCondition, cPreCondition)  # PreCondition

      @nSeqNum                = nSeqNum
      @nTimeTick              = nTimeTick
      @cCallerObject          = nil        # APIȯԥ֥
      @hDo                    = {}
      @aSpecifiedDoAttributes = []

      super(sTestID)

      # ¤å
      aErrors = []
      begin
        basic_post_check(hScenarioPost)
      rescue TTCMultiError
        aErrors.concat($!.message())
      end
      check_error(aErrors)

      # 䴰
      if (hScenarioDo.nil?())
        hScenarioDo = {}
      end
      if (hScenarioPost.nil?())
        hScenarioPost = {}
      end
      pre_attribute_check(hScenarioDo)

      # 顼ʤdopost_conditionξǼ
      store_do_info(hScenarioDo, cPreCondition)
      store_condition_info(hScenarioPost, cPreCondition.hObjectType)
    end

    #=================================================================
    #   : doξǼ
    #=================================================================
    def store_do_info(hScenarioDo, cPreCondition)
      check_class(Hash, hScenarioDo)            # do
      check_class(PreCondition, cPreCondition)  # PreCondition

      # Ǽ
      @aSpecifiedDoAttributes = hScenarioDo.keys()
      hScenarioDo.each{|atr, val|
        case atr
        when TSR_PRM_ID
          @hDo[atr] = val
          @cCallerObject = cPreCondition.hAllObject[val]

        else
          @hDo[atr] = val
        end
      }
    end


    #=================================================================
    #   : ñ̾ޤȤƥȤȤ֤
    #=================================================================
    def get_proc_units(cElement)
      @hAllObject.each{|sObjectID, cObjectInfo|
        if (GRP_PROCESS_UNIT.include?(cObjectInfo.sObjectType))
          cElement.set_proc_unit(sObjectID, cObjectInfo.hState[TSR_PRM_BOOTCNT])
        end
      }
    end

    #=================================================================
    #   : DoνIMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_do(cPrevObjectInfo)
      check_class(ProcessUnit, cPrevObjectInfo) # Υǥ

      cElement = IMCodeElement.new()

      hProcUnitInfo = get_proc_unit_info(cPrevObjectInfo)

      # id˵ܤIDȰפƤ뤳Ȥǧ
      if (hProcUnitInfo[:id] != @hDo[TSR_PRM_ID])
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

      # Ƚ
      cElement.set_comment(hProcUnitInfo, "#{TSR_UNS_DO}#{@nSeqNum}_#{@nTimeTick}")
      # GCOVγϤ⤷ϺƳ
      gc_gcov_resume(cElement, hProcUnitInfo)

      # syscall
      bIsReturn = true
      if (@hDo.has_key?(TSR_PRM_SYSCALL))
        if (@hDo.has_key?(TSR_PRM_ERCD))
          cElement.set_syscall(hProcUnitInfo, @hDo[TSR_PRM_SYSCALL], @hDo[TSR_PRM_ERCD])
        elsif (@hDo.has_key?(TSR_PRM_ERUINT))
          cElement.set_syscall(hProcUnitInfo, @hDo[TSR_PRM_SYSCALL], @hDo[TSR_PRM_ERUINT], TYP_ER_UINT)
        elsif (@hDo.has_key?(TSR_PRM_BOOL))
          cElement.set_syscall(hProcUnitInfo, @hDo[TSR_PRM_SYSCALL], @hDo[TSR_PRM_BOOL], TYP_BOOL_T)
        else
          cElement.set_syscall(hProcUnitInfo, @hDo[TSR_PRM_SYSCALL], nil)
          bIsReturn = false
        end
      else
        # "#"Ϥޤ륳ɤϥߥͿʤ
        bSemicolon = true
        if (@hDo[TSR_PRM_CODE] =~ /^\#.*/)
          bSemicolon = false
        end
        cElement.set_code(hProcUnitInfo, @hDo[TSR_PRM_CODE], bSemicolon)
        bIsReturn = false
      end

      # GCOV
      if (bIsReturn == true)
        # ͤ硤¹Ծ֤ˤʤ뤿APIȯԤñ̤ǹԤ
        gc_gcov_pause(cElement, hProcUnitInfo)
      else
        # ̵ͤ硤doθǼ¹νñ̤Ԥ
        gc_gcov_pause(cElement, get_proc_unit_info(@cActivate, @cRunning))
      end

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : gcovϤνIMCodeElement饹ɲä
    #         ֤
    #=================================================================
    def gc_gcov_resume(cElement, hProcUnitInfo)
      check_class(IMCodeElement, cElement) # IMCodeElement饹Υ󥹥
      check_class(Hash, hProcUnitInfo)     # ¹Ԥñ̾

      if (@cConf.enable_gcov?() && (@hDo[TSR_PRM_GCOV] == true) && (@bGcovAll == false))
        cElement.set_code(hProcUnitInfo, FNC_GCOV_TTG_C_RESUME)
      end
    end

    #=================================================================
    #   : gcovǤνIMCodeElement饹ɲä֤
    #=================================================================
    def gc_gcov_pause(cElement, hProcUnitInfo)
      check_class(IMCodeElement, cElement) # IMCodeElement饹Υ󥹥
      check_class(Hash, hProcUnitInfo)     # ¹Ԥñ̾

      if (@cConf.enable_gcov?() && (@hDo[TSR_PRM_GCOV] == true) && (@bGcovAll == false))
        cElement.set_code(hProcUnitInfo, FNC_GCOV_TTG_C_PAUSE)
      end
    end

    #=================================================================
    #   : CPUå֤βν
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_lastpost_cpu_unl()
      cElement = IMCodeElement.new()
      hProcUnitInfo = get_proc_unit_info(@cActivate, @cRunning)

      if (!@cActivate.nil?())
        cElement.set_syscall(hProcUnitInfo, "#{API_IUNL_CPU}()")
      else
        cElement.set_syscall(hProcUnitInfo, "#{API_UNL_CPU}()")
      end

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : Ǹθ֤ǥᥤ󥿥򵯤ɤ֤
    #=================================================================
    def gc_lastpost_maintask_wup(lPrevMainTaskState)
      cElement = IMCodeElement.new()

      # ֤ǥᥤ󥿥¹Ծ֤ξ
      if (lPrevMainTaskState == :running)
        # ᥤ󥿥¹Ǥ뤿ᡤ⤷ʤ

      # ֤ǥᥤ󥿥¹Ծ֤ξ
      elsif (lPrevMainTaskState == :ready)
        if (!@cRunning.nil?())
          cElement.set_syscall(get_proc_unit_info(@cRunning), "#{API_CHG_PRI}(#{TTG_MAIN_TASK}, #{TTG_MAIN_PRI})")
          if (check_running_pri(TTG_MAIN_PRI) == true)
            cElement.set_syscall(get_proc_unit_info(@cRunning), "#{API_ROT_RDQ}(#{TTG_MAIN_PRI})")
          end

          # ᥤץåͥ٤TTG_MAIN_PRIƱreadyΥ硤rot_rdqȯԤƥǥѥå
          @hTask.each{|sObjectID, cObjectInfo|
            if ((cObjectInfo.hState[TSR_PRM_PRCID] == @sMainPrcid) && (cObjectInfo.hState[TSR_PRM_TSKPRI] == TTG_MAIN_PRI) && (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RDY))
              cElement.set_syscall(get_proc_unit_info(cObjectInfo), "#{API_ROT_RDQ}(#{TTG_MAIN_PRI})")
            end
          }
        end

      # ֤ǥᥤ󥿥Ԥ֤ξ
      elsif (lPrevMainTaskState == :sleep)
        if (!@cRunning.nil?())
          cElement.set_syscall(get_proc_unit_info(@cRunning), "#{API_WUP_TSK}(#{TTG_MAIN_TASK})")
          cElement.set_syscall(get_proc_unit_info(@cRunning), "#{API_CHG_PRI}(#{TTG_MAIN_TASK}, #{TTG_MAIN_PRI})")
          if (check_running_pri(TTG_MAIN_PRI) == true)
            cElement.set_syscall(get_proc_unit_info(@cRunning), "#{API_ROT_RDQ}(#{TTG_MAIN_PRI})")
          end

          # ᥤץåͥ٤TTG_MAIN_PRIƱreadyΥ硤rot_rdqȯԤƥǥѥå
          @hTask.each{|sObjectID, cObjectInfo|
            if ((cObjectInfo.hState[TSR_PRM_PRCID] == @sMainPrcid) && (cObjectInfo.hState[TSR_PRM_TSKPRI] == TTG_MAIN_PRI) && (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RDY))
              cElement.set_syscall(get_proc_unit_info(cObjectInfo), "#{API_ROT_RDQ}(#{TTG_MAIN_PRI})")
            end
          }

        elsif (!@cActivate.nil?())
          cElement.set_syscall(get_proc_unit_info(@cActivate), "#{API_IWUP_TSK}(#{TTG_MAIN_TASK})")

        # ᥤ󥿥򵯾Ǥñ̤ʤ
        else
          abort(ERR_MSG % [__FILE__, __LINE__])
        end

      else
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : ǥѥåػ߾֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_lastpost_ena_dsp()
      cElement      = IMCodeElement.new()
      hProcUnitInfo = get_proc_unit_info(@cRunning)

      cElement.set_syscall(hProcUnitInfo, "#{API_ENA_DSP}()")

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : ͥ٥ޥ
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_lastpost_set_ini_ipm()
      cElement      = IMCodeElement.new()
      hProcUnitInfo = get_proc_unit_info(@cRunning)

      cElement.set_syscall(hProcUnitInfo, "#{API_CHG_IPM}(#{KER_TIPM_ENAALL})")

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : ư֤Υ।٥ȥϥɥ߽Υɤ
    #         IMCodeElement饹ˤޤȤ֤
    #         (Χᥤ󥿥¹Ԥ)
    #=================================================================
    def gc_lastpost_time_event_stp()
      cElement      = IMCodeElement.new()
      hProcUnitInfo = get_proc_unit_info()

      @hAllObject.each{|sObjectID, cObjectInfo|
        if (cObjectInfo.sObjectType == TSR_OBJ_ALARM)
          cElement.set_syscall(hProcUnitInfo, "#{API_STP_ALM}(#{sObjectID})")
        elsif (cObjectInfo.sObjectType == TSR_OBJ_CYCLE)
          cElement.set_syscall(hProcUnitInfo, "#{API_STP_CYC}(#{sObjectID})")
        end
      }

      cElement.set_checkpoint(hProcUnitInfo)

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : ػ߾֤γߤꤹ륳ɤ֤
    #=================================================================
    def gc_lastpost_interrupt_dis()
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      # dis_intɬפΤֹ
      aDisIntNo = []
      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((GRP_INTERRUPT.include?(cObjectInfo.sObjectType) == true) && (cObjectInfo.hState[TSR_PRM_STATE] == KER_TA_ENAINT))
          aDisIntNo.push(cObjectInfo.hState[TSR_PRM_INTNO])
        end
      }

      # ʣƤ٤dis_int¹Ԥ
      aDisIntNo.uniq!()
      aDisIntNo.each{|snIntNo|
        cElement.set_syscall(hMainTaskInfo, "#{API_DIS_INT}(#{snIntNo})")
      }

      cElement.set_checkpoint(hMainTaskInfo)

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : ξ֤˹Ԥ٤Υᥤ
    #         IMCodeElement饹饹ˤޤȤ֤
    #=================================================================
    def gc_post_maintask_set(cNextActivate, cNextRunning, bNextCpuLock, bNextRunSus, lPrevMainTaskState, bGainTime)
      check_class(ProcessUnit, cNextActivate, true) # ΥǥǵưƤ󥿥
      check_class(ProcessUnit, cNextRunning, true)  # ΥǥǼ¹Υ
      check_class(Bool, bNextCpuLock)               # ΥǥCPUåɤ
      check_class(Bool, bNextRunSus)                # ΥǥǲϾ֤ɤ
      check_class(Symbol, lPrevMainTaskState)       # ΥǥΥᥤ󥿥ξ
      check_class(Bool, bGainTime)                  # ֤ʤɬפ뤫ɤ

      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      # ߤCPU֤
      bNowCpuLock = check_cpu_loc()

      # ߤȸ֤βϾ֤
      bNowRunSus = check_run_sus()

      # CPUå֤ξ(ȯԤǤʤ)
      if (bNowCpuLock == true)
        @lMainTaskState = lPrevMainTaskState
        return nil
      end

      # ֤ǥᥤ󥿥¹Ծ֤ξ
      if (lPrevMainTaskState == :running)
        # ξ򤹤٤硤Υǥ
        # ᥤ󥿥򵯾Ǥ뤿ᡤslp_tsk
        # 1)Υǥ˼¹Ծ֤Υ¸ߤ
        # 2)Υǥμ¹Ծ֤ΥϾ֤Ǥʤ
        #   (ǲϾ֤ǶԤȤʤꡤᥤ󥿥򵯾Ǥʤ)
        # 3)ΥǥCPUåǤʤ
        #   (ʣdo/post³chg_pri/wup_tskȯԤǤʤǽ)
        if ((!cNextActivate.nil?() || !cNextRunning.nil?()) && (bNextRunSus == false) && (bNextCpuLock == false))
          cElement.set_syscall(hMainTaskInfo, "#{API_SLP_TSK}()")
          @lMainTaskState = :sleep

        # 嵭ʳϲ⤷ʤ
        else
          @lMainTaskState = lPrevMainTaskState
        end

      # ֤ǥᥤ󥿥Ԥ֤ξ
      elsif (lPrevMainTaskState == :sleep)
        # ߼¹Ծ֤Υ¸ߤʤĻ֤ʤɬפ
        # ᥤ󥿥öưƻ֤ʤᤵ
        if (@cRunning.nil?() && (bGainTime == true))
          hProcUnitInfo = get_proc_unit_info(@cActivate)
          cElement.set_syscall(hProcUnitInfo, "#{API_IWUP_TSK}(#{TTG_MAIN_TASK})")

          @lMainTaskState = :running

        # Τ줫ξ硤Υǥ
        # ¹Ծ֤νñ̤ʤʤ뤿ᡤᥤ󥿥򵯾
        # 1)Υǥ˼¹Ծ֤νñ̤¸ߤʤ
        # 2)ΥǥCPUå
        # (do/post³chg_pri/wup_tskȯԤǤʤǽ)
        # 3)Υǥμ¹Ծ֤νñ̤Ͼ
        # (ǲϾ֤ǶԤȤʤꡤᥤ󥿥򵯾Ǥʤ)
        elsif ((cNextActivate.nil?() && cNextRunning.nil?()) || (bNextCpuLock == true) || (bNextRunSus == true))
          hProcUnitInfo = get_proc_unit_info(@cActivate, @cRunning)
          if (@cActivate.nil?())
            cElement.set_syscall(hProcUnitInfo, "#{API_CHG_PRI}(#{TTG_MAIN_TASK}, #{TTG_WAIT_PRI})")
            cElement.set_syscall(hProcUnitInfo, "#{API_WUP_TSK}(#{TTG_MAIN_TASK})")

          else
            cElement.set_syscall(hProcUnitInfo, "#{API_IWUP_TSK}(#{TTG_MAIN_TASK})")

            # ¹Ծ֤Υ硤ᥤ󥿥¹Ծ֤Ȥʤʤ褦chg_priƤ
            if (!@cRunning.nil?())
              cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{TTG_MAIN_TASK}, #{TTG_WAIT_PRI})")
              if (check_running_pri(TTG_WAIT_PRI) == true)
                cElement.set_syscall(hMainTaskInfo, "#{API_ROT_RDQ}(#{TTG_WAIT_PRI})")
              end
            end
          end

          @lMainTaskState = :ready
        # 嵭ʳϲ⤷ʤ
        else
          @lMainTaskState = lPrevMainTaskState
        end

      elsif (lPrevMainTaskState == :ready)
        # ξ򤹤٤硤Υǥ
        # ᥤ󥿥򵯾Ǥ뤿ᡤͥ٤ᤷslp_tsk
        # 1)Υǥ˼¹Ծ֤νñ̤¸ߤ
        # 2)Υǥμ¹Ծ֤ΥϾ֤Ǥʤ
        #   (ǲϾ֤ǶԤȤʤꡤᥤ󥿥򵯾Ǥʤ)
        # 3)ΥǥCPUåǤʤ
        #   (ʣdo/post³chg_pri/wup_tskȯԤǤʤǽ)
        if ((!cNextActivate.nil?() || !cNextRunning.nil?()) && (bNextRunSus == false) && (bNextCpuLock == false))
          # ᥤ󥿥TTG_MAIN_PRIξchg_priȯԤʤ
          cElement.set_chg_pri_main_task(hMainTaskInfo)

          cElement.set_syscall(hMainTaskInfo, "#{API_SLP_TSK}()")
          @lMainTaskState = :sleep

        # Υǥ˼¹Ծ֤Υ¸ߤʤ
        # ᥤ󥿥¹Ծ֤Ȥ
        elsif (cNextRunning.nil?())
          hProcUnitInfo = get_proc_unit_info(@cRunning)
          cElement.set_syscall(get_proc_unit_info(), "#{API_CHG_PRI}(#{TTG_TSK_SELF}, #{TTG_MAIN_PRI})")

          @lMainTaskState = :running
        # 嵭ʳϲ⤷ʤ
        else
          @lMainTaskState = lPrevMainTaskState
        end

      else
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : ư׵ᥭ塼󥰤򤹤
    #         IMCodeElement饹ˤޤȤ֤
    #         (Χᥤ󥿥¹Ԥ)
    #=================================================================
    def gc_lastpost_task_can_queueing()
      cElement = IMCodeElement.new()

      hProcUnitInfo = get_proc_unit_info()

      @hTask.each{|sObjectID, cObjectInfo|
        if (!cObjectInfo.hState[TSR_PRM_ACTCNT].nil?() && cObjectInfo.hState[TSR_PRM_ACTCNT] > 0)
          cElement.set_local_var(hProcUnitInfo[:id], TSR_PRM_ERUINT, "ER_UINT")
          cObjectInfo.hState[TSR_PRM_ACTCNT].times{
            cElement.set_syscall(hProcUnitInfo, "#{API_CAN_ACT}(#{sObjectID})", nil, TYP_ER_UINT)
            cElement.set_assert(hProcUnitInfo, TSR_PRM_ERUINT, cObjectInfo.hState[TSR_PRM_ACTCNT])
          }
        end

      }

      cElement.set_checkpoint(hProcUnitInfo)

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : readyΥslp_tsk
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_lastpost_ready_sleep()
      cElement = IMCodeElement.new()

      @hTask.each{|sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RDY)
          hProcUnitInfo = get_proc_unit_info(cObjectInfo)
          cElement.set_syscall(hProcUnitInfo, "#{API_SLP_TSK}()")
        end
      }

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : ưλ륳ɤ
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_lastpost_all_task_ter()
      # ¾¸ߤ硤٤ter_tsk()
      cElement = IMCodeElement.new()

      hProcUnitInfo = get_proc_unit_info()

      @hTask.each{|sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] != KER_TTS_DMT)
          cElement.set_syscall(hProcUnitInfo, "#{API_TER_TSK}(#{sObjectID})")
        end
      }

      cElement.set_checkpoint(hProcUnitInfo)

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : åݥȤϤ
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_checkpoint_zero()
      cElement = IMCodeElement.new()

      @hTask.each{ |sObjectID, cObjectInfo|
        hProcUnitInfo = get_proc_unit_info(cObjectInfo)
        cElement.set_checkpoint_zero(hProcUnitInfo)
      }

      return cElement # [IMCodeElement]
    end

    #=================================================================
    #   : ΥǥǵưACTIVATE󥿥¸ߤ
    #         硤ưԤĥɤ֤
    #=================================================================
    def gc_wait_non_task_activate(cPrevActivate, bGainTime)
      check_class(ProcessUnit, cPrevActivate, true)  # ΥǥACTIVATEǤ󥿥
      check_class(Bool, bGainTime)                   # ֤ʤ뤫

      cElement = IMCodeElement.new()

      # 󥿥¸ߤΤ
      if (!@cActivate.nil?())
        hActivateInfo = get_proc_unit_info(@cActivate)
        hRunningInfo = get_proc_unit_info(@cRunning)
        # ֤ߤʤƥȥξ硤ưԤʤ
        if (GRP_TIME_EVENT_HDL.include?(@cActivate.sObjectType) && (bGainTime == true))
        # Υǥ󥿥ʤ硤鵯ưԤ
        elsif (cPrevActivate.nil?())
          cElement.set_checkpoint(hActivateInfo)
          cElement.wait_checkpoint(hRunningInfo)
        # ۤʤ󥿥ACTIVATEˤʤäϡ󥿥鵯ưԤ
        elsif (cPrevActivate.sObjectID != @cActivate.sObjectID)
          cElement.set_checkpoint(hActivateInfo)
          cElement.wait_checkpoint(get_proc_unit_info(cPrevActivate))
        # Ʊ󥿥bootcntѤäƤϡ٥뤿᥿Ԥ
        elsif (cPrevActivate.hState[TSR_PRM_BOOTCNT] != @cActivate.hState[TSR_PRM_BOOTCNT])
          cElement.set_checkpoint(hActivateInfo)
          cElement.wait_checkpoint(hRunningInfo)
        end
      end

      return cElement # [IMCodeElement]
    end
  end
end
