#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: TestScenario.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"
require "common/bin/Config.rb"
require "common/bin/test_scenario/PreCondition.rb"
require "common/bin/test_scenario/Do_PostCondition.rb"
require "ttc/bin/test_scenario/TestScenario.rb"
require "ttj/bin/test_scenario/TestScenario.rb"
require "bin/builder/fmp_builder/test_scenario/TestScenario.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: TestScenario
  #     : PreConditionDoPostConditionΥǡ
  #===================================================================
  class TestScenario
    include CommonModule

    attr_reader :sTestID, :hVariation, :cPreCondition, :aDo_PostCondition, :bGainTime, :bGcovAll

    #=================================================================
    #   : 󥹥ȥ饯
    #=================================================================
    def initialize(sTestID, hScenario)
      check_class(Object, sTestID, true)    # ƥID
      check_class(Object, hScenario, true)  # predopostʥꥪ

      @cConf        = Config.new()  # եμ
      @hVariation   = {}            # Хꥨ
      @bGainTime    = nil           # ֽ
      @bHasTimeTick = false         # ƥåĤȽѥե饰
      @sTestID      = sTestID       # ƥID
      @sNote        = nil           # 

      # ¤å
      basic_check(sTestID, hScenario)

      # ƥåĤȽ
      hMacro = @cConf.get_macro()
      hScenario.each{|sCondition, shCondition|
        if (sCondition =~ TSR_REX_PRE_DO || sCondition =~ TSR_REX_PRE_POST)
          if (has_timetick?(shCondition))
            @bHasTimeTick = true
            break
          end
        end
      }

      # variationǼ
      if (hScenario[TSR_LBL_VARIATION].nil?())
        @hVariation = {}
      else
        @hVariation = hScenario[TSR_LBL_VARIATION]
      end
      # gcov_all
      if (@hVariation[TSR_PRM_GCOV_ALL].nil?())
        @bGcovAll = false
      else
        @bGcovAll = @hVariation[TSR_PRM_GCOV_ALL]
      end

      # noteǼ
      @sNote = hScenario[TSR_LBL_NOTE]

      # pre_condition
      @cPreCondition = PreCondition.new(sTestID, hScenario[TSR_LBL_PRE])
      @cPreCondition.set_gcov_all_flg(@bGcovAll)

      # dopost_condition(dopostϰ˽)
      @aDo_PostCondition = []

      # ¤
      hScenario = fix_structure(hScenario)

      # ֹ
      aSeqNumList = []
      hScenario.each_key{|sCondition|
        if (sCondition =~ TSR_REX_DO)
          aSeqNumList.push($1.to_i())
        end
      }
      aSeqNumList = aSeqNumList.sort()

      # dopost
      aSeqNumList.each{|nSeqNum|
        sSeqDo   = "#{TSR_UNS_DO}#{nSeqNum}"
        sSeqPost = "#{TSR_UNS_POST}#{nSeqNum}"
        # ֹǤƥå
        aTimeTickList = hScenario[sSeqDo].keys()
        aTimeTickList.concat(hScenario[sSeqPost].keys())
        aTimeTickList = aTimeTickList.uniq().sort()

        aTimeTickList.each{|nTimeTick|
          hScenarioDo   = hScenario["#{TSR_UNS_DO}#{nSeqNum}"][nTimeTick]
          hScenarioPost = hScenario["#{TSR_UNS_POST}#{nSeqNum}"][nTimeTick]

          cObj = Do_PostCondition.new(sTestID, hScenarioDo, hScenarioPost, nSeqNum, nTimeTick, @cPreCondition)
          cObj.set_gcov_all_flg(@bGcovAll)
          @aDo_PostCondition.push(cObj)
        }
      }
    end

    #=================================================================
    #   : ƥȥʥꥪι¤
    #=================================================================
    def fix_structure(hScenario)
      check_class(Hash, hScenario)  # ƥȥʥꥪ

      hResult = {}
      hScenario.each{|sCondition, shCondition|
        case sCondition
        when TSR_LBL_PRE, TSR_LBL_VARIATION, TSR_LBL_NOTE
          hResult[sCondition] = shCondition
        when TSR_REX_PRE_DO
          sSeq    = "#{TSR_UNS_DO}#{$1.to_i()}"
          hResult = fix_condition(hResult, shCondition, sSeq)
        when TSR_REX_PRE_POST
          sSeq    = "#{TSR_UNS_POST}#{$1.to_i()}"
          hResult = fix_condition(hResult, shCondition, sSeq)
        else
          abort(ERR_MSG % [__FILE__, __LINE__])
        end
      }

      return hResult  # [Hash]줿ƥȥʥꥪ
    end

    #=================================================================
    #   : ǥι¤
    #=================================================================
    def fix_condition(hScenario, hCondition, sSeq)
      check_class(Hash, hScenario)         # ʥꥪ
      check_class(Hash, hCondition, true)  # ǥ
      check_class(String, sSeq)            # ֹ

      hResult = hScenario.dup()
      hMacro = @cConf.get_macro()
      # ƥå
      if (has_timetick?(hCondition))
        hResult[sSeq] = {}
        hCondition.each{|nTimeTick, hBlock|
          nTimeTick = parse_value(nTimeTick, hMacro)
          hResult[sSeq][nTimeTick] = hBlock
        }
      # ƥå̵0ƥå䴰
      else
        hResult[sSeq] = {}
        hResult[sSeq][0] = hCondition
      end

      return hResult  # [Hash]줿ǥ
    end

    #=================================================================
    #   : ƥǥ
    #=================================================================
    def init_conditions()
      aConditions = get_all_condition()
      aConditions.each{|cCondition|
        cCondition.init_instance_variables()
      }
    end

    #=================================================================
    #   : ֹ֤
    #=================================================================
    def get_seqnum(nIndex)
      check_class(Integer, nIndex)  # ܤdo_post  # ܤdo_post

      return @aDo_PostCondition[nIndex].nSeqNum  # [Integer]ֹ
    end

    #=================================================================
    #   : ƥåֹ֤
    #=================================================================
    def get_timetick(nIndex)
      check_class(Integer, nIndex)  # ܤdo_post  # ܤdo_post

      return @aDo_PostCondition[nIndex].nTimeTick  # [Integer]ƥåֹ
    end

    #=================================================================
    #   : pre_conditionǿʤ֤
    #=================================================================
    def set_pre_gain_tick()
      @cPreCondition.set_pre_gain_tick()
    end

    #=================================================================
    #   : ǥѥåػߤγǧ(ǥѥåػ߾֤ξtrue)
    #=================================================================
    def check_dis_dsp(nIndex = nil)
      check_class(Integer, nIndex, true)  # ܤdo_post  # ܤdo_post

      if (nIndex.nil?())
        return @cPreCondition.check_dis_dsp()  # [Bool]ǥѥåػ߾
      else
        return @aDo_PostCondition[nIndex].check_dis_dsp()  # [Bool]ǥѥåػ߾
      end
    end

    #=================================================================
    #   : ͥ٥ޥγǧ(ǤϤʤtrue)
    #=================================================================
    def check_chg_ipm(nIndex = nil)
      check_class(Integer, nIndex, true)  # ܤdo_post  # ܤdo_post

      if (nIndex.nil?())
        return @cPreCondition.check_pre_need_chg_ipm()  # [Bool]ͥ٥ޥ
      else
        return @aDo_PostCondition[nIndex].check_chg_ipm()  # [Bool]ͥ٥ޥ
      end
    end

    #=================================================================
    #   : CPUå֤γǧ(CPUå֤ξtrue)
    #=================================================================
    def check_cpu_loc(nIndex = nil)
      check_class(Integer, nIndex, true)  # ܤdo_post  # ܤdo_post

      if (nIndex.nil?())
        return @cPreCondition.check_cpu_loc()  # [Bool]CPUå
      else
        return @aDo_PostCondition[nIndex].check_cpu_loc()  # [Bool]CPUå
      end
    end

    #=================================================================
    #   : Ǹpost_conditionǧ
    #=================================================================
    def check_lastpost_condition(nIndex)
      check_class(Integer, nIndex)  # ܤdo_post

      if (@aDo_PostCondition[TTG_IDX_LAST] == @aDo_PostCondition[nIndex])
        return true  # [Bool]Ǹpost_condition
      end

      return false  # [Bool]Ǹpost_condition
    end

    #=================================================================
    #   : ᥤ󥿥IDץåIDư
    #=================================================================
    def get_main_task_proc()
      return @cPreCondition.get_proc_unit_info()  # [Hash]ᥤ󥿥ξ
    end

    #=================================================================
    #   : ο֤
    #=================================================================
    def get_stack_num()
      return @cPreCondition.hTask.size()  # [Integer]ο
    end

    #=================================================================
    #   : Ƥνñ̾Ȥ줾κǽŪʵư
    #=================================================================
    def get_proc_units(cElement)
      check_class(IMCodeElement, cElement)  # ɤɲä륨

      @aDo_PostCondition[TTG_IDX_LAST].get_proc_units(cElement)
    end

    #=================================================================
    #   : ߤξ֤֤Ȥλ֤κ
    #=================================================================
    def get_post_time(nIndex)
      check_class(Integer, nIndex)  # ܤdo_post

      return @aDo_PostCondition[nIndex + 1].nTimeTick - @aDo_PostCondition[nIndex].nTimeTick  # [Integer]ߤξ֤֤Ȥλ֤κ
    end

    #=================================================================
    #   : 㳰ľ֤Υ̵ͭǧ
    #=================================================================
    def exist_pre_task_tex_ena()
      return @cPreCondition.exist_pre_task_tex_ena()  # [Bool]㳰ľ֤Υ¸ߤ뤫
    end

    #=================================================================
    #   : ACTIVATEǤ륿㳰ϥɥ̵ͭǧ
    #=================================================================
    def exist_pre_task_texhdr_activate()
      return @cPreCondition.exist_pre_task_texhdr_activate()  # [Bool]ACTIVATEǤ륿㳰ϥɥ餬¸ߤ뤫
    end

    #=================================================================
    #   : Ԥ֥Ȥ̵ͭǧ
    #=================================================================
    def exist_pre_scobj_data()
      return @cPreCondition.exist_pre_scobj_data()  # [Bool]Ԥ֥Ȥ¸ߤ뤫
    end

    #=================================================================
    #   : ֥ԤΥ̵ͭǧ
    #=================================================================
    def exist_pre_task_scobj_waiting()
      return @cPreCondition.exist_pre_task_scobj_waiting()  # [Bool]֥ԤΥ¸ߤ뤫
    end

    #=================================================================
    #   : Ԥ(꡼סǥ쥤)Υ̵ͭǧ
    #         Ԥ֤Ԥ(꡼סǥ쥤)ޤ
    #=================================================================
    def exist_pre_task_waiting()
      return @cPreCondition.exist_pre_task_waiting()  # [Bool]Ԥ֤Υ¸ߤ뤫
    end

    #=================================================================
    #   : ԤԤ֤Υ̵ͭǧ
    #         Ԥ֤ζԤޤ
    #=================================================================
    def exist_pre_task_suspended()
      return @cPreCondition.exist_pre_task_suspended()  # [Bool]ԤԤ֤Υ¸ߤ뤫
    end

    #=================================================================
    #   : ¹Բǽ֤Υ̵ͭǧ
    #=================================================================
    def exist_pre_task_ready()
      return @cPreCondition.exist_pre_task_ready()  # [Bool]¹Բǽ֤Υ¸ߤ뤫
    end

    #=================================================================
    #   : ͥ٤Ƚͥ٤ۤʤ륿̵ͭǧ
    #=================================================================
    def exist_pre_task_pri_chg()
      return @cPreCondition.exist_pre_task_pri_chg()  # [Bool]ͥ٤Ƚͥ٤ۤʤ륿¸ߤ뤫
    end

    #=================================================================
    #   : ư׵ᥭ塼󥰤򤷤Ƥ륿̵ͭ
    #         ǧ
    #=================================================================
    def exist_task_queueing(nIndex = nil)
      check_class(Integer, nIndex, true)  # ܤdo_post

      if (nIndex.nil?())
        return @cPreCondition.exist_task_queueing()  # [Bool]ư׵ᥭ塼󥰤򤷤Ƥ륿¸ߤ뤫
      else
        return @aDo_PostCondition[TTG_IDX_LAST].exist_task_queueing()  # [Bool]ư׵ᥭ塼󥰤򤷤Ƥ륿¸ߤ뤫
      end
    end

    #=================================================================
    #   : α㳰װꤵƤ륿㳰̵ͭǧ
    #=================================================================
    def exist_pre_task_tex_pndptn()
      return @cPreCondition.exist_pre_task_tex_pndptn()  # [Bool]α㳰װꤵƤ륿㳰¸ߤ뤫
    end

    #=================================================================
    #   : ư֡Txxx_STAˤΥ।٥ȥϥɥ̵ͭǧ
    #=================================================================
    def exist_time_event_sta(nIndex = nil)
      check_class(Integer, nIndex, true)  # ܤdo_post

      if (nIndex.nil?())
        return @cPreCondition.exist_time_event_sta()  # [Bool]ư֤Υ।٥ȥϥɥ餬¸ߤ뤫
      else
        return @aDo_PostCondition[TTG_IDX_LAST].exist_time_event_sta()  # [Bool]ư֤Υ।٥ȥϥɥ餬¸ߤ뤫
      end
    end

    #=================================================================
    #   : ľ֤γߥϥɥ顤ߥӥ롼̵ͭ
    #         ǧ
    #=================================================================
    def exist_interrupt_ena(nIndex = nil)
      check_class(Integer, nIndex, true)  # ܤdo_post

      if (nIndex.nil?())
        return @cPreCondition.exist_interrupt_ena()  # [Bool]ľ֤γߥϥɥ顤ߥӥ롼¸ߤ뤫
      else
        return @aDo_PostCondition[TTG_IDX_LAST].exist_interrupt_ena()  # [Bool]ľ֤γߥϥɥ顤ߥӥ롼¸ߤ뤫
      end
    end

    #=================================================================
    #   : ¹Ծ֤Υ̵ͭǧ
    #=================================================================
    def exist_task_running(nIndex = nil)
      check_class(Integer, nIndex, true)  # ܤdo_post

      if (nIndex.nil?())
        return @cPreCondition.exist_task_running()  # [Bool]¹Ծ֤Υ¸ߤ뤫
      else
        return @aDo_PostCondition[TTG_IDX_LAST].exist_task_running()  # [Bool]¹Ծ֤Υ¸ߤ뤫
      end
    end

    #=================================================================
    #   : ư󥿥̵ͭǧ
    #=================================================================
    def exist_nontask_activate(nIndex = nil)
      check_class(Integer, nIndex, true)  # ܤdo_post

      if (nIndex.nil?())
        return @cPreCondition.exist_nontask_activate()  # [Bool]ư󥿥¸ߤ뤫
      else
        return @aDo_PostCondition[TTG_IDX_LAST].exist_nontask_activate()  # [Bool]ư󥿥¸ߤ뤫
      end
    end

    #=================================================================
    #   : ֤ʤɬפ뤫ǧ
    #=================================================================
    def exist_post_timetick(nIndex)
      check_class(Integer, nIndex)  # ܤdo_post

      if (@aDo_PostCondition[nIndex].nTimeTick != @aDo_PostCondition[nIndex + 1].nTimeTick)
        return true  # [Bool]֤ʤɬפ뤫
      else
        return false  # [Bool]֤ʤɬפ뤫
      end
    end

    #=================================================================
    #   : doäƤtrueǤϤʤfalse֤
    #=================================================================
    def check_do_info(nIndex)
      check_class(Integer, nIndex)  # ܤdo_post

      if (@aDo_PostCondition[nIndex].hDo.empty?())
        return false  # [Bool]do꤬Ƥ뤫
      else
        return true  # [Bool]do꤬Ƥ뤫
      end
    end

    #=================================================================
    #   : Х/ѿ뤿Υɤꤹ
    #=================================================================
    def gc_global_local_var(cElement)
      check_class(IMCodeElement, cElement)  # ɤɲä륨

      @cPreCondition.gc_global_local_var(cElement)
    end

    #=================================================================
    #   : إåե˽Ϥ륳ɤꤹ
    #=================================================================
    def gc_header(cElement)
      check_class(IMCodeElement, cElement)  # ɤɲä륨

      @cPreCondition.gc_header(cElement)
    end

    #=================================================================
    #   : եե˽Ϥ륳ɤꤹ
    #=================================================================
    def gc_config(cElement)
      check_class(IMCodeElement, cElement)  # ɤɲä륨

      @cPreCondition.gc_config(cElement)
    end

    #=================================================================
    #   : 㳰ľ֤ˤ륳ɤ֤
    #=================================================================
    def gc_pre_task_tex_ena()
      return @cPreCondition.gc_pre_task_tex_ena()  # [IMCodeElement]㳰ľ֤ˤ륳
    end

    #=================================================================
    #   : 㳰򵯤ɤ֤
    #=================================================================
    def gc_pre_task_texhdr_activate()
      return @cPreCondition.gc_pre_task_texhdr_activate()  # [IMCodeElement]㳰򵯤
    end

    #=================================================================
    #   : Ԥ֥ȤνΤΥɤ֤
    #=================================================================
    def gc_pre_scobj_data()
      return @cPreCondition.gc_pre_scobj_data()  # [IMCodeElement]Ԥ֥ȤνΤΥ
    end

    #=================================================================
    #   : ֥ԤΤΥɤ֤
    #=================================================================
    def gc_pre_task_scobj_waiting()
      return @cPreCondition.gc_pre_task_scobj_waiting()  # [IMCodeElement]֥ԤΤΥ
    end

    #=================================================================
    #   : Ԥ(꡼סǥ쥤)ΥȡԤ֤
    #         Ԥ֤Υꤹ륳ɤ֤
    #         Ԥ֤Ԥ(꡼סǥ쥤)ޤ
    #=================================================================
    def gc_pre_task_waiting()
      return @cPreCondition.gc_pre_task_waiting()  # [IMCodeElement]Ԥ֡Ԥ֤Υꤹ륳
    end

    #=================================================================
    #   : ԤԤ֤ꤹ륳ɤ֤
    #         Ԥ֤ζԤޤ
    #=================================================================
    def gc_pre_task_suspended()
      return @cPreCondition.gc_pre_task_suspended()  # [IMCodeElement]ԤԤ֤ꤹ륳
    end

    #=================================================================
    #   : ¹Բǽ֤Υꤹ륳ɤ֤
    #         ºݤϵˡΧԤ֤ˤƤ
    #         ʤλǡ㳰ĤƤ륿ϡ
    #=================================================================
    def gc_pre_task_ready()
      return @cPreCondition.gc_pre_task_ready()  # [IMCodeElement]¹Բǽ֤Υꤹ륳
    end

    #=================================================================
    #   : α㳰װꤹ륳ɤ֤
    #=================================================================
    def gc_pre_task_tex_pndptn()
      return @cPreCondition.gc_pre_task_tex_pndptn()  # [IMCodeElement]α㳰װꤹ륳
    end

    #=================================================================
    #   : ư֡Txxx_STAˤΥ।٥ȥϥɥꤹ
    #         ɤ֤
    #=================================================================
    def gc_pre_time_event_sta()
      return @cPreCondition.gc_pre_time_event_sta()  # [IMCodeElement]ư֤Υ।٥ȥϥɥꤹ륳
    end

    #=================================================================
    #   : ľ֤γߤꤹ륳ɤ֤
    #=================================================================
    def gc_pre_interrupt_ena()
      return @cPreCondition.gc_pre_interrupt_ena()  # [IMCodeElement]ľ֤γߤꤹ륳
    end

    #=================================================================
    #   : ͥ٤Ƚͥ٤ۤʤ륿
    #         IMCodeElement饹ˤޤȤ֤(dormantʳΥ)
    #=================================================================
    def gc_pre_task_pri_chg()
      return @cPreCondition.gc_pre_task_pri_chg()  # [IMCodeElement]ͥ٤Ƚͥ٤ۤʤ륿ꤹ륳
    end

    #=================================================================
    #   : ¹Ծ֤Υ򤹤륳ɤ֤
    #=================================================================
    def gc_pre_task_running()
      return @cPreCondition.gc_pre_task_running()  # [IMCodeElement]¹Ծ֤Υ򤹤륳
    end

    #=================================================================
    #   : ǥѥåػߤˤ륳ɤ֤
    #=================================================================
    def gc_pre_dis_dsp()
      return @cPreCondition.gc_pre_dis_dsp()  # [IMCodeElement]ǥѥåػߤˤ륳
    end

    #=================================================================
    #   : ͥ٥ޥ0ʳˤ륳ɤ֤
    #=================================================================
    def gc_pre_set_ipm()
      return @cPreCondition.gc_pre_set_ipm()  # [IMCodeElement]ͥ٥ޥ0ʳˤ륳
    end

    #=================================================================
    #   : ư󥿥ꥳɤ֤
    #=================================================================
    def gc_pre_nontask_activate()
      return @cPreCondition.gc_pre_nontask_activate()  # [IMCodeElement]ư󥿥ꥳ
    end

    #=================================================================
    #   : ֿʤ륳ɤ֤
    #=================================================================
    def gc_tick_gain(nIndex)
      check_class(Integer, nIndex)  # ܤdo_post

      cElement = IMCodeElement.new()

      @aDo_PostCondition[nIndex].gc_tick_gain(cElement)

      return cElement  # [IMCodeElement]ֿʤ륳
    end

    #=================================================================
    #   : ꡼פƤ¹Բǽ֤ˤ륳ɤ֤
    #=================================================================
    def gc_pre_task_ready_porder()
      return @cPreCondition.gc_pre_task_ready_porder()  # [IMCodeElement]꡼פƤ¹Բǽ֤ˤ륳
    end

    #=================================================================
    #   : ư׵ᥭ塼󥰤򤹤륳ɤ֤
    #=================================================================
    def gc_pre_task_queueing()
      return @cPreCondition.gc_pre_task_queueing()  # [IMCodeElement]ư׵ᥭ塼󥰤򤹤륳
    end

    #=================================================================
    #   : CPUå֤ʼ¹νñ̤
    #=================================================================
    def gc_pre_cpu_loc()
      return @cPreCondition.gc_pre_cpu_loc()  # [IMCodeElement]CPUå֤򤹤륳
    end

    #=================================================================
    #   : ǥΥ֥Ȥrefɤ֤
    #=================================================================
    def gc_obj_ref(nIndex = nil)
      check_class(Integer, nIndex, true)  # ܤdo_post

      if (nIndex.nil?())
        return @cPreCondition.gc_obj_ref()  # [IMCodeElement]ǥΥ֥Ȥref
      else
        return @aDo_PostCondition[nIndex].gc_obj_ref()  # [IMCodeElement]ǥΥ֥Ȥref
      end
    end

    #=================================================================
    #   : DoνΥɤ֤
    #=================================================================
    def gc_do(nIndex)
      check_class(Integer, nIndex)  # ܤdo_post

      if (nIndex == 0)
        cPrevObjectInfo = @cPreCondition.get_prev_actvate_running()
      else
        cPrevObjectInfo = @aDo_PostCondition[nIndex - 1].get_prev_actvate_running()
      end

      return @aDo_PostCondition[nIndex].gc_do(cPrevObjectInfo)  # [IMCodeElement]DoνΥ
    end

    #=================================================================
    #   : CPUå֤βΥɤ֤
    #=================================================================
    def gc_lastpost_cpu_unl()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_cpu_unl()  # [IMCodeElement]CPUå֤βΥ
    end

    #=================================================================
    #   : Ǹθ֤ǥᥤ󥿥򵯤ɤ֤
    #=================================================================
    def gc_lastpost_maintask_wup(nIndex)
      check_class(Integer, nIndex)  # ܤdo_post

      if (nIndex == 0)
        cPrevCondition = @cPreCondition
      else
        cPrevCondition = @aDo_PostCondition[TTG_IDX_LAST - 1]
      end

      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_maintask_wup(cPrevCondition.lMainTaskState)  # [IMCodeElement]Ǹθ֤ǥᥤ󥿥򵯤
    end

    #=================================================================
    #   : ǥѥåǽˤ륳ɤ֤
    #=================================================================
    def gc_lastpost_ena_dsp()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_ena_dsp()  # [IMCodeElement]ǥѥåǽˤ륳
    end

    #=================================================================
    #   : ͥ٥ޥ륳ɤ֤
    #=================================================================
    def gc_lastpost_set_ini_ipm()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_set_ini_ipm()  # [IMCodeElement]ͥ٥ޥ륳
    end

    #=================================================================
    #   : ư֤Υ।٥ȥϥɥ߽Υɤ֤
    #=================================================================
    def gc_lastpost_time_event_stp()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_time_event_stp()  # [IMCodeElement]ư֤Υ।٥ȥϥɥ߽Υ
    end

    #=================================================================
    #   : ػ߾֤γߤꤹ륳ɤ֤
    #=================================================================
    def gc_lastpost_interrupt_dis()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_interrupt_dis()  # [IMCodeElement]ػ߾֤γߤꤹ륳
    end

    #=================================================================
    #   : ¾λ륳ɤ֤
    #=================================================================
    def gc_lastpost_all_task_ter()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_all_task_ter()  # [IMCodeElement]¾λ륳
    end

    #=================================================================
    #   : ư׵ᥭ塼󥰤륳ɤ֤
    #=================================================================
    def gc_lastpost_task_can_queueing()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_task_can_queueing()  # [IMCodeElement]ư׵ᥭ塼󥰤륳
    end

    #=================================================================
    #   : readyΥslp_tsk륳ɤ֤
    #=================================================================
    def gc_lastpost_ready_sleep()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_ready_sleep()  # [IMCodeElement]readyΥslp_tsk륳
    end

    #=================================================================
    #   : ֤ǡξ֤˹ԤΥᥤ󥿥ꤹ륳
    #         ֤
    #=================================================================
    def gc_pre_maintask_set()
      # [IMCodeElement]֤ǡξ֤˹ԤΥᥤ󥿥ꤹ륳
      return @cPreCondition.gc_pre_maintask_set(@aDo_PostCondition[0].cActivate, @aDo_PostCondition[0].cRunning, @aDo_PostCondition[0].check_cpu_loc(), @aDo_PostCondition[0].check_run_sus())
    end

    #=================================================================
    #   : ֤ǡξ֤˹ԤΥᥤ󥿥ꤹ륳
    #         ֤
    #=================================================================
    def gc_post_maintask_set(nIndex, bGainTime)
      check_class(Integer, nIndex)  # ܤdo_post
      check_class(Bool, bGainTime)  # ֤ʤ뤫

      if (nIndex == 0)
        cPrevCondition = @cPreCondition
      else
        cPrevCondition = @aDo_PostCondition[nIndex - 1]
      end
      cNowCondition  = @aDo_PostCondition[nIndex]
      cNextCondition = @aDo_PostCondition[nIndex + 1]

      # [IMCodeElement]֤ǡξ֤˹ԤΥᥤ󥿥ꤹ륳
      return cNowCondition.gc_post_maintask_set(cNextCondition.cActivate, cNextCondition.cRunning, cNextCondition.check_cpu_loc(), cNextCondition.check_run_sus(), cPrevCondition.lMainTaskState, bGainTime)
    end

    #=================================================================
    #   : åݥȤϤ륳ɤ֤
    #=================================================================
    def gc_checkpoint_zero()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_checkpoint_zero()  # [IMCodeElement]åݥȤϤ륳
    end

    #=================================================================
    #   : @aDo_PostConditionIndex֤
    #=================================================================
    def get_do_post_index()
      aIndex = []

      @aDo_PostCondition.each_index{|nIndex|
        aIndex.push(nIndex)
      }

      return aIndex  # [Array]Index
    end

    #=================================================================
    #   : 롼̵֤ͭ
    #=================================================================
    def exist_ini_rtn()
      return @cPreCondition.bIsIniRtn  # [Bool]롼¸ߤ뤫
    end

    #=================================================================
    #   : λ롼̵֤ͭ
    #=================================================================
    def exist_ter_rtn()
      return @cPreCondition.bIsTerRtn  # [Bool]λ롼¸ߤ뤫
    end

    #=================================================================
    #   : ߥϥɥ̵֤ͭ
    #=================================================================
    def exist_int_hdr()
      return @cPreCondition.bIsIntHdr  # [Bool]ߥϥɥ餬¸ߤ뤫
    end

    #=================================================================
    #   : ߥӥ롼̵֤ͭ
    #=================================================================
    def exist_isr()
      return @cPreCondition.bIsISR  # [Bool]ߥӥ롼¸ߤ뤫
    end

    #=================================================================
    #   : CPU㳰ϥɥ̵֤ͭ
    #=================================================================
    def exist_exception()
      return @cPreCondition.bIsException  # [Bool]CPU㳰ϥɥ餬¸ߤ뤫
    end

    #=================================================================
    #   : ꤷ֥Ȥ֤
    #=================================================================
    def get_all_object_info(sObjectType)
      check_class(String, sObjectType)  # оݤȤ륪֥ȥ

      return @aDo_PostCondition[TTG_IDX_LAST].get_all_object_info(sObjectType)  # [Hash]֥Ⱦ
    end

    #=================================================================
    #   : ꤷ֥ȥפνñ̤ACTIVATEǤ륪
    #         ȤID֤
    #=================================================================
    def get_activate_proc_unit_id(sObjectType)
      check_class(String, sObjectType)  # оݤȤ륪֥ȥ

      aProcUnitID = @cPreCondition.get_activate_proc_unit_id(sObjectType)

      @aDo_PostCondition.each{|cPostCondition|
        aProcUnitID.concat(cPostCondition.get_activate_proc_unit_id(sObjectType))
      }

      return aProcUnitID.uniq()  # [Array]ACTIVATEǤ륪֥ȤID
    end

    #=================================================================
    #   : TA_STA°μϥɥ̵֤ͭ
    #=================================================================
    def exist_cyclic_sta()
      return @cPreCondition.exist_cyclic_sta()  # [Bool]TA_STA°μϥɥ餬¸ߤ뤫
    end

    #=================================================================
    #   : TA_ENAINT°γߥӥ롼̵֤ͭ
    #=================================================================
    def exist_isr_enaint()
      return @cPreCondition.exist_isr_enaint()  # [Bool]TA_ENAINT°γߥӥ롼¸ߤ뤫
    end

    #=================================================================
    #   : /λ롼򥪥֥IDǥȤ
    #         ֤
    #=================================================================
    def get_ini_ter_object_info_sort_by_id(sObjectType)
      check_class(String, sObjectType)  # оݤȤ륪֥ȥ[orλ롼]

      return @cPreCondition.get_ini_ter_object_info_sort_by_id(sObjectType)  # [Hash]֥Ⱦ
    end

    #=================================================================
    #   : ΥǥǵưACTIVATE󥿥¸ߤ
    #         硤ưԤĥɤ֤
    #=================================================================
    def gc_wait_non_task_activate(nIndex)
      check_class(Integer, nIndex)  # ܤdo_post

      if (nIndex == 0)
        cPrevCondition = @cPreCondition
      else
        cPrevCondition = @aDo_PostCondition[nIndex - 1]
      end

      # [IMCodeElement]֤ǡξ֤˹ԤΥᥤ󥿥ꤹ륳
      return @aDo_PostCondition[nIndex].gc_wait_non_task_activate(cPrevCondition.cActivate, @bGainTime)
    end
  end
end
