#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: MultipleChecker.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"
require "common/bin/Config.rb"
require "common/bin/test_scenario/TestScenario.rb"
require "ttc/bin/class/TTCCommon.rb"

#=====================================================================
# TTCModule
#=====================================================================
module TTCModule
  #===================================================================
  # 饹̾: MultipleChecker
  #   : ʥꥪ֤Υ顼å
  #===================================================================
  class MultipleChecker
    include CommonModule
    include TTCModule

    #=================================================================
    # : 󥹥ȥ饯
    #=================================================================
    def initialize()
      @cConf = Config.new()
      # ƥIDʣå
      @hMultipleTestID = Hash.new{|hash, key|
        hash[key] = []
      }
      # ԥå
      @aSpinlockID     = []
      @aExistSpinFiles = []
      # Ƽѥ᡼
      @hUnifiedAtrs = {
        :hInthdr    => {},
        :hIsr       => {},
        :hIsr2      => {},
        :hException => {}
      }

=begin
      # ֹ
      @aIntno            = []
      @aExistIntnoTestID = []
=end
    end

    #=================================================================
    # : 顼åѤΥǡǼ
    #=================================================================
    def store(cTS, sFileName)
      check_class(TestScenario, cTS)  # ƥȥʥꥪ
      check_class(String, sFileName)  # ե̾

      # ԥåå
      if (@cConf.is_fmp?())
        aSpinNames = cTS.get_spinlock_names()
        @aSpinlockID.concat(aSpinNames)
        if (aSpinNames.size() > 0)
          @aExistSpinFiles.push(sFileName)
        end
      end

=begin
      # ֹå
      aIntno = cTS.get_all_intno()
      @aIntno.concat(aIntno)
      if (aIntno.size() > 0)
        @aExistIntnoTestID.push(cTS.sTestID)
      end
=end

      # ƥIDʣå
      @hMultipleTestID[cTS.sTestID].push(sFileName)
      # Ƽѥ᡼
      @hUnifiedAtrs[:hInthdr][sFileName]    = cTS.get_inthdr_attributes_by_intno()
      @hUnifiedAtrs[:hIsr][sFileName]       = cTS.get_isr_attributes_by_intno()
      @hUnifiedAtrs[:hIsr2][sFileName]      = cTS.get_isr_attributes_by_intno_and_isrpri()
      @hUnifiedAtrs[:hException][sFileName] = cTS.get_exception_attributes_by_excno()

    end

    #=================================================================
    # : ʥꥪ֥顼å¹Ԥ
    #=================================================================
    def multiple_check()
      aErrors = []

      # ƱƥIDʣYAMLѤƤ
      @hMultipleTestID.each{|sTestID, aFileNames|
        ### T7_001: ƥIDʣƤ
        if (aFileNames.size() > 1)
          sErr = sprintf("T7_001: " + ERR_TESTID_MULTIPLE, sTestID)
          aFileNames.each{|sFileName|
            sErr.concat("\n * #{sFileName}")
          }
          aErrors.push(TTCError.new(sErr))
        end
      }

      # ƥȥ줵줿°ɬפʥ֥ȤΥå
      ### T7_002: ƱֹФߥϥɥˤinhnointpriclassۤʤ
      ### T7_003: ƱֹФߥӥ롼ˤintpriۤʤ
      ### T7_004: ƱֹФisrpriƱΥӥ롼ˤexinfclassۤʤ
      ### T7_006: ƱCPU㳰ϥɥֹФCPU㳰ϥɥˤclassۤʤ
      hChech = {
        :hInthdr    => "T7_002: " + ERR_UNIFIED_ATR_INTHDR,
        :hIsr       => "T7_003: " + ERR_UNIFIED_ATR_ISR,
        :hIsr2      => "T7_004: " + ERR_UNIFIED_ATR_ISR,
        :hException => "T7_006: " + ERR_UNIFIED_ATR_EXCEPTION
      }
      hChech.each{|lKey, sErr|
        begin
          multiple_check_unified_attributes(@hUnifiedAtrs[lKey], sErr)
        rescue TTCError
          aErrors.push($!)
        end
      }


      # ֹξͤå
      hCheck = Hash.new{|hash, key|
        hash[key] = Hash.new{|hash2, key2|
          hash2[key2] = []
        }
      }
      [:hInthdr, :hIsr].each{|lKey|
        @hUnifiedAtrs[lKey].each{|sTestID, hData|
          hData.each_key{|hGroupKeyAtrs|
            hCheck[hGroupKeyAtrs[TSR_PRM_INTNO]][lKey].push(sTestID)
          }
        }
      }
      # å
      # (ϥå奭:hInthdr:hIsrȤʤäƤ뤬Ȥ)
      hCheck.each{|snIntNo, hGroup|
        ### T7_005: ƱֹФơߥϥɥȳߥӥ롼Ƥ
        if (hGroup[:hInthdr].size() > 0 && hGroup[:hIsr].size() > 0)
          sErr = sprintf("T7_005: " + ERR_CONFLICT_INTNO, snIntNo) + "\n"
          sErr.concat(" #{TSR_OBJ_INTHDR}\n")
          hGroup[:hInthdr].sort().each{|sFileName|
            sErr.concat(" * #{sFileName}\n")
          }
          sErr.concat(" #{TSR_OBJ_ISR}\n")
          hGroup[:hIsr].sort().each{|sFileName|
            sErr.concat(" * #{sFileName}\n")
          }
          aErrors.push(TTCError.new(sErr))
        end
      }

=begin
      ### T7_007: ֹλѿͤĶƤ
      @aIntno = @aIntno.uniq().sort()
      if (@aIntno.size() > @cConf.get_intno_num())
        sErr = "T7_007: " + ERR_OVER_INTNO_SUM + "\n"
        @aExistIntnoTestID.each{|sTestID|
          sErr += " * #{sTestID}\n"
        }
        aErrors.push(TTCError.new(sErr))
      end
=end

      ### T7_F001: ԥåοͤĶƤ
      if (@cConf.is_fmp?() && @cConf.get_spinlock_num() != 0)
        @aSpinlockID = @aSpinlockID.uniq().sort()
        if (@aSpinlockID.size() > @cConf.get_spinlock_num())
          sErr = "T7_F001: " + ERR_OVER_SPINLOCK_SUM + "\n"
          @aExistSpinFiles.each{|sFileName|
            sErr += " * #{sFileName}\n"
          }
          aErrors.push(TTCError.new(sErr))
        end
      end

      check_error(aErrors)
    end

    #=================================================================
    # : ѥ᡼ƥȥ֤줵Ƥ뤫å
    #=================================================================
    def multiple_check_unified_attributes(hUnifiedAtrs, sErr)
      check_class(Hash, hUnifiedAtrs)  # åǡ
      check_class(String, sErr)        # 顼å

      # ѥ᡼Ȥ߹碌Ȥ˥ƥIDޤȤ
      hGroups = Hash.new{|hash, key|
        hash[key] = Hash.new{|hash2, key2|
          hash2[key2] = []
        }
      }
      hUnifiedAtrs.each{|sTestID, hData|
        hData.each{|hGroupKeyAtrs, aAtrs|
          aAtrs.each{|hAtrs|
            hGroups[hGroupKeyAtrs][hAtrs].push(sTestID)
          }
        }
      }

      # ѥ᡼Ȥ߹碌ۤʤƥȥ뤫å
      hGroups.each{|hGroupKeyAtrs, hAtrGroups|
        if (hAtrGroups.size() > 1)
          nNum = 1
          # 롼
          aTmp = []
          hGroupKeyAtrs.each{|atr, val|
            aTmp.push("#{atr} = #{val}")
          }
          sErr.concat("\ntarget: " + aTmp.join(", ") + "\n")
          # Ȥ߹碌Ȥ˥ƥID
          hAtrGroups.each{|hAtrs, aTestID|
            # ѥ᡼Ȥ߹碌
            sErr.concat("-" * 30 + "\n")
            sErr.concat("case#{nNum}: ")
            nNum += 1
            aTmp = []
            hAtrs.each{|atr, val|
              unless (val.nil?())
                aTmp.push("#{atr} = #{val}")
              end
            }
            sErr.concat(aTmp.join(", ") + "\n")
            # ƥID
            aTestID.each{|sTestID|
              sErr.concat(" * #{sTestID}\n")
            }
          }

          raise(TTCError.new(sErr))
        end
      }
    end
  end
end
