#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2012 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#  Copyright (C) 2012 by FUJISOFT INCORPORATED
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: TTCCommon.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "yaml"
require "common/bin/CommonModule.rb"
require "ttc/bin/class/TTCError.rb"
require "ttc/bin/class/ObjectCommon.rb"
require "ttc/bin/kwalify.rb"
require "common/bin/Config.rb"

#=====================================================================
# TTCModule
#=====================================================================
module TTCModule
  include CommonModule

  #===================================================================
  # : YAMLեɤ
  #===================================================================
  def load_yaml_file(sFileName)
    check_class(String, sFileName)  # ե̾

    cConf = Config.new()
    begin
      if (cConf.use_yaml_library?())
        yaml = YAML.load_file(sFileName)
      else
        yaml = Kwalify::Yaml.load_file(sFileName)
       end
    rescue SystemCallError
      raise(TTCError.new(sprintf(ERR_CANNOT_OPEN_FILE, sFileName)))
    rescue ArgumentError
      raise(TTCError.new(sprintf(ERR_YAML_SYNTAX_INVALID, sFileName)))
    rescue Kwalify::SyntaxError
      raise(TTCError.new(sprintf(ERR_YAML_SYNTAX_INVALID, sFileName)))
    end

    return yaml  # [Object]YAML֥
  end
  protected :load_yaml_file

  #===================================================================
  # : ͤ黻
  #===================================================================
  def parse_value(val, hMacro = {})
    check_class(Object, val, true)  # 
    check_class(Hash, hMacro)       # ޥ

    # ʸξ͡ʥб
    if (val.is_a?(String))
      result = val.dup()
      # 桼ޥִ
      unless (hMacro.empty?())
        aMatches = val.scan(/\w+/)
        aMatches.each{|sMacro|
          if (hMacro.has_key?(sMacro))
            result = result.gsub(/(^|\W)#{sMacro}(?=$|\W)/, "\\1#{hMacro[sMacro]}")
          end
        }
      end

      # ͡16ʿˤȰεȶΤߤǹ줿ʸ
      if (result =~ /^(\d+|0x[a-fA-F\d]+|[\s\+\-\*\/\|\&\(\)])+$/)
        begin
          result = eval(result)
        rescue SyntaxError
          sErr = sprintf(ERR_EXPRESSION_INVALID, result)
          raise(TTCError.new(sErr))
        end
      end
    # ʸʳξϤΤޤ
    else
      result = safe_dup(val)
    end

    return result  # [Object]黻
  end

  #===================================================================
  # : ޥִ׻α黻Ԥ
  #===================================================================
  def calc_all_expr(data, hMacro)
    check_class(Object, data, true)  # 
    check_class(Hash, hMacro)        # ޥ

    if (data.is_a?(Hash))
      hTmp = data
      data = {}
      hTmp.each{|atr, val|
        atr       = parse_value(atr, hMacro)
        val       = calc_all_expr(val, hMacro)
        data[atr] = val
      }
    elsif (data.is_a?(Array))
      data = data.dup()
      data.each_with_index{|val, index|
        data[index] = calc_all_expr(val, hMacro)
      }
    elsif (data.is_a?(String))
      data = parse_value(data, hMacro)
    end

    return data  # [Object]ޥִ׻α黻η
  end

  #===================================================================
  # : ʸ򸡺ƥIDͿǤƤ򥨥ꥢ
  #       : ʸʳξϤΤޤ֤
  #===================================================================
  def alias_replace(sStr, hAlias)
    check_class(Object, sStr)  # оʸ
    check_class(Hash, hAlias)  # ꥢѴơ֥

    if (sStr.is_a?(String))
      sResult = sStr.dup()
      aMatches = sResult.scan(/\w+/)
      aMatches.each{|sMatch|
        # ֤оID˴ޤޤϥꥢ
        if (hAlias.has_key?(sMatch))
          sAlias  = hAlias[sMatch]
          sResult = sResult.gsub(/(^|\W)#{sMatch}(?=$|\W)/, "\\1#{sAlias}")
        end
      }
      return sResult  # [Object]ƥIDͿ줿ʸ
    else
      return safe_dup(sStr)  # Υ֥
    end
  end

  #===================================================================
  # : ʸ˥ƥIDͿ֤
  #===================================================================
  def alias_str(sStr, sTestID)
    check_class(String, sStr)     # оʸ
    check_class(String, sTestID)  # ƥID

    return "#{sTestID}_#{sStr}"  # [String]ƥIDͿ줿ʸ
  end

  #===================================================================
  #   : ХбΤѥ᡼Ѵ¹Ԥ
  #===================================================================
  def convert_global_params(sStr, hTable)
    check_class(String, sStr)  # оʸ
    check_class(Hash, hTable)  # Ѵɽ

    sResult = ""  # Ѵʸ
    aList = sStr.split(/(\w+)/)
    aList.each{|val|
      case val
      when CFG_MCR_REX_PRCID
        val = convert_global_prcid(val, hTable)
      when CFG_MCR_REX_INTNO
        val = convert_global_intno(val, hTable)
      when CFG_MCR_REX_INHNO
        val = convert_global_inhno(val, hTable)
      when CFG_MCR_REX_EXCNO
        val = convert_global_excno(val, hTable)
      end
      sResult.concat(val)
    }

    return sResult  # [String]Ѵʸ
  end

  #===================================================================
  #   : ХбΤѥ᡼Ѵprcid
  #===================================================================
  def convert_global_prcid(sMacro, hTable)
    check_class(String, sMacro)  # ޥ
    check_class(Hash, hTable)    # Ѵɽ

    lPrevKey = TTC_GLOBAL_TABLE[TTC_GLOBAK_KEY_PRCID][:local].index(sMacro)
    lConvKey = hTable[lPrevKey]
    unless (lConvKey.nil?())
      sGlobal =  TTC_GLOBAL_TABLE[TTC_GLOBAK_KEY_PRCID][:global][lConvKey]
    else
      sGlobal = sMacro.dup()
    end

    return sGlobal  # [String]ѴΥѥ᡼
  end

  #===================================================================
  #   : ХбΤѥ᡼Ѵintno
  #===================================================================
  def convert_global_intno(sMacro, hTable)
    check_class(String, sMacro)  # ޥ
    check_class(Hash, hTable)    # Ѵɽ

    sGlobal = sMacro.dup()
    if (sMacro =~ CFG_MCR_REX_INTNO)
      case $3
      when "INVALID"
        lPrevKey = TTC_GLOBAL_TABLE[TTC_GLOBAK_KEY_INTNO_INVALID][:local].index($1)
        lConvKey = hTable[lPrevKey]
        unless (lConvKey.nil?())
          sGlobal = TTC_GLOBAL_TABLE[TTC_GLOBAK_KEY_INTNO_INVALID][:global][lConvKey]
        end
      when "NOT_SET"
        lPrevKey = TTC_GLOBAL_TABLE[TTC_GLOBAK_KEY_INTNO_NOT_SET][:local].index($1)
        lConvKey = hTable[lPrevKey]
        unless (lConvKey.nil?())
          sGlobal = TTC_GLOBAL_TABLE[TTC_GLOBAK_KEY_INTNO_NOT_SET][:global][lConvKey]
        end
      else
        lPrevKey = TTC_GLOBAL_TABLE[TTC_GLOBAK_KEY_INTNO_PREFIX][:local].index($1)
        lConvKey = hTable[lPrevKey]
        unless (lConvKey.nil?())
          sGlobal = TTC_GLOBAL_TABLE[TTC_GLOBAK_KEY_INTNO_PREFIX][:global][lConvKey] + $6
        end
      end
    end

    return sGlobal  # [String]ѴΥѥ᡼
  end

  #===================================================================
  #   : ХбΤѥ᡼Ѵinhno
  #===================================================================
  def convert_global_inhno(sMacro, hTable)
    check_class(String, sMacro)  # ޥ
    check_class(Hash, hTable)    # Ѵɽ

    sGlobal = sMacro.dup()
    if (sMacro =~ CFG_MCR_REX_INHNO)
      lPrevKey = TTC_GLOBAL_TABLE[TTC_GLOBAK_KEY_INHNO_PREFIX][:local].index($1)
      lConvKey = hTable[lPrevKey]
      unless (lConvKey.nil?())
        sGlobal = TTC_GLOBAL_TABLE[TTC_GLOBAK_KEY_INHNO_PREFIX][:global][lConvKey] + $4
      end
    end

    return sGlobal  # [String]ѴΥѥ᡼
  end

  #===================================================================
  #   : ХбΤѥ᡼Ѵexcno
  #===================================================================
  def convert_global_excno(sMacro, hTable)
    check_class(String, sMacro)  # ޥ
    check_class(Hash, hTable)    # Ѵɽ

    sGlobal = sMacro.dup()
    lPrevKey = TTC_GLOBAL_TABLE[TTC_GLOBAK_KEY_EXCNO][:local].index(sMacro)
    lConvKey = hTable[lPrevKey]
    unless (lConvKey.nil?())
      sGlobal = TTC_GLOBAL_TABLE[TTC_GLOBAK_KEY_EXCNO][:global][lConvKey]
    end

    return sGlobal  # [String]ѴΥѥ᡼
  end

  #===================================================================
  # : ǥʬϤƥåĤȽꤷ֤
  #===================================================================
  def has_timetick?(hCondition)
    check_class(Object, hCondition, true)  # dopost_condition

    bResult = false
    if (hCondition.is_a?(Hash))
      cConf   = Config.new()
      hMacro  = cConf.get_macro()
      bResult = hCondition.all?(){|key, val|
        key = parse_value(key, hMacro)
        key.is_a?(Integer)
      }
    end

    return bResult  # [Bool]ƥåľtrueǤʤfalse
  end

  #===================================================================
  # : 顼뤫å㳰ꤲ
  #===================================================================
  def check_error(aErrors)
    check_class(Array, aErrors)  # 顼Ǽ

    # 顼ä
    unless (aErrors.empty?())
      raise(TTCMultiError.new(aErrors))
    end
  end

  #===================================================================
  # : °ƤΤå
  #===================================================================
  def check_defined_attribute(aAtrs, aAtrList, aPath)
    check_class(Array, aAtrs)     # Ҥ줿°
    check_class(Array, aAtrList)  # Ǥ°
    check_class(Array, aPath)     # 롼ȤΥѥ

    aErrors = []
    ### T1_022: ֥Ȥǽ°ʳꤵƤ
    aAtrs.each{|sAtr|
      unless (aAtrList.include?(sAtr))
        sErr = sprintf("T1_022: " + ERR_UNDEFINED_KEY, sAtr)
        aErrors.push(YamlError.new(sErr, aPath))
      end
    }

    check_error(aErrors)
  end

  #===================================================================
  # : °Υ饹ץå
  #===================================================================
  def check_attribute_type(sAtr, val, acClass, bAllowNil, aPath)
    check_class(String, sAtr)             # °̾
    check_class(Object, val, true)        # å
    check_class([Class, Array], acClass)  # 饹
    check_class(Bool, bAllowNil)          # nilĤ뤫
    check_class(Array, aPath)             # 롼ȤΥѥ

    bMatch = false
    # ꤵ줿饹å
    unless (acClass.is_a?(Array))
      acClass = [acClass]
    end
    # nil
    if (bAllowNil == true)
      acClass.push(NilClass)
    end
    acClass.each{|cClass|
      if (val.is_a?(cClass))
        bMatch = true
        break
      end
    }

    ### T2_001: ѥ᡼ηꤵƤ뷿Ȱۤʤ
    if (bMatch == false)
      sErr = sprintf("T2_001: " + ERR_INVALID_TYPE, sAtr, acClass.join(" or "), val.class())
      raise(YamlError.new(sErr, aPath + [sAtr]))
    end
  end

  #===================================================================
  # : °ͤ0ʾå
  #===================================================================
  def check_attribute_unsigned(sAtr, val, aPath)
    check_class(String, sAtr)       # °̾
    check_class(Object, val, true)  # å
    check_class(Array, aPath)       # 롼ȤΥѥ

    check_attribute_type(sAtr, val, Integer, false, aPath)
    # 
    if (val < 0)
      sErr = sprintf("T2_002: " + ERR_BE_INTEGER_GE, sAtr, 0, val)
      raise(YamlError.new(sErr, aPath + [sAtr]))
    end
  end

  #===================================================================
  # : °ͤꤷͤ礭å
  #===================================================================
  def check_attribute_gt(sAtr, val, nComp, aPath)
    check_class(String, sAtr)       # °̾
    check_class(Object, val, true)  # å
    check_class(Integer, nComp)     # Ӥ
    check_class(Array, aPath)       # 롼ȤΥѥ

    check_attribute_type(sAtr, val, Integer, false, aPath)
    # 
    if (val <= nComp)
      sErr = sprintf("T2_002: " + ERR_BE_INTEGER_GT, sAtr, nComp, val)
      raise(YamlError.new(sErr, aPath + [sAtr]))
    end
  end

  #===================================================================
  # : °ͤꤷͰʲå
  #===================================================================
  def check_attribute_le(sAtr, val, nComp, aPath)
    check_class(String, sAtr)       # °̾
    check_class(Object, val, true)  # å
    check_class(Integer, nComp)     # Ӥ
    check_class(Array, aPath)       # 롼ȤΥѥ

    check_attribute_type(sAtr, val, Integer, false, aPath)
    # 
    if (val > nComp)
      sErr = sprintf("T2_002: " + ERR_BE_INTEGER_LE, sAtr, nComp, val)
      raise(YamlError.new(sErr, aPath + [sAtr]))
    end
  end

  #===================================================================
  # : °ͤꤷͤ꾮å
  #===================================================================
  def check_attribute_lt(sAtr, val, nComp, aPath)
    check_class(String, sAtr)       # °̾
    check_class(Object, val, true)  # å
    check_class(Integer, nComp)     # Ӥ
    check_class(Array, aPath)       # 롼ȤΥѥ

    check_attribute_type(sAtr, val, Integer, false, aPath)
    # 
    if (val >= nComp)
      sErr = sprintf("T2_002: " + ERR_BE_INTEGER_LT, sAtr, nComp, val)
      raise(YamlError.new(sErr, aPath + [sAtr]))
    end
  end

  #===================================================================
  # : °ͤϰå
  #===================================================================
  def check_attribute_range(sAtr, val, nMin, nMax, aPath)
    check_class(String, sAtr)       # °̾
    check_class(Object, val, true)  # å
    check_class(Integer, nMin)      # Ǿ
    check_class(Integer, nMax)      # 
    check_class(Array, aPath)       # 롼ȤΥѥ

    check_attribute_type(sAtr, val, Integer, false, aPath)
    # 
    unless (val >= nMin && val <= nMax)
      sErr = sprintf("T2_002: " + ERR_BE_INTEGER_RANGE, sAtr, nMin, nMax, val)
      raise(YamlError.new(sErr, aPath + [sAtr]))
    end
  end

  #===================================================================
  # : °ͤͽ줿ͤå
  #===================================================================
  def check_attribute_enum(sAtr, val, aEnum, aPath)
    check_class(String, sAtr)       # °̾
    check_class(Object, val, true)  # å
    check_class(Array, aEnum)       # ͽ줿
    check_class(Array, aPath)       # 롼ȤΥѥ

    unless (aEnum.include?(val))
      sErr = sprintf("T2_002: " + ERR_BE_INCLUDE, sAtr, aEnum.join(" | "), val)
      raise(YamlError.new(sErr, aPath + [sAtr]))
    end
  end

  #===================================================================
  # : °ͤͽ줿͡ޤϤȤ߹碌å
  #===================================================================
  def check_attribute_multi(sAtr, val, aEnum, aPath)
    check_class(String, sAtr)       # °̾
    check_class(Object, val, true)  # å
    check_class(Array, aEnum)       # ͽ줿
    check_class(Array, aPath)       # 롼ȤΥѥ

    val = val.gsub(/\s+/, "")
    val = val.gsub(/^\((.*)\)$/, "\\1")
    aMacro = val.split("|")
    aMacro.each{|sMacro|
      begin
        check_attribute_enum(sAtr, sMacro, aEnum, aPath)
      rescue YamlError
        sErr = sprintf("T2_002: " + ERR_BE_INCLUDE, sAtr, aEnum.join(" | "), val)
        raise(YamlError.new(sErr, aPath + [sAtr]))
      end
    }
  end

  #===================================================================
  # : °ͤѿ̾å
  #===================================================================
  def check_attribute_variable(sAtr, val, aPath)
    check_class(String, sAtr)       # °̾
    check_class(Object, val, true)  # å(T2_001ǥåԤ)
    check_class(Array, aPath)       # 롼ȤΥѥ

    check_attribute_type(sAtr, val, String, false, aPath)
    ### T2_003: ѿ̾̿̾§ȿƤ
    unless (val =~ TSR_REX_VARIABLE)
      sErr = sprintf("T2_003: " + ERR_INVALID_VAR_NAME, val)
      raise(YamlError.new(sErr, aPath + [sAtr]))
    end
  end

  #===================================================================
  # : do°å
  #===================================================================
  def check_do_attribute(hDo, aSpecified, aPath)
    check_class(Hash, hDo)          # å
    check_class(Array, aSpecified)  # ꤵ줿°
    check_class(Array, aPath)       # 롼ȤΥѥ

    aErrors = []
    ### T2: do°å
    hDefs = get_do_attribute_list()
    hDefs.each{|sAtr, aClass|
      if (aSpecified.include?(sAtr))
        cClass = hDo[sAtr].class()
        unless (aClass.include?(cClass))
          sErr = sprintf("T2_001: " + ERR_INVALID_TYPE, sAtr, aClass.join(" or "), cClass)
          aErrors.push(YamlError.new(sErr, aPath + [sAtr]))
        end
      end
    }

    check_error(aErrors)
  end

  #===================================================================
  # : do°
  #===================================================================
  def get_do_attribute_list()
    # ץեб°
    cConf = Config.new()
    if (cConf.is_asp?())
      aResult = GRP_DEF_DO_ASP
    elsif (cConf.is_fmp?())
      aResult = GRP_DEF_DO_FMP
    else
      abort(ERR_MSG % [__FILE__, __LINE__])
    end

    return aResult.dup()  # [Array]do°
  end
end
