#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2012 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#  Copyright (C) 2012 by FUJISOFT INCORPORATED
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: ProcessUnit.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "ttc/bin/class/TTCCommon.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: ProcessUnit
  #     : ñ̥֥Ȥξ륯饹
  #===================================================================
  class ProcessUnit
    include TTCModule
    include TTCModule::ObjectCommon

    #=================================================================
    # : °å(°ꤷå)
    #=================================================================
    def pre_attribute_check(hObjectInfo, aPath, bIsPre)
      check_class(Hash, hObjectInfo)  # ֥Ⱦ
      check_class(Array, aPath)       # 롼ȤΥѥ
      check_class(Bool, bIsPre)       # pre_condition⤫

      aErrors = []
      begin
        super(hObjectInfo, aPath, bIsPre)
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      # do
      if (hObjectInfo[TSR_PRM_DO].is_a?(Hash))
        aAtrDefList = get_do_attribute_list().keys()
        aAtrDefList.delete(TSR_PRM_ID)  # id°ǤʤΤǺ
        begin
          check_defined_attribute(hObjectInfo[TSR_PRM_DO].keys(), aAtrDefList, aPath + [TSR_PRM_DO])
        rescue TTCMultiError
          aErrors.concat($!.message())
        end
      end

      # var
      if (hObjectInfo[TSR_PRM_VAR].is_a?(Hash))
        hObjectInfo[TSR_PRM_VAR].each{|sVarName, hVar|
          if (hVar.is_a?(Hash))
            ### T1_025: pre_conditionѿtypeꤵƤʤ
            if (bIsPre == true && hVar[TSR_PRM_VAR_TYPE].nil?())
              sErr = sprintf("T1_025: " + ERR_REQUIRED_KEY, TSR_PRM_VAR_TYPE)
              aErrors.push(YamlError.new(sErr, aPath + [TSR_PRM_VAR, sVarName]))
            ### T1_026: post_conditionѿtypeꤵƤ
            elsif (bIsPre == false && hVar.has_key?(TSR_PRM_VAR_TYPE))
              sErr = sprintf("T1_026: " + ERR_ONLY_PRE_ATR, TSR_PRM_VAR_TYPE)
              aErrors.push(YamlError.new(sErr, aPath + [TSR_PRM_VAR, sVarName]))
            end
          else
            # Variable饹Υ󥹥ѿT2_001å»
            sErr = sprintf("T2_001: " + ERR_INVALID_TYPE, sVarName, "Hash", hVar.class())
            aErrors.push(YamlError.new(sErr, aPath + [TSR_PRM_VAR, sVarName]))
          end
        }
      elsif (hObjectInfo[TSR_PRM_VAR].nil?())
        # ⤷ʤ
      else
        # Variable饹Υ󥹥ѿT2_001å»
        sErr = sprintf("T2_001: " + ERR_INVALID_TYPE, TSR_PRM_VAR, "Hash", hObjectInfo[TSR_PRM_VAR].class())
        aErrors.push(YamlError.new(sErr, aPath))
      end

      check_error(aErrors)
    end

    #=================================================================
    #   : °å
    #=================================================================
    def attribute_check()
      aErrors = []
      @hState.each{|sAtr, val|
        begin
          sAtr = get_real_attribute_name(sAtr)
          if (is_specified?(sAtr))
            case sAtr
            # 0ʾ
            when TSR_PRM_LEFTTMO, TSR_PRM_LEFTTIM, TSR_PRM_EXINF, TSR_PRM_BOOTCNT, TSR_PRM_PORDER,
                 TSR_PRM_CYCPHS, TSR_PRM_CYCTIM, TSR_PRM_PNDPTN, TSR_PRM_TEXPTN
              check_attribute_unsigned(sAtr, val, @aPath)

            # 0礭
            when TSR_PRM_PRCID
              check_attribute_gt(sAtr, val, 0, @aPath)

            # ʸ
            when TSR_PRM_CLASS, TSR_PRM_TASK, TSR_PRM_SPINID
              check_attribute_type(sAtr, val, String, false, @aPath)

            # ʸNil
            when TSR_PRM_WOBJID
              check_attribute_type(sAtr, val, String, true, @aPath)

            # 0ʾʸ
            when TSR_PRM_ACTPRC, TSR_PRM_EXCNO, TSR_PRM_INHNO, TSR_PRM_INTNO
              unless (val.is_a?(String))
                check_attribute_unsigned(sAtr, val, @aPath)
              end

            # 0꾮ʸ
            when TSR_PRM_INTPRI
              unless (val.is_a?(String))
                check_attribute_lt(sAtr, val, 0, @aPath)
              end

            # 
            when TSR_PRM_GLOBAL
              check_attribute_type(sAtr, val, Bool, false, @aPath)

            # ͥ
            when TSR_PRM_ITSKPRI, TSR_PRM_TSKPRI, TSR_PRM_ISRPRI
              check_attribute_range(sAtr, val, TTC_MAX_PRI, TTC_MIN_PRI, @aPath)

            # ư塼
            when TSR_PRM_ACTCNT, TSR_PRM_WUPCNT
              check_attribute_range(sAtr, val, 0, TTC_MAX_QUEUING, @aPath)

            # do
            when TSR_PRM_DO
              check_attribute_type(sAtr, val, Hash, false, @aPath)
              check_do_attribute(val, @aSpecifiedDoAttributes, @aPath + [sAtr])

            # var
            when TSR_PRM_VAR
              check_attribute_type(sAtr, val, Hash, false, @aPath)
              # ѿ̾Υå
              val.each{|sVarName, cVar|
                check_attribute_variable(sAtr, sVarName, @aPath)
                cVar.check_attribute_value()
              }

            # hdlstat
            when TSR_PRM_HDLSTAT
              if (@cConf.is_asp?())
                aList = GRP_ENUM_HDLSTAT_ASP
              elsif (@cConf.is_fmp?())
                aList = GRP_ENUM_HDLSTAT_FMP
              else
                abort(ERR_MSG % [__FILE__, __LINE__])
              end
              check_attribute_type(sAtr, val, String, false, @aPath)
              check_attribute_enum(sAtr, val, aList, @aPath)

            # state
            when TSR_PRM_TSKSTAT, TSR_PRM_ALMSTAT, TSR_PRM_CYCSTAT, TSR_PRM_TEXSTAT, TSR_PRM_INTSTAT
              # TESRYǤ᤹ͤ
              val = get_real_state_value()
              # ǽ
              if (@cConf.is_asp?())
                aList = GRP_OBJECT_STATE_AVAILABLE_ASP
              elsif (@cConf.is_fmp?())
                aList = GRP_OBJECT_STATE_AVAILABLE_FMP
              else
                abort(ERR_MSG % [__FILE__, __LINE__])
              end
              check_attribute_type(sAtr, val, String, false, @aPath)
              check_attribute_enum(sAtr, val, aList[sAtr], @aPath)

            # °
            when TSR_PRM_CYCATR, TSR_PRM_INTATR
              check_attribute_type(sAtr, val, String, false, @aPath)
              check_attribute_multi(sAtr, val, GRP_AVAILABLE_OBJATR[@sObjectType], @aPath)

            else
              abort(ERR_MSG % [__FILE__, __LINE__])
            end
          end
        rescue TTCError
          aErrors.push($!)
        end
      }

      check_error(aErrors)
    end

    #=================================================================
    #   : ֥ȥå
    #=================================================================
    def object_check(bIsPre = false)
      check_class(Bool, bIsPre)  # pre_condition

      aErrors = []
      # ѿΥå
      unless (@hState[TSR_PRM_VAR].nil?())
        @hState[TSR_PRM_VAR].each{|sVarName, cVar|
          begin
            cVar.object_check(bIsPre)
          rescue TTCMultiError
            aErrors.concat($!.message())
          end
        }
      end

      # ХΥå
      if (bIsPre == true && (@sObjectType == TSR_OBJ_INIRTN || @sObjectType == TSR_OBJ_TERRTN))
        if (@hState[TSR_PRM_GLOBAL] == true)
          ### T3_INI001: Х롼줿ȤclassꤵƤ
          ### T3_TER001: Х뽪λ롼줿ȤclassꤵƤ
          if (is_specified?(TSR_PRM_CLASS))
            sErr = sprintf(ERR_ON_GLOBAL_SET_CLASS, @sObjectID)
            if (@sObjectType == TSR_OBJ_INIRTN)
              sErr = "T3_INI001: " + sErr
            else
              sErr = "T3_TER001: " + sErr
            end
            aErrors.push(YamlError.new(sErr, @aPath))
          end
          ### T3_INI002: Х롼줿ȤprcidꤵƤ
          ### T3_TER002: Х뽪λ롼줿ȤprcidꤵƤ
          if (is_specified?(TSR_PRM_PRCID))
            sErr = sprintf(ERR_ON_GLOBAL_SET_PRCID, @sObjectID)
            if (@sObjectType == TSR_OBJ_INIRTN)
              sErr = "T3_INI002: " + sErr
            else
              sErr = "T3_TER002: " + sErr
            end
            aErrors.push(YamlError.new(sErr, @aPath))
          end
        end
      end

      check_error(aErrors)
    end

    #=================================================================
    # : ֥Υޥִ
    #=================================================================
    def convert_macro()
      super()

      # ѿ
      if (@hState[TSR_PRM_VAR].is_a?(Hash))
        @hState[TSR_PRM_VAR].each_value{|cVar|
          cVar.convert_macro()
        }
      end
    end

    #=================================================================
    #   : ХбΤѥ᡼Ѵ¹Ԥ
    #=================================================================
    def convert_global(hTable, hClassTable)
      check_class(Hash, hTable)       # Ѵɽ
      check_class(Hash, hClassTable)  # 饹ִбɽ

      super(hTable, hClassTable)

      # ѿ
      unless (@hState[TSR_PRM_VAR].nil?())
        @hState[TSR_PRM_VAR].each_value{|cVar|
          cVar.convert_global(hTable)
        }
      end
    end

    #=================================================================
    #   : ͤ䴰
    #=================================================================
    def complement_init_object_info()
      # λ롼
      if (@sObjectType == TSR_OBJ_INIRTN || @sObjectType == TSR_OBJ_TERRTN)
        hMacro = @cConf.get_macro()

        # global
        unless (is_specified?(TSR_PRM_GLOBAL))
          @hState[TSR_PRM_GLOBAL] = false
        end
        # exinf
        unless (is_specified?(TSR_PRM_EXINF))
          @hState[TSR_PRM_EXINF] = hMacro["EXINF_A"]
        end
        # gcov
        if (!@aSpecifiedDoAttributes.include?(TSR_PRM_GCOV) &&
            (@aSpecifiedDoAttributes.include?(TSR_PRM_SYSCALL) || @aSpecifiedDoAttributes.include?(TSR_PRM_CODE)))
          @hState[TSR_PRM_DO][TSR_PRM_GCOV] = true
        end
      end

      # fmp
      if (@cConf.is_fmp?())
        # globalν롼󡦽λ롼
        if ((@sObjectType == TSR_OBJ_INIRTN || @sObjectType == TSR_OBJ_TERRTN) && @hState[TSR_PRM_GLOBAL] == true)
          # class
          unless (is_specified?(TSR_PRM_CLASS))
            @hState[TSR_PRM_CLASS] = IMC_NO_CLASS
          end
          # prcid
          unless (is_specified?(TSR_PRM_PRCID))
            @hState[TSR_PRM_PRCID] = "MAIN_PRCID"
          end
        else
          # class
          unless (is_specified?(TSR_PRM_CLASS))
            if (@sObjectType == TSR_OBJ_ISR)
              @hState[TSR_PRM_CLASS] = CFG_MCR_CLS_SELF_ONLY_SELF
            else
              @hState[TSR_PRM_CLASS] = CFG_MCR_CLS_SELF_ALL
            end
          end
          # prcid
          unless (is_specified?(TSR_PRM_PRCID))
            @hState[TSR_PRM_PRCID] = CFG_MCR_PRC_SELF
          end
        end
      end
    end

    #=================================================================
    # : 䴰¹Ԥ
    #=================================================================
    def complement(cPrevObj)
      check_class(ProcessUnit, cPrevObj)  # ľξ֤Υ֥

      # ꤵƤʤ䴰
      cPrevObj.hState.each{|sAtr, val|
        sRealAtr = get_real_attribute_name(sAtr)
        if (!is_specified?(sRealAtr))
          # ѿ䴰
          if (sRealAtr == TSR_PRM_VAR && val.is_a?(Hash))
            complement_variable(val)
          else
            @hState[sAtr] = safe_dup(val)
          end
        # ѿξά줿°䴰
        elsif (sRealAtr == TSR_PRM_VAR && val.is_a?(Hash))
          complement_variable(val)
        end
      }
    end

    #=================================================================
    # : ѿ䴰¹Ԥ
    #=================================================================
    def complement_variable(hPrevVar)
      check_class(Hash, hPrevVar)  # ľξ֤ѿ

      if (@hState[TSR_PRM_VAR].nil?())
        @hState[TSR_PRM_VAR] = {}
      end
      hPrevVar.each{|sVarName, cVar|
        # ѿξ󤬾άƤʣ
        if (@hState[TSR_PRM_VAR][sVarName].nil?())
          @hState[TSR_PRM_VAR][sVarName] = cVar.dup()
          @hState[TSR_PRM_VAR][sVarName].aSpecifiedAttributes = []
        # ѿξ󤬤䴰
        else
          @hState[TSR_PRM_VAR][sVarName].complement(cVar)
        end
      }
    end

    #=================================================================
    # : ꥢ¹Ԥ
    #=================================================================
    def alias(hAlias)
      check_class(Hash, hAlias)   # ꥢѴơ֥

      super(hAlias)

      # ѿ
      unless (@hState[TSR_PRM_VAR].nil?())
        hTmp = @hState[TSR_PRM_VAR].dup()
        @hState[TSR_PRM_VAR] = {}
        hTmp.each{|sVarName, cVar|
          sAlias = hAlias[sVarName]
          cVar.alias(hAlias)
          @hState[TSR_PRM_VAR][sAlias] = cVar
        }
      end

      # do
      unless (@hState[TSR_PRM_DO].nil?())
        @hState[TSR_PRM_DO].each{|sAtr, val|
          @hState[TSR_PRM_DO][sAtr] = alias_replace(val, hAlias)
        }
      end
    end

    #=================================================================
    # : ֥ȤΥꥢѴơ֥֤
    #=================================================================
    def get_alias(sTestID, nNum = nil)
      check_class(String, sTestID)      # ƥID
      check_class(Integer, nNum, true)  # ֹ

      hResult = {}

      # ֥ID
      case @sObjectType
      # ߥϥɥξ硤٥+ֹ֤
      when TSR_OBJ_INTHDR
        hResult[@sObjectID] = "#{TTG_LBL_INTHDR}_#{@hState[TSR_PRM_INTNO]}"
      # ߥӥ롼ξ硤٥+ֹ+ƥID+֥ID֤
      when TSR_OBJ_ISR
        hResult[@sObjectID] = "#{TTG_LBL_ISR}_#{@hState[TSR_PRM_INTNO]}_#{alias_str(@sObjectID, sTestID)}"
      # CPU㳰ϥɥξ硤٥+CPU㳰ϥɥֹ֤
      when TSR_OBJ_EXCEPTION
        hResult[@sObjectID] = "#{TTG_LBL_EXCEPTION}_#{@hState[TSR_PRM_EXCNO]}"
      else
        hResult[@sObjectID] = alias_str(@sObjectID, sTestID)
      end

      # ѿ̾
      unless (@hState[TSR_PRM_VAR].nil?())
        @hState[TSR_PRM_VAR].each_key{|sVarName|
          hResult[sVarName] = alias_str(sVarName, sTestID)
        }
      end

      return hResult  # [Hash]ꥢѴơ֥
    end

    #=================================================================
    # : ֥Ȥʣ֤
    #=================================================================
    def dup()
      cObjectInfo = super()

      # ֥IDʣ
      cObjectInfo.sObjectID = safe_dup(@sObjectID)
      # ֥ȥʣ
      cObjectInfo.sObjectType = safe_dup(@sObjectType)
      # ѥ᡼ʣ
      cObjectInfo.hState = safe_dup(@hState)

      return cObjectInfo  # [Object]ʣ֥
    end

    #=================================================================
    #   : ֥ȤƤYAML֥ȤѴ֤
    #=================================================================
    def to_yaml(bIsPre = false)
      check_class(Bool, bIsPre)  # pre_condition

      hYaml = {}
      # preξtype°Ϳ
      if (bIsPre == true)
        hYaml[TSR_PRM_TYPE] = @sObjectType
      end
      # ݻƤ
      @hState.each{|sAtr, val|
        sRealAtr = get_real_attribute_name(sAtr)
        if (!val.nil?() || is_specified?(sRealAtr))
          case sAtr
          # ѿ
          when TSR_PRM_VAR
            hYaml[TSR_PRM_VAR] = {}
            val.each{|sVarName, cVar|
              hYaml[TSR_PRM_VAR][sVarName] = cVar.to_yaml()
            }
          # 
          when TSR_PRM_STATE
            hYaml[sRealAtr] = get_real_state_value()
          # ¾
          else
            hYaml[sRealAtr] = safe_dup(val)
          end
        end
      }

      return hYaml  # [Hash]YAML֥
    end

    #=================================================================
    #   : ֥¸ߤѿ֤̾
    #=================================================================
    def get_variable_names()
      aResult = []
      unless (@hState[TSR_PRM_VAR].nil?())
        aResult = @hState[TSR_PRM_VAR].keys()
      end

      return aResult  # [Array]֥¸ߤѿ̾
    end

    #=================================================================
    #   : ݻ°̾TESRY°̾
    #=================================================================
    def get_real_attribute_name(sAtr)
      check_class(String, sAtr)  # ݻ°̾

      case sAtr
      when TSR_PRM_STATE
        sAtr = GRP_PRM_KEY_PROC_STAT[@sObjectType]
      when TSR_PRM_ATR
        sAtr = GRP_PRM_KEY_PROC_ATR[@sObjectType]
      when TSR_PRM_LEFTTMO
        if (@sObjectType != TSR_OBJ_TASK)
          sAtr = TSR_PRM_LEFTTIM
        end
      end

      return sAtr  # [String]TESRY°̾
    end

    #=================================================================
    #   : ݻѾ°TESRYξ°
    #=================================================================
    def get_real_state_value()
      if (@bConvertState == true)
        val = GRP_OBJECT_STATE.index(@hState[TSR_PRM_STATE])
      else
        val = @hState[TSR_PRM_STATE]
      end

      return val  # [String]TESRY°
    end

    #=================================================================
    #   : YAMLؤΥѥꤹ
    #=================================================================
    def set_path(aPath)
      check_class(Array, aPath)  # 롼ȤΥѥ

      super(aPath)
      if (@hState[TSR_PRM_VAR].is_a?(Hash))
        @hState[TSR_PRM_VAR].each{|sVarName, cVar|
          cVar.aPath = aPath + [sVarName]
        }
      end
    end

    #=================================================================
    #   : Yaml˵ҤƤѥ᡼ꥹȤϿ
    #=================================================================
    def set_specified_attribute(hObjectInfo)
      check_class(Hash, hObjectInfo)  # ֥Ⱦ

      super(hObjectInfo)

      # λ롼do
      if (hObjectInfo[TSR_PRM_DO].is_a?(Hash))
        @aSpecifiedDoAttributes = hObjectInfo[TSR_PRM_DO].keys()
      end
    end

    #=================================================================
    #   : valueѿ뤫֤
    #=================================================================
    def is_value_set_variable?()
      bResult = false

      if (is_specified?(TSR_PRM_VAR))
        @hState[TSR_PRM_VAR].each_value{|cVar|
          if (cVar.is_value_set?())
            bResult = true
            break
          end
        }
      end

      return bResult  # [Bool]valueѿ뤫
    end

    #=================================================================
    #   : activateʽñ̤֤
    #=================================================================
    def is_activate?()
      case @sObjectType
      when TSR_OBJ_TASK
        bResult = GRP_ACTIVATE.include?(@hState[TSR_PRM_STATE])
      when TSR_OBJ_INIRTN, TSR_OBJ_TERRTN
        bResult = false
      else
        bResult = GRP_ACTIVATE.include?(@hState[TSR_PRM_HDLSTAT])
      end

      return bResult  # [Bool]activateʽñ̤
    end

    #=================================================================
    #   : ԥåԤνñ̤
    #=================================================================
    def is_spinlock_waiting?()
      case @sObjectType
      when TSR_OBJ_TASK
        bResult = (@hState[TSR_PRM_STATE] == TSR_STT_R_WAITSPN)
      when TSR_OBJ_INIRTN, TSR_OBJ_TERRTN
        bResult = false
      else
        bResult = (@hState[TSR_PRM_HDLSTAT] == TSR_STT_A_WAITSPN)
      end

      return bResult  # [Bool]ԥåԤνñ̤
    end

    #=================================================================
    #   : lefttmolefttimꤵƤ뤫
    #=================================================================
    def has_lefttmo?()
      return !(@hState[TSR_PRM_LEFTTMO].nil?())  # [Bool]lefttmolefttimꤵƤ뤫
    end

    #=================================================================
    #   : ߥϥɥȳߥӥ롼ξ֤֤
    #=================================================================
    def is_initial_status?()
      return ((@hState[TSR_PRM_ATR] == KER_TA_NULL && @hState[TSR_PRM_STATE] == KER_TA_DISINT) ||
              (@hState[TSR_PRM_ATR] == KER_TA_ENAINT && @hState[TSR_PRM_STATE] == KER_TA_ENAINT))
             # [Bool]ߥϥɥȳߥӥ롼ξ֤֤
    end
  end
end
