#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Task.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "ttc/bin/process_unit/ProcessUnit.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Task
  #     : ξ륯饹
  #===================================================================
  class Task < ProcessUnit
    #=================================================================
    #   : ֥ȥå
    #=================================================================
    def object_check(bIsPre)
      check_class(Bool, bIsPre)  # pre_condition

      aErrors = []
      begin
        super(bIsPre)
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      # Ԥ֤ξ
      if (GRP_TASK_WAITING.include?(@hState[TSR_PRM_STATE]))
        ### T3_TSK001: ֤Ԥ֤ǤΤԤоݤꤵƤʤ
        if (@hState[TSR_PRM_WOBJID].nil?())
          aErrors.push(YamlError.new("T3_TSK001: " + ERR_NO_WOBJID_WAITING, @aPath))
        ### T3_TSK002: ֤Ԥ֤ԤоݤSLEEPξ˵׵ᥭ塼󥰿ꤵƤ
        elsif (@hState[TSR_PRM_WOBJID] == TSR_STT_SLEEP && !@hState[TSR_PRM_WUPCNT].nil?() && @hState[TSR_PRM_WUPCNT] > 0)
          aErrors.push(YamlError.new("T3_TSK002: " + ERR_SLEEPING_CANNOT_WUP, @aPath))
        ### T3_TSK003: pre_conditionDELAYԤλл֤ꤵƤʤ
        elsif (bIsPre == true && @hState[TSR_PRM_WOBJID] == TSR_STT_DELAY && @hState[TSR_PRM_LEFTTMO].nil?())
          aErrors.push(YamlError.new("T3_TSK003: " + ERR_NO_LEFTTMO_DELAY, @aPath))
        end
      ### T3_TSK004: Ԥ֤ǤϤʤΤԤоݤꤵƤ
      elsif (!@hState[TSR_PRM_WOBJID].nil?())
        aErrors.push(YamlError.new("T3_TSK004: " + ERR_SET_WOBJID_NO_WAITING, @aPath))
      end

      ### T3_TSK005: actcnt0ǤΤactprcꤵƤ
      if (@hState[TSR_PRM_ACTCNT] == 0 && !@hState[TSR_PRM_ACTPRC].nil?() && @hState[TSR_PRM_ACTPRC] != KER_TPRC_NONE)
        aErrors.push(YamlError.new("T3_TSK005: " + ERR_SET_ACTPRC_NO_ACTCNT, @aPath))
      end
      ### T3_TSK006: ֤ԥåԤλspinidꤵƤʤ
      if (@hState[TSR_PRM_STATE] == TSR_STT_R_WAITSPN && @hState[TSR_PRM_SPINID].nil?())
        aErrors.push(YamlError.new("T3_TSK006: " + ERR_NO_SPINID_WAITING, @aPath))
      end

      # dormantΥ
      if (is_dormant?())
        @aSpecifiedAttributes.each{|sAtr|
          ### T3_TSK007: ٻ߾֤ξ˻Ǥʤѥ᡼ꤵƤ
          if (sAtr != TSR_PRM_TYPE && !GRP_ACTIVATE_PRM_ON_DORMANT[TSR_OBJ_TASK].include?(sAtr))
            sErr = sprintf("T3_TSK007: " + ERR_ATR_DORMANT_TASK, sAtr)
            aErrors.push(YamlError.new(sErr, @aPath))
          end
        }
      end

      check_error(aErrors)
    end

    #=================================================================
    #   : ͤ䴰
    #=================================================================
    def complement_init_object_info()
      super()
      hMacro  = @cConf.get_macro()

      # tskpri
      unless (is_specified?(TSR_PRM_TSKPRI))
        @hState[TSR_PRM_TSKPRI]  = hMacro["TSK_PRI_MID"]
      end
      # itskpri
      unless (is_specified?(TSR_PRM_ITSKPRI))
        @hState[TSR_PRM_ITSKPRI] = hMacro["TSK_PRI_MID"]
      end
      # exinf
      if (!is_specified?(TSR_PRM_EXINF) && @sObjectType != TSR_OBJ_TASK_EXC)
        @hState[TSR_PRM_EXINF] = hMacro["EXINF_A"]
      end
      # bootcnt
      unless (is_specified?(TSR_PRM_BOOTCNT))
        @hState[TSR_PRM_BOOTCNT] = 0
      end
    end

    #=================================================================
    # : 䴰¹Ԥ
    #=================================================================
    def complement(cPrevObjectInfo)
      check_class(ProcessUnit, cPrevObjectInfo)  # ľΥ֥Ⱦ

      super(cPrevObjectInfo)

      # 䴰㳰(1)
      if (!is_specified?(TSR_PRM_WOBJID) && (cPrevObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_WAI ||
          cPrevObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_WAS) && 
          (@hState[TSR_PRM_STATE] != KER_TTS_WAI && @hState[TSR_PRM_STATE] != KER_TTS_WAS))
        @hState[TSR_PRM_WOBJID] = nil
        @hState[TSR_PRM_TSKWAIT] = nil
      end
      # 䴰㳰(2)
      if (!is_specified?(TSR_PRM_LEFTTMO) && (cPrevObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_WAI ||
          cPrevObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_WAS) && 
          !cPrevObjectInfo.hState[TSR_PRM_WOBJID].nil?() && !cPrevObjectInfo.hState[TSR_PRM_LEFTTMO].nil?() &&
          ((@hState[TSR_PRM_STATE] != KER_TTS_WAI && @hState[TSR_PRM_STATE] != KER_TTS_WAS) || 
           cPrevObjectInfo.hState[TSR_PRM_WOBJID] != @hState[TSR_PRM_WOBJID]))
        @hState[TSR_PRM_LEFTTMO] = nil
      end
      # 䴰㳰(4)
      if (!is_specified?(TSR_PRM_PORDER) && (cPrevObjectInfo.hState[TSR_PRM_STATE] != @hState[TSR_PRM_STATE] ||
          cPrevObjectInfo.hState[TSR_PRM_TSKPRI] != @hState[TSR_PRM_TSKPRI]))
        @hState[TSR_PRM_PORDER] = nil
      end
    end

    #=================================================================
    # : 䴰λ˼¹Ԥ
    #=================================================================
    def complement_after()
      # dormantξ硤Υѥ᡼̵Ȥ
      if (@hState[TSR_PRM_STATE] == KER_TTS_DMT)
        @hState.each_key{|sAtr|
          if (!is_specified?(sAtr) && !GRP_COMPLEMENT_PRM_ON_DORMANT.include?(sAtr))
            @hState[sAtr] = nil
          end
        }
      end
    end

    #=================================================================
    # : ԤоݤꤵƤ뤫֤
    #=================================================================
    def has_wait_target?()
      return !(@hState[TSR_PRM_WOBJID].nil?())
    end

    #=================================================================
    # : Ԥ֥ȤꤵƤ뤫֤
    #=================================================================
    def has_wait_object?()
      return (has_wait_target?() && !GRP_WAIT_NON_OBJECT.include?(@hState[TSR_PRM_WOBJID]))  # [Bool]Ԥ֥ȤꤵƤ뤫
    end

    #=================================================================
    # : ¹Բǽ֤֤
    #=================================================================
    def is_ready?()
      return (@hState[TSR_PRM_STATE] == KER_TTS_RDY)  # [Bool]¹Բǽ֤
    end

    #=================================================================
    # : ֥Ԥ֤֤
    #=================================================================
    def is_object_waiting?()
      return ([KER_TTS_WAI, KER_TTS_WAS].include?(@hState[TSR_PRM_STATE]))  # [Bool]֥Ԥ֤
    end

    #=================================================================
    # : ٻ߾֤֤
    #=================================================================
    def is_dormant?()
      return (@hState[TSR_PRM_STATE] == KER_TTS_DMT)  # [Bool]ٻ߾֤
    end

    #=================================================================
    # : Ͼ֤֤
    #=================================================================
    def is_running_suspended?()
      return (@hState[TSR_PRM_STATE] == KER_TTS_RUS)  # [Bool]Ͼ֤
    end
  end
end
