#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2012 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#  Copyright (C) 2012 by FUJISOFT INCORPORATED
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Variable.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "ttc/bin/class/TTCCommon.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Variable
  #     : variableξ륯饹
  #===================================================================
  class Variable
    include TTCModule
    include TTCModule::ObjectCommon

    #=================================================================
    #   : ͤΥå
    #=================================================================
    def check_attribute_value()
      check_attribute_type(TSR_PRM_VAR_TYPE, @sType, String, false, @aPath)
      check_attribute_type(TSR_PRM_VAR_VALUE, @snValue, [String, Integer], true, @aPath)
      if (!@hMember.nil?())
        @hMember.each_value{|val|
          check_attribute_type("member", val, [String, Integer], false, @aPath)
        }
      end
    end

    #=================================================================
    #   : ֥ȥå
    #=================================================================
    def object_check(bIsPre)
      check_class(Bool, bIsPre)  # pre_condition

      aErrors = []
      # ¤Τξ
      if (STR_INITIAL_INFO.has_key?(@sType))
        ### T3_VAR001: ѿ¤Τξˤι¤ΤΥаʳѤƤ
        # ̾
        aMemberNames = []
        STR_INITIAL_INFO[@sType].each{|aMember|
          aMemberNames.push(aMember[0])
        }
        # ƤФѤǤΤ
        unless (@hMember.nil?())
          @hMember.each_key{|sMember|
            unless (aMemberNames.include?(sMember))
              sErr = sprintf("T3_VAR001: " + ERR_VAR_UNDEFINED_MEMBER, sMember, @sType)
              aErrors.push(YamlError.new(sErr, @aPath))
            end
          }
        end
        ### T3_VAR003: ѿ¤Τξvalue°Ƥ
        unless (@snValue.nil?())
          aErrors.push(YamlError.new("T3_VAR003: " + ERR_VAR_INVALID_DEFINE_VALUE, @aPath))
        end
      ### T3_VAR002: ѿǡξ˥ФƤ
      elsif (!@hMember.nil?())
        aErrors.push(YamlError.new("T3_VAR002: " + ERR_VAR_INVALID_DEFINE_MEMBER, @aPath))
      end

      check_error(aErrors)
    end

    #=================================================================
    #   : valueƤ뤫֤
    #=================================================================
    def is_value_set?()
      return !(@snValue.nil?() && @hMember.nil?())  # [Bool]valueƤ뤫
    end

    #=================================================================
    # : ѿΥޥִ
    #=================================================================
    def convert_macro()
      hMacro = @cConf.get_macro()
      # 
      @snValue = calc_all_expr(@snValue, hMacro)
      # 
      unless (@hMember.nil?())
        @hMember.each{|sAtr, val|
          @hMember[sAtr] = calc_all_expr(@hMember[sAtr], hMacro)
        }
      end
    end

    #=================================================================
    #   : ХбΤѥ᡼Ѵ¹Ԥ
    #=================================================================
    def convert_global(hTable)
      check_class(Hash, hTable)  # бɽ

      # 
      if (@snValue.is_a?(String))
        @snValue = convert_global_params(@snValue, hTable)
      end
      # 
      unless (@hMember.nil?())
        @hMember.each{|sAtr, val|
          if (@hMember[sAtr].is_a?(String))
            @hMember[sAtr] = convert_global_params(@hMember[sAtr], hTable)
          end
        }
      end
    end

    #=================================================================
    # : 䴰¹Ԥ
    #=================================================================
    def complement(cPrevVar)
      check_class(Variable, cPrevVar)  # ľξ֤ѿ

      # 
      if (@sType.nil?())
        @sType = safe_dup(cPrevVar.sType)
      end
      # 
      unless (is_specified?(TSR_PRM_VAR_VALUE))
        @snValue = safe_dup(cPrevVar.snValue)
      end
      # ¤
      if (!cPrevVar.hMember.nil?() && !@hMember.nil?())
        cPrevVar.hMember.each{|sAtr, val|
          unless (is_specified?(sAtr))
            @hMember[sAtr] = safe_dup(val)
          end
        }
      end
    end

    #=================================================================
    # : ꥢ¹Ԥ
    #=================================================================
    def alias(hAlias)
      check_class(Hash, hAlias)   # ꥢѴơ֥

      # ѿ̾
      @sVarName = hAlias[@sVarName]
      # 
      if (@snValue.is_a?(String))
        @snValue = alias_replace(@snValue, hAlias)
      end
      # 
      unless (@hMember.nil?())
        @hMember.each{|sAtr, val|
          @hMember[sAtr] = alias_replace(val, hAlias)
        }
      end
    end

    #=================================================================
    # : ֥Ȥʣ֤
    #=================================================================
    def dup()
      cVar = super()

      # ѿ̾ʣ
      cVar.sVarName = safe_dup(@sVarName)
      # ʣ
      cVar.sType = safe_dup(@sType)
      # ʣ
      cVar.snValue = safe_dup(@snValue)
      # ¤ʣ
      unless (@hMember.nil?())
        hNewMember = {}
        @hMember.each{|atr, val|
          hNewMember[atr] = safe_dup(val)
        }
        cVar.hMember = hNewMember
      end

      return cVar  # [Object]ʣ֥
    end

    #=================================================================
    #   : ֥ȤƤyaml֥Ȥˤƽ
    #=================================================================
    def to_yaml()
      hYaml = {}

      # 󥹥ѿ
      unless (@sVarName.nil?())
        hYaml["@sVarName"] = @sVarName
      end
      # type
      hYaml[TSR_PRM_VAR_TYPE] = @sType
      # value
      if (!@snValue.nil?() || is_specified?(TSR_PRM_VAR_VALUE))
        hYaml[TSR_PRM_VAR_VALUE] = @snValue
      end
      # ¤ΤΥ
      unless (@hMember.nil?())
        @hMember.each{|atr, val|
          hYaml[atr] = val
        }
      end

      return hYaml  # [Hash]YAML֥
    end
  end
end
