#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Mailbox.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "ttc/bin/sc_object/SCObject.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Mailbox
  #     : ᡼ܥåξ륯饹
  #===================================================================
  class Mailbox < SCObject
    #=================================================================
    #   : °å
    #=================================================================
    def attribute_check()
      aErrors = []
      begin
        super()
      rescue TTCMultiError
        aErrors = $!.message()
      end

      begin
        # wtsklist
        sAtr = TSR_PRM_WTSKLIST
        if (is_specified?(sAtr))
          cProc = Proc.new(){|hData, aPath|
            if (hData.is_a?(Hash))
              aProcErrors = []
              hData.each{|atr, val|
                begin
                  if (atr == TSR_VAR_VAR)
                    check_attribute_variable(atr, val, aPath)
                  else
                    sErr = sprintf(ERR_UNDEFINED_KEY, atr)
                    raise(YamlError.new(sErr, aPath))
                  end
                rescue YamlError
                  aProcErrors.push($!)
                end
              }
              check_error(aProcErrors)
            elsif (!hData.nil?())
              sErr = sprintf(ERR_LIST_ITEM_INVALID_TYPE_NIL, sAtr, Hash, hData.class())
              raise(YamlError.new(sErr, aPath))
            end
          }
          attribute_check_task_list(sAtr, @hState[sAtr], cProc)
        end
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      begin
        # msglist
        sAtr = TSR_PRM_MSGLIST
        if (is_specified?(sAtr))
          check_attribute_type(sAtr, @hState[sAtr], Array, false, @aPath)
          aPath = @aPath + [sAtr]
          aTmpErrors = []
          @hState[sAtr].each_with_index{|hData, nIndex|
            # ꥹȤǤHash
            unless (hData.is_a?(Hash))
              sErr = sprintf(ERR_LIST_INVALID_TYPE, sAtr, Hash, hData.class())
              raise(YamlError.new(sErr, aPath + [nIndex]))
            end
            # Ǥƥå
            hData.each{|atr, val|
              begin
                case atr
                when TSR_VAR_MSG
                  check_attribute_variable(atr, val, aPath + [nIndex])
                when TSR_VAR_MSGPRI
                  check_attribute_range(atr, val, TTC_MAX_PRI, TTC_MIN_PRI, aPath + [nIndex])
                else
                  sErr = sprintf(ERR_UNDEFINED_KEY, atr)
                  raise(YamlError.new(sErr, aPath + [nIndex]))
                end
              rescue YamlError
                aTmpErrors.push($!)
              end
            }
          }
          check_error(aTmpErrors)
        end
      rescue YamlError
        aErrors.push($!)
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      check_error(aErrors)
    end

    #=================================================================
    #   : ֥ȥå
    #=================================================================
    def object_check(bIsPre)
      check_class(Bool, bIsPre)  # pre_condition

      aErrors = []
      begin
        super(bIsPre)
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      ### T3_MBX001: ᡼ܥå°TA_MPRIλ˼ԤåꥹȤΥå
      ###          : åإåѿ̾ͥ٤°ҤƤʤ
      unless (@hState[TSR_PRM_MSGLIST].nil?())
        if (@hState[TSR_PRM_ATR] == KER_TA_MPRI)
          @hState[TSR_PRM_MSGLIST].each_with_index{|hData, index|
            if (hData[TSR_VAR_MSG].nil?() || hData[TSR_VAR_MSGPRI].nil?())
              aErrors.push(YamlError.new("T3_MBX001: " + ERR_MSGLIST_VARS_MUST_DEFINE, @aPath + [index]))
            end
          }
        ### T3_MBX002: ᡼ܥå°TA_MPRIʳλ˼ԤåꥹȤΥå
        ###          : ͥ٤°ҤƤ
        else
          @hState[TSR_PRM_MSGLIST].each_with_index{|hData, index|
            if (hData.has_key?(TSR_VAR_MSGPRI))
              aErrors.push(YamlError.new("T3_MBX002: " + ERR_CANNOT_BE_DEFINED_MSGPRI, @aPath + [index]))
            end
          }
        end
        ### T3_MBX003: msglistΥꥹȤƱѿİʾ¸ߤ
        aVarName = []
        @hState[TSR_PRM_MSGLIST].each{|hData|
          if (hData.has_key?(TSR_VAR_MSG))
            if (aVarName.include?(hData[TSR_VAR_MSG]))
              sErr = sprintf("T3_MBX003: " + ERR_MSGLIST_VAR_DUPLICATE, hData[TSR_VAR_MSG])
              aErrors.push(YamlError.new(sErr, @aPath))
            end
            aVarName.push(hData[TSR_VAR_MSG])
          end
        }
      end

      check_error(aErrors)
    end

    #=================================================================
    #   : ͤ䴰
    #=================================================================
    def complement_init_object_info()
      super()

      # mbxatr
      unless (is_specified?(TSR_PRM_MBXATR))
        @hState[TSR_PRM_ATR] = "ANY_ATT_MBX"
      end
      # maxmpri
      unless (is_specified?(TSR_PRM_MAXMPRI))
        @hState[TSR_PRM_MAXMPRI] = "MSG_PRI_MAX"
      end
    end

    #=================================================================
    #   : ԤꥹѿȷȤ߹碌֤
    #=================================================================
    def get_wtsklist_variable()
      hVars = {}
      unless (@hState[TSR_PRM_WTSKLIST].nil?())
        @hState[TSR_PRM_WTSKLIST].each{|hTask|
          hTask.each{|sTask, hData|
            unless (hData.nil?())
              hVars[sTask] = {}
              hData.each{|sAtr, sVarName|
                if (sAtr == TSR_VAR_VAR)
                  hVars[sTask][sVarName] = [TYP_T_P_MSG, TYP_T_P_MSG_PRI]
                end
              }
            end
          }
        }
      end

      return hVars  # [Hash]ԤꥹѿȷȤ߹碌
    end

    #=================================================================
    #   : åꥹѿȷȤ߹碌֤
    #=================================================================
    def get_msglist_variable()
      hVars = {}
      unless (@hState[TSR_PRM_MSGLIST].nil?())
        @hState[TSR_PRM_MSGLIST].each{|hData|
          unless (hData.nil?())
            hData.each{|sAtr, sVarName|
              if (sAtr == TSR_VAR_MSG)
                if (@hState[TSR_PRM_ATR] == KER_TA_MPRI)
                  hVars[sVarName] = [TYP_T_MSG_PRI]
                else
                  hVars[sVarName] = [TYP_T_MSG]
                end
              end
            }
          end
        }
      end

      return hVars  # [Hash]åꥹѿȷȤ߹碌
    end
  end
end
