#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: PriDataQ.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "ttc/bin/sc_object/SCObject.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: PriDataQ
  #     : ͥ٥ǡ塼ξ륯饹
  #===================================================================
  class PriDataQ < SCObject
    #=================================================================
    #   : °å
    #=================================================================
    def attribute_check()
      aErrors = []
      begin
        super()
      rescue TTCMultiError
        aErrors = $!.message()
      end

      begin
        # stsklist
        sAtr = TSR_PRM_STSKLIST
        if (is_specified?(sAtr))
          cProc = Proc.new(){|hData, aPath|
            # ǤΥå
            if (hData.is_a?(Hash))
              # ɬפǤꤵƤ뤫å
              unless (hData.has_key?(TSR_VAR_DATA) && hData.has_key?(TSR_VAR_DATAPRI))
                sErr = sprintf("T3_DO001: " + ERR_REQUIRED_KEY, "#{TSR_VAR_DATA} and #{TSR_VAR_DATAPRI}")
                raise(YamlError.new(sErr, aPath))
              else
                aProcErrors = []
                hData.each{|atr, val|
                  begin
                    case atr
                    when TSR_VAR_DATA
                      check_attribute_unsigned(atr, val, aPath)
                    when TSR_VAR_DATAPRI
                      check_attribute_range(atr, val, TTC_MAX_PRI, TTC_MIN_PRI, aPath)
                    else
                      sErr = sprintf(ERR_UNDEFINED_KEY, atr)
                      raise(YamlError.new(sErr, aPath))
                    end
                  rescue YamlError
                    aProcErrors.push($!)
                  end
                }
                check_error(aProcErrors)
              end
            else
              sErr = sprintf(ERR_LIST_ITEM_INVALID_TYPE, sAtr, Hash, hData.class())
              raise(YamlError.new(sErr, aPath))
            end
          }
          attribute_check_task_list(sAtr, @hState[sAtr], cProc)
        end
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      begin
        # rtsklist
        sAtr = TSR_PRM_RTSKLIST
        if (is_specified?(sAtr))
          cProc = Proc.new(){|hData, aPath|
            if (hData.is_a?(Hash))
              aProcErrors = []
              hData.each{|atr, val|
                begin
                  case atr
                  when TSR_VAR_VARDATA, TSR_VAR_VARPRI
                    check_attribute_variable(atr, val, aPath)
                  else
                    sErr = sprintf(ERR_UNDEFINED_KEY, atr)
                    raise(YamlError.new(sErr, aPath))
                  end
                rescue YamlError
                  aProcErrors.push($!)
                end
              }
              check_error(aProcErrors)
            elsif (!hData.nil?())
              sErr = sprintf(ERR_LIST_ITEM_INVALID_TYPE_NIL, sAtr, Hash, hData.class())
              raise(YamlError.new(sErr, aPath))
            end
          }
          attribute_check_task_list(sAtr, @hState[sAtr], cProc)
        end
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      begin
        # datalist
        sAtr = TSR_PRM_DATALIST
        if (is_specified?(sAtr))
          check_attribute_type(sAtr, @hState[sAtr], Array, false, @aPath)
          aPath = @aPath + [sAtr]
          aTmpErrors = []
          @hState[sAtr].each_with_index{|hData, nIndex|
            # ꥹȤǤHash
            unless (hData.is_a?(Hash))
              sErr = sprintf(ERR_LIST_INVALID_TYPE, sAtr, Hash, hData.class())
              raise(YamlError.new(sErr, aPath + [nIndex]))
            end
            # ɬפǤꤵƤ뤫å
            unless (hData.has_key?(TSR_VAR_DATA) && hData.has_key?(TSR_VAR_DATAPRI))
              sErr = sprintf("T3_DO001: " + ERR_REQUIRED_KEY, "#{TSR_VAR_DATA}\" and \"#{TSR_VAR_DATAPRI}")
              raise(YamlError.new(sErr, aPath + [nIndex]))
            end
            # Ǥƥå
            hData.each{|atr, val|
              begin
                case atr
                when TSR_VAR_DATA
                  check_attribute_unsigned(atr, val, aPath + [nIndex])
                when TSR_VAR_DATAPRI
                  check_attribute_range(atr, val, TTC_MAX_PRI, TTC_MIN_PRI, aPath + [nIndex])
                else
                  sErr = sprintf(ERR_UNDEFINED_KEY, atr)
                  raise(YamlError.new(sErr, aPath + [nIndex]))
                end
              rescue YamlError
                aTmpErrors.push($!)
              end
            }
          }
          check_error(aTmpErrors)
        end
      rescue YamlError
        aErrors.push($!)
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      check_error(aErrors)
    end

    #=================================================================
    #   : ֥ȥå
    #=================================================================
    def object_check(bIsPre)
      check_class(Bool, bIsPre)  # pre_condition

      aErrors = []
      begin
        super(bIsPre)
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      # datalistΥ
      if (@hState[TSR_PRM_DATALIST].nil?())
        nDataCount = 0
      else
        nDataCount = @hState[TSR_PRM_DATALIST].size()
      end
      ### T3_PDQ001: ΰ˶ΤԤ
      if (@hState[TSR_PRM_DATACNT] > nDataCount && !@hState[TSR_PRM_STSKLIST].nil?() && !@hState[TSR_PRM_STSKLIST].empty?())
        aErrors.push(YamlError.new("T3_PDQ001: " + ERR_SEND_WAITING_HAVE_SPACE, @aPath))
      end
      ### T3_PDQ002: ΰ˥ǡäƤΤ˼Ԥ
      if (nDataCount > 0 && !@hState[TSR_PRM_RTSKLIST].nil?() && !@hState[TSR_PRM_RTSKLIST].empty?())
        aErrors.push(YamlError.new("T3_PDQ002: " +ERR_RECV_WAITING_HAVE_DATA, @aPath))
      end
      ### T3_PDQ003: ΰʾΥǡäƤ
      if (nDataCount > @hState[TSR_PRM_DATACNT])
        aErrors.push(YamlError.new("T3_PDQ003: " +ERR_DATALIST_HAVE_OVER_DATA, @aPath))
      end

      check_error(aErrors)
    end

    #=================================================================
    #   : ͤ䴰
    #=================================================================
    def complement_init_object_info()
      super()

      # pdqatr
      unless (is_specified?(TSR_PRM_PDQATR))
        @hState[TSR_PRM_ATR] = "ANY_ATT_PDQ"
      end
      # maxdpri
      unless (is_specified?(TSR_PRM_MAXDPRI))
        @hState[TSR_PRM_MAXDPRI] = "DATA_PRI_MAX"
      end
      # pdqcnt
      unless (is_specified?(TSR_PRM_PDQCNT))
        @hState[TSR_PRM_DATACNT] = "ANY_DATA_CNT"
      end
    end

    #=================================================================
    #   : ԤꥹѿȷȤ߹碌֤
    #=================================================================
    def get_rtsklist_variable()
      hVars = {}
      unless (@hState[TSR_PRM_RTSKLIST].nil?())
        @hState[TSR_PRM_RTSKLIST].each{|hTask|
          hTask.each{|sTask, hData|
            unless (hData.nil?())
              hVars[sTask] = {}
              hData.each{|sAtr, sVarName|
                case sAtr
                when TSR_VAR_VARDATA
                  hVars[sTask][sVarName] = [TYP_INTPTR_T]
                when TSR_VAR_VARPRI
                  hVars[sTask][sVarName] = [TYP_PRI]
                end
              }
            end
          }
        }
      end

      return hVars  # [Hash]ԤꥹѿȷȤ߹碌
    end
  end
end
