#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Semaphore.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "ttc/bin/sc_object/SCObject.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Semaphore
  #     : ޥեξ륯饹
  #===================================================================
  class Semaphore < SCObject
    #=================================================================
    #   : °å
    #=================================================================
    def attribute_check()
      aErrors = []
      begin
        super()
      rescue TTCMultiError
        aErrors = $!.message()
      end

      begin
        # wtsklist
        sAtr = TSR_PRM_WTSKLIST
        if (is_specified?(sAtr))
          cProc = Proc.new(){|val, aPath|
            unless (val.nil?())
              sErr = sprintf(ERR_LIST_ITEM_INVALID_TYPE, sAtr, NilClass, val.class())
              raise(YamlError.new(sErr, aPath))
            end
          }
          attribute_check_task_list(sAtr, @hState[sAtr], cProc)
        end
      rescue YamlError
        aErrors.push($!)
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      check_error(aErrors)
    end

    #=================================================================
    #   : ֥ȥå
    #=================================================================
    def object_check(bIsPre)
      check_class(Bool, bIsPre)  # pre_condition

      aErrors = []
      begin
        super(bIsPre)
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      ### T3_SEM001: 񸻿isemcntˤ񸻿maxsemˤ礭
      if (@hState[TSR_PRM_ISEMCNT] > @hState[TSR_PRM_MAXSEM])
        sErr = sprintf("T3_SEM001: " + ERR_OVER_THAN_MAXSEM, TSR_PRM_ISEMCNT)
        aErrors.push(YamlError.new(sErr, @aPath))
      end
      ### T3_SEM002: ߻񸻿semcntˤ񸻿maxsemˤ礭
      if (@hState[TSR_PRM_SEMCNT] > @hState[TSR_PRM_MAXSEM])
        sErr = sprintf("T3_SEM002: " + ERR_OVER_THAN_MAXSEM, TSR_PRM_SEMCNT)
        aErrors.push(YamlError.new(sErr, @aPath))
      end

      check_error(aErrors)
    end

    #=================================================================
    #   : ͤ䴰
    #=================================================================
    def complement_init_object_info()
      super()

      # sematr
      unless (is_specified?(TSR_PRM_SEMATR))
        @hState[TSR_PRM_ATR] = "ANY_ATT_SEM"
      end
      # maxsem
      unless (is_specified?(TSR_PRM_MAXSEM))
        @hState[TSR_PRM_MAXSEM]  = "ANY_MAX_SEMCNT"
      end
      # isemcnt
      unless (is_specified?(TSR_PRM_ISEMCNT))
        @hState[TSR_PRM_ISEMCNT] = "ANY_INI_SEMCNT"
      end
      # semcnt
      unless (is_specified?(TSR_PRM_SEMCNT))
        @hState[TSR_PRM_SEMCNT]  = "ANY_NOW_SEMCNT"
      end
    end
  end
end
