#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: PreCondition.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: PreCondition
  #     : pre_conditionξ륯饹
  #===================================================================
  class PreCondition < Condition
    #=================================================================
    # : pre_conditionι¤å
    #=================================================================
    def basic_check(hScenarioPre)
      check_class(Hash, hScenarioPre)  # pre_condition

      aErrors = []
      aPath = get_condition_path()
      # ֥Ȥι¤å
      hScenarioPre.each{|sObjectID, hObjectInfo|
        begin
          common_basic_check(sObjectID, hObjectInfo, aPath)

          # ֥Ȥι¤꤬ʤХ°Υå
          ### T1_018: pre_conditionΥ֥Ȥtype°Ƥʤ
          unless (hObjectInfo.has_key?(TSR_PRM_TYPE))
            sErr = sprintf("T1_018: " + ERR_REQUIRED_KEY, TSR_PRM_TYPE)
            aErrors.push(YamlError.new(sErr, aPath + [sObjectID]))
          else
            # Ǥ륪֥ȥ
            if (@cConf.is_asp?())
              aObjectType = GRP_DEF_OBJECT_ASP.keys()
            elsif (@cConf.is_fmp?())
              aObjectType = GRP_DEF_OBJECT_FMP.keys()
            else
              abort(ERR_MSG % [__FILE__, __LINE__])
            end
            ### T1_017: ꤵ줿֥ȥפƤʤ
            unless (aObjectType.include?(hObjectInfo[TSR_PRM_TYPE]))
              sErr = sprintf("T1_017: " + ERR_OBJECT_UNDEFINED, hObjectInfo[TSR_PRM_TYPE])
              aErrors.push(YamlError.new(sErr, aPath + [sObjectID]))
            end
          end
        rescue TTCMultiError
          aErrors.concat($!.message())
        end
      }

      check_error(aErrors)
    end

    #=================================================================
    #   : ǥå
    #=================================================================
    def condition_check()
      aErrors = []
      aPath = get_condition_path()

      begin
        super()
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      # CPU_STATEν
      aCpuLock = []
      hObjects = get_objects_by_type(TSR_OBJ_CPU_STATE)
      hObjects.each_value{|cObjectInfo|
        nPrcid = cObjectInfo.get_process_id()
        aCpuLock[nPrcid] = cObjectInfo
      }


      # ñ̤Υå
      hExistFlags = {:bProcessUnit => false, :bTask => false}
      hPOrder     = Hash.new{|hash, key|
        hash[key] = {:cRunning => nil, :aOthers => []}
      }
      hObjects = get_objects_by_type(GRP_PROCESS_UNIT_ALL)
      hObjects.each{|sObjectID, cObjectInfo|
        # 
        if (cObjectInfo.sObjectType == TSR_OBJ_TASK)
          # ¸ߥե饰true
          hExistFlags[:bTask] = true
          # ͥٵžåΤΥǡ
          nPrcid = cObjectInfo.get_process_id()
          if (cObjectInfo.is_activate?())
            hPOrder[nPrcid][:cRunning] = cObjectInfo
          else
            hPOrder[nPrcid][:aOthers].push(cObjectInfo) 
          end
        end
        # ¹νñ̤¸
        if (cObjectInfo.is_activate?())
          # ¸ߥե饰true
          hExistFlags[:bProcessUnit] = true
        end
      }
      ### T4_001: pre_conditionǼ¹Ծ֤νñ̤¸ߤʤ
      if (hExistFlags[:bProcessUnit] == false)
        aErrors.push(YamlError.new("T4_001: " + ERR_NO_RUNNING_PROCESS_UNIT, aPath))
      end
      ### T4_002: pre_conditionǥ¸ߤʤ
      if (hExistFlags[:bTask] == false)
        aErrors.push(YamlError.new("T4_002: " + ERR_NO_TASK, aPath))
      end

      # ͥٵžΥå
      hPOrder.each{|nPrcid, hTasks|
        unless (hTasks[:cRunning].nil?())
          hTasks[:aOthers].each{|cObjectInfo|
            ### T4_003: pre_conditionCPUå֤λˡͥ٤ФƼ¹Ծ֤žƤ֤ˤʤäƤ
            if (!aCpuLock[nPrcid].nil?() && aCpuLock[nPrcid].is_cpu_lock?() &&
                !cObjectInfo.hState[TSR_PRM_TSKPRI].nil?() && cObjectInfo.is_ready?() &&
                hTasks[:cRunning].hState[TSR_PRM_TSKPRI] > cObjectInfo.hState[TSR_PRM_TSKPRI])
              sErr = sprintf("T4_003: " + ERR_INVERTED_STATE_IN_PRE, nPrcid)
              aErrors.push(YamlError.new(sErr, aPath))
              break
            end
            ### T4_004: pre_conditionporderžƤ֤ˤʤäƤ
            if (hTasks[:cRunning].hState[TSR_PRM_TSKPRI] == cObjectInfo.hState[TSR_PRM_TSKPRI] &&
                !hTasks[:cRunning].hState[TSR_PRM_PORDER].nil?() && !cObjectInfo.hState[TSR_PRM_PORDER].nil?() &&
                hTasks[:cRunning].hState[TSR_PRM_PORDER] > cObjectInfo.hState[TSR_PRM_PORDER])
              sErr = sprintf("T4_004: " + ERR_INVERTED_PORDER_IN_PRE, nPrcid)
              aErrors.push(YamlError.new(sErr, aPath))
              break
            end
          }
        end
      }


      # 㳰
      hObjects = get_objects_by_type(TSR_OBJ_TASK_EXC)
      hObjects.each{|sObjectID, cObjectInfo|
        # Ϣ
        sTask = cObjectInfo.hState[TSR_PRM_TASK]
        if (@hAllObject.has_key?(sTask))
          cTask = @hAllObject[sTask]
          if (cTask.sObjectType == TSR_OBJ_TASK)
            ### T4_034: 㳰롼εưƤΤACTIVATEǤʤ
            if (cTask.is_activate?() && cObjectInfo.hState[TSR_PRM_STATE] == TSR_STT_TTEX_ENA &&
                cObjectInfo.hState[TSR_PRM_HDLSTAT] == TSR_STT_STP && cObjectInfo.hState[TSR_PRM_PNDPTN] != 0)
              aErrors.push(YamlError.new("T4_034: " + ERR_NOT_ACTIVATE_TASK_EXC, aPath + [sObjectID]))
            end
          ### T4_022: ϢIDΥ֥ȤǤʤ
          else
            sErr = sprintf("T4_022: " + ERR_TARGET_NOT_TASK, sTask)
            aErrors.push(YamlError.new(sErr, aPath + [sObjectID, TSR_PRM_TASK]))
          end
        ### T4_021: ϢIDΥ֥Ȥ¸ߤʤ
        else
          sErr = sprintf("T4_021: " + ERR_TARGET_NOT_DEFINED, sTask)
          aErrors.push(YamlError.new(sErr, aPath + [sObjectID, TSR_PRM_TASK]))
        end
      }

      check_error(aErrors)
    end

    #=================================================================
    # : ͤ䴰
    #=================================================================
    def complement_init_object_info()
      @hAllObject.each_value{|cObjectInfo|
        cObjectInfo.complement_init_object_info()
      }
    end

    #=================================================================
    # : ֥ȡѿΥꥢѴơ֥֤
    #=================================================================
    def get_alias()
      hResult       = {}
      hSpinCount    = Hash.new(1)  # ԥå̾Τ᥯饹о򥫥
      aSortedObject = @hAllObject.sort()
      aSortedObject.each{|aObjectInfo|
        cObjectInfo = aObjectInfo[1]
        if (cObjectInfo.sObjectType == TSR_OBJ_SPINLOCK)
          sClass = cObjectInfo.hState[TSR_PRM_CLASS]
          hAlias = cObjectInfo.get_alias(@sTestID, hSpinCount[sClass])
          hSpinCount[sClass] += 1
        else
          hAlias = cObjectInfo.get_alias(@sTestID)
        end
        hResult = hResult.merge(hAlias)
      }

      return hResult  # [Hash]ꥢѴơ֥
    end

    #=================================================================
    #   : ֤
    #=================================================================
    def is_time_control_situation?(hVariation)
      check_class(Hash, hVariation)  # Хꥨ

      bResult = super(hVariation)

      if (bResult == false)
        hObjects = get_objects_by_type(GRP_TIME_EVENT_HDL)
        hObjects.each_value{|cObjectInfo|
          # pre_conditionACTIVATEʥ।٥ȥϥɥ餬¸ߤ
          if (cObjectInfo.is_activate?())
            bResult = true
            break
          # pre_conditionˤơcycstatTCYC_STAꤵƤϥɥ餬¸ߤ
          elsif (cObjectInfo.sObjectType == TSR_OBJ_CYCLE && cObjectInfo.is_cyc_sta?())
            bResult = true
            break
          end
        }
      end

      return bResult  # [Bool]
    end

    #=================================================================
    # : pre_conditionΥѥ֤
    #=================================================================
    def get_condition_path()
      return [@sTestID, TSR_LBL_PRE]  # [Array]pre_conditionΥѥ
    end

=begin
    #=================================================================
    # : ֹ
    #=================================================================
    def get_all_intno()
      aResult  = []
      hObjects = get_objects_by_type([TSR_OBJ_INTHDR, TSR_OBJ_ISR])
      hObjects.each_value{|cObjectInfo|
        aResult.push(cObjectInfo.hState[TSR_PRM_INTNO])
      }

      return aResult.uniq()  # [Array]ֹ
    end
=end
  end
end
