#!/bin/sh
#
#  TTSP
#      TOPPERS Test Suite Package
# 
#  Copyright (C) 2009-2012 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2009-2011 by Digital Craft Inc.
#  Copyright (C) 2009-2011 by NEC Communication Systems, Ltd.
#  Copyright (C) 2009-2012 by FUJISOFT INCORPORATED
# 
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
# 
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
# 
#  $Id: ttb.sh 2 2012-05-09 02:23:52Z nces-shigihara $
# 

# ȼ¹ԥå
chk=`dirname $0`
if [ $chk != "." ]
then
	echo "Need to execute at a directory of existing \"ttb.sh\""
	exit 1
fi

# ttspեХѥ
TTSP_DIR=`pwd`

# TTB¹Ԥɬפʥե
NECESSARY_DIR="\
api_test \
library \
scripts \
sil_test \
tools"

# TTB¹Ԥɬפʥե̵ͭå
for dir in ${NECESSARY_DIR[@]}
do
	if [ ! -d $dir ]
	then
		echo "$dir is necessary directory"
		exit 1
	fi
done

# եɹ
source ./scripts/common.sh
source ./configure.sh

# TTBåȰ¸եΥ󥯥롼
source ./library/$PROFILE_NAME/target/$TARGET_NAME/ttsp_target.sh

#
# ץե
#
if [ $PROFILE_NAME = "ASP" ]
then
	API_TEST_DIR="api_test/ASP"
	SIL_TEST_DIR="sil_test/ASP"
	KERNEL_COBJS_COMMON="startup.o task.o wait.o time_event.o task_manage.o task_refer.o task_sync.o task_except.o semaphore.o eventflag.o dataqueue.o pridataq.o mailbox.o mempfix.o time_manage.o cyclic.o alarm.o sys_manage.o interrupt.o exception.o"
elif [ $PROFILE_NAME = "FMP" ]
then
	API_TEST_DIR="api_test"
	SIL_TEST_DIR="sil_test/FMP"
	CONFIG_PRC="-P $PROCESSOR_NUM"
	KERNEL_COBJS_COMMON="startup.o task.o wait.o time_event.o task_manage.o task_refer.o task_sync.o task_except.o semaphore.o eventflag.o dataqueue.o pridataq.o mailbox.o mempfix.o time_manage.o cyclic.o alarm.o sys_manage.o interrupt.o exception.o spin_lock.o mp.o"
else
	echo "$ERR_PROFILE_INVALID ($PROFILE_NAME)"
	exit 1
fi

#
# INCLUDEоݤΥѥ
#
TTSP_DIR_NAME=${TTSP_DIR##*/}

TEST_LIB_FILE="ttsp_test_lib.o"
INCLUDE_DIR=`echo '\$(SRCDIR)/'$TTSP_DIR_NAME'/library/'$PROFILE_NAME'/test \$(SRCDIR)/'$TTSP_DIR_NAME'/library/'$PROFILE_NAME'/target/'$TARGET_NAME`
ARCH_DIR=`echo '\$(SRCDIR)/'$TTSP_DIR_NAME'/library/'$PROFILE_NAME'/arch'`
for dir in ${ARCH_PATH[@]}
do
	INCLUDE_DIR=`echo "$INCLUDE_DIR $ARCH_DIR/$dir"`
done


#
# configureץ
#
CONFIG_KERNEL_LIB=`echo "-T $TARGET_NAME -U $TEST_LIB_FILE $CONFIG_PRC $CONFIG_OPT -a "`
if [ $USE_KERNEL_LIB = true ]
then
	CONFIG_TEST_PROGRAM=`echo '-T '$TARGET_NAME' -A '$APPLI_NAME' -L \$(SRCDIR)/'$TTSP_DIR_NAME'/'$KERNEL_LIB' -U '$TEST_LIB_FILE $CONFIG_PRC $CONFIG_OPT' -a'`
elif [ $USE_KERNEL_LIB = false ]
then
	CONFIG_TEST_PROGRAM=`echo '-T '$TARGET_NAME' -A '$APPLI_NAME' -U '$TEST_LIB_FILE $CONFIG_PRC $CONFIG_OPT' -a'`
else
	echo "$ERR_USE_KER_LIB_INVALID ($USE_KERNEL_LIB)"
	exit 1
fi

# TTSPᥤ˥塼
ttsp_main_menu()
{
	go_main_flg=0
	go_api_test_flg=0

	check_makefile

	while true
	do
		cat<<EOS

$DOUBLE_LINE
 $MAIN_MENU
$DOUBLE_LINE
 1: $API_TEST_MENU
 2: $SIL_TEST_MENU
 c: $CHECK_LIBRARY_MENU
 k: $KERNEL_LIBRARY_MENU
 q: $EXIT_TOOL
$SINGLE_LINE
EOS
echo -n " $INPUT_NO "
		# ɤ߹
		read key
		echo ""
		# ɤ߹ˤäʬ
		case ${key} in
			1)
			 source ./scripts/api_test.sh
			 ;;
			2)
			 source ./scripts/sil_test.sh
			 ;;
			c)
			 source ./scripts/check_library.sh
			 ;;
			k)
			 source ./scripts/kernel_lib.sh
			 ;;
			q)
			 exit 0
			 ;;
			*)
			 echo " $key $ERR_INVALID_NO"
			 ;;
		esac
	done
	exit 0
}

# 
ttsp_main_menu
